# DiffEqBase.jl

[![Join the chat at https://gitter.im/JuliaDiffEq/Lobby](https://badges.gitter.im/JuliaDiffEq/Lobby.svg)](https://gitter.im/JuliaDiffEq/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Build Status](https://github.com/SciML/DiffEqBase.jl/workflows/Tests/badge.svg)](https://github.com/SciML/DiffEqBase.jl/actions?query=workflow%3ATests)
[![Build status](https://badge.buildkite.com/99cbd352c336779c3117e4da61255a1ed8e7e7c084c3c2516c.svg)](https://buildkite.com/julialang/diffeqbase-dot-jl)

DiffEqBase.jl is a component package in the DiffEq ecosystem. It holds the
common types and utility functions which are shared by other solver packages
to promote code reuse in the differential equation solver code.
Users interested in using this
functionality in full should check out [DifferentialEquations.jl](https://github.com/SciML/DifferentialEquations.jl).

The documentation for the interfaces here can be found in [DiffEqDocs.jl](https://docs.sciml.ai/DiffEqDocs/dev/) and [DiffEqDevDocs.jl](https://docs.sciml.ai/DiffEqDevDocs/dev/).

module DiffEqBaseGeneralizedGeneratedExt

using DiffEqBase
using GeneralizedGenerated

function SciMLBase.numargs(::GeneralizedGenerated.RuntimeFn{Args}) where {Args}
    return GeneralizedGenerated.from_type(Args) |> length
end

end

macro tight_loop_macros(ex)
    return :($(esc(ex)))
end

# TODO: would be good to have dtmin a function of dt
function prob2dtmin(prob; use_end_time = true)
    return prob2dtmin(prob.tspan, oneunit(eltype(prob.tspan)), use_end_time)
end

# This function requires `eps` to exist, which restricts below `<: Real`
# Example of a failure is Rational
function prob2dtmin(tspan, ::AbstractFloat, use_end_time)
    t1, t2 = tspan
    isfinite(t1) || throw(ArgumentError("t0 in the tspan `(t0, t1)` must be finite"))
    if use_end_time && isfinite(t2 - t1)
        return max(eps(t2), eps(t1))
    else
        return max(eps(typeof(t1)), eps(t1))
    end
end
prob2dtmin(tspan, ::Integer, ::Any) = 0
# Multiplication is for putting the right units on the constant!
prob2dtmin(tspan, onet, ::Any) = onet * 1 // Int64(2)^33 # roughly 10^10 but more likely to turn into a multiplication.

function timedepentdtmin(integrator::DEIntegrator)
    return timedepentdtmin(integrator.t, integrator.opts.dtmin)
end
timedepentdtmin(t::AbstractFloat, dtmin) = abs(max(eps(t), dtmin))
timedepentdtmin(::Any, dtmin) = abs(dtmin)

maybe_with_logger(f, logger) = logger === nothing ? f() : Logging.with_logger(f, logger)

function default_logger(logger)
    Logging.min_enabled_level(logger) ≤ ProgressLogging.ProgressLevel && return nothing

    if Sys.iswindows() || (isdefined(Main, :IJulia) && Main.IJulia.inited)
        progresslogger = ConsoleProgressMonitor.ProgressLogger()
    else
        progresslogger = TerminalLoggers.TerminalLogger()
    end

    logger1 = LoggingExtras.EarlyFilteredLogger(progresslogger) do log
        log.level == ProgressLogging.ProgressLevel
    end
    logger2 = LoggingExtras.EarlyFilteredLogger(logger) do log
        log.level != ProgressLogging.ProgressLevel
    end

    return LoggingExtras.TeeLogger(logger1, logger2)
end

# for the non-unitful case the correct type is just u
_rate_prototype(u, t::T, onet::T) where {T} = u

# Nonlinear Solve functionality
@inline __fast_scalar_indexing(args...) = all(ArrayInterface.fast_scalar_indexing, args)

@inline __maximum_abs(op::F, x, y) where {F} = __maximum(abs ∘ op, x, y)
## Nonallocating version of maximum(op.(x, y))
@inline function __maximum(op::F, x, y) where {F}
    if __fast_scalar_indexing(x, y)
        return maximum(
            @closure(
                (xᵢyᵢ) -> begin
                    xᵢ, yᵢ = xᵢyᵢ
                    return op(xᵢ, yᵢ)
                end
            ), zip(x, y)
        )
    else
        return mapreduce(@closure((xᵢ, yᵢ) -> op(xᵢ, yᵢ)), max, x, y)
    end
end

@inline function __norm_op(::typeof(Base.Fix2(norm, 2)), op::F, x, y) where {F}
    if __fast_scalar_indexing(x, y)
        return sqrt(
            sum(
                @closure(
                    (xᵢyᵢ) -> begin
                        xᵢ, yᵢ = xᵢyᵢ
                        return op(xᵢ, yᵢ)^2
                    end
                ), zip(x, y)
            )
        )
    else
        return sqrt(mapreduce(@closure((xᵢ, yᵢ) -> (op(xᵢ, yᵢ)^2)), +, x, y))
    end
end

@inline __norm_op(norm::N, op::F, x, y) where {N, F} = norm(op.(x, y))

function __nonlinearsolve_is_approx(
        x::Number, y::Number; atol = false,
        rtol = atol > 0 ? false : sqrt(eps(promote_type(typeof(x), typeof(y))))
    )
    return isapprox(x, y; atol, rtol)
end
function __nonlinearsolve_is_approx(
        x, y; atol = false,
        rtol = atol > 0 ? false : sqrt(eps(promote_type(eltype(x), eltype(y))))
    )
    length(x) != length(y) && return false
    d = __maximum_abs(-, x, y)
    return d ≤ max(atol, rtol * max(maximum(abs, x), maximum(abs, y)))
end

@inline function __add_and_norm(::Nothing, x, y)
    Base.depwarn(
        "Not specifying the internal norm of termination conditions has been \
                  deprecated. Using inf-norm currently.",
        :__add_and_norm
    )
    return __maximum_abs(+, x, y)
end
@inline __add_and_norm(::typeof(Base.Fix1(maximum, abs)), x, y) = __maximum_abs(+, x, y)
@inline __add_and_norm(::typeof(Base.Fix2(norm, Inf)), x, y) = __maximum_abs(+, x, y)
@inline __add_and_norm(f::F, x, y) where {F} = __norm_op(f, +, x, y)

using OrdinaryDiffEq, Test
my_f(u, p, t) = u
my_f!(du, u, p, t) = du .= u
ode = ODEProblem(my_f, [1.0], (0.0, 1.0))
integrator = init(ode, Tsit5())
@test SciMLBase.unwrapped_f(integrator.f.f) === my_f

ode = ODEProblem(my_f!, [1.0], (0.0, 1.0))
integrator = init(ode, Tsit5())
@test SciMLBase.unwrapped_f(integrator.f.f) === my_f!

using OrdinaryDiffEq, ForwardDiff, Measurements
x = 1.0 ± 0.0
f = (du, u, p, t) -> du .= u
tspan = (0.0, 1.0)
prob = ODEProblem(f, [x], tspan)

# Should not error during problem construction but should be unwrapped
integ = init(prob, Tsit5(), dt = 0.1)
@test SciMLBase.unwrapped_f(integ.f.f) === f

# Handle functional initial conditions
prob = ODEProblem((dx, x, p, t) -> (dx .= 0), (p, t) -> zeros(2), (0, 10))
solve(prob, TRBDF2())

using FlexUnits, FlexUnits.UnitRegistry, OrdinaryDiffEq, Test

f(du, u, p, t) = du .= 3 * u"1/s" * u
prob = ODEProblem(f, [2.0u"m"], (0.0u"s", 1.0u"s"))
intg = init(prob, Tsit5(), dt = 0.01u"s")
@test_nowarn step!(intg, 0.02u"s", true)

@test SciMLBase.unitfulvalue(1.0u"1/s") == 1.0u"1/s"
@test SciMLBase.value(1.0u"1/s") isa Real

using OrdinaryDiffEq, StaticArrays, Test
using SciMLSensitivity  # Required for reverse-mode AD
using DifferentiationInterface
using ADTypes: AutoForwardDiff, AutoMooncake

# Load backends for all versions (required for DifferentiationInterface extensions)
using ForwardDiff
using Mooncake

# Version-dependent imports
if VERSION <= v"1.11"
    using Zygote
    using ADTypes: AutoZygote
end
if VERSION <= v"1.11"
    using Enzyme
    using ADTypes: AutoEnzyme
end

# Define backends based on Julia version
# ForwardDiff: All versions
# Mooncake: All versions
# Zygote: Julia <= 1.11
# Enzyme: Julia <= 1.11
function get_test_backends()
    backends = Pair{String, Any}[]
    # ForwardDiff on all versions
    push!(backends, "ForwardDiff" => AutoForwardDiff())
    # Mooncake on all versions
    push!(backends, "Mooncake" => AutoMooncake(; config = nothing))
    # Zygote only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Zygote" => AutoZygote())
    end
    # Enzyme only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Enzyme" => AutoEnzyme())
    end
    return backends
end

f(u, p, t) = copy(u)

backends = get_test_backends()
# Note: Mooncake and Zygote are excluded due to issues with SciMLSensitivity adjoint rules
# Mooncake: issues with adjoint rules
# Zygote: MethodError length(::Nothing) in automatic_sensealg_choice when p=nothing
backends_for_staticarrays = filter(b -> b[1] ∉ ("Mooncake", "Zygote"), backends)

@testset "StaticArrays AD tests" begin
    for (name, backend) in backends_for_staticarrays
        @testset "StaticArrays derivative with $name" begin
            du1 = DifferentiationInterface.derivative(backend, 5.0) do x
                prob = ODEProblem(f, [x], (0.0, 1.0), nothing)
                sol = solve(prob, Tsit5())
                sol.u[end][1]
            end

            du2 = DifferentiationInterface.derivative(backend, 5.0) do x
                prob = ODEProblem(f, SVector(x), (0.0, 1.0), nothing)
                sol = solve(prob, Tsit5())
                sol.u[end][1]
            end

            @test du1 ≈ du2
        end
    end
end

module DiffEqBaseMeasurementsExt

using DiffEqBase
import DiffEqBase: value
using Measurements

# Support adaptive steps should be errorless
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{
            <:Measurements.Measurement,
            N,
        },
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:Measurements.Measurement, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::Measurements.Measurement, t)
    return abs(Measurements.value(u))
end

end

using StochasticDiffEq, DiffEqBase, OrdinaryDiffEq
using Test, Random

import SDEProblemLibrary: prob_sde_2Dlinear, prob_sde_additivesystem, prob_sde_lorenz
import ODEProblemLibrary: prob_ode_linear

prob = prob_sde_2Dlinear
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10)

@test sim.u[1] isa DiffEqBase.RODESolution
@test sim[1, 2] isa Matrix
@test sim[1, 2, 1] isa Float64

sim = solve(prob2, SRIW1(), EnsembleThreads(), dt = 1 // 2^(3), trajectories = 10)
err_sim = DiffEqBase.calculate_ensemble_errors(sim; weak_dense_errors = true)
@test length(sim) == 10

sim = solve(
    prob2, SRIW1(), EnsembleThreads(), dt = 1 // 2^(3), trajectories = 10,
    batch_size = 2
)
err_sim = DiffEqBase.calculate_ensemble_errors(sim; weak_dense_errors = true)
@test length(sim) == 10

sim = solve(
    prob2, SRIW1(), EnsembleThreads(), dt = 1 // 2^(3), adaptive = false,
    trajectories = 10
)
err_sim = DiffEqBase.calculate_ensemble_errors(sim; weak_timeseries_errors = true)

sim = solve(prob2, SRIW1(), EnsembleThreads(), dt = 1 // 2^(3), trajectories = 10)
DiffEqBase.calculate_ensemble_errors(sim)
@test length(sim) == 10

sim = solve(prob2, SRIW1(), EnsembleSplitThreads(), dt = 1 // 2^(3), trajectories = 10)
DiffEqBase.calculate_ensemble_errors(sim)
@test length(sim) == 10

sim = solve(prob2, SRIW1(), EnsembleSerial(), dt = 1 // 2^(3), trajectories = 10)
DiffEqBase.calculate_ensemble_errors(sim)
@test length(sim) == 10

prob = prob_sde_additivesystem
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRA1(), dt = 1 // 2^(3), trajectories = 10)
DiffEqBase.calculate_ensemble_errors(sim)

output_func = function (sol, i)
    return last(last(sol))^2, false
end
prob2 = EnsembleProblem(prob, output_func = output_func)
sim = solve(prob2, SRA1(), dt = 1 // 2^(3), trajectories = 10)

prob = prob_sde_lorenz
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10)

output_func = function (sol, i)
    return last(sol), false
end

prob = prob_ode_linear
prob_func = function (prob, i, repeat)
    return ODEProblem(prob.f, rand() * prob.u0, prob.tspan, 1.01)
end

Random.seed!(100)
reduction = function (u, batch, I)
    u = append!(u, batch)
    μ = sum(u) / length(u)
    σ² = sum((x - μ)^2 for x in u) / length(u)
    return u, ((σ² / sqrt(last(I))) / μ < 0.5) ? true : false
end

prob2 = EnsembleProblem(
    prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction, u_init = Vector{Float64}(),
    safetycopy = false
)
sim = solve(prob2, Tsit5(), trajectories = 10000, batch_size = 20)
@test sim.converged == true

prob_func = function (prob, i, repeat)
    return ODEProblem(prob.f, (1 + i / 100) * prob.u0, prob.tspan, 1.01)
end

reduction = function (u, batch, I)
    u = append!(u, batch)
    return u, false
end

prob2 = EnsembleProblem(
    prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction, u_init = Vector{Float64}()
)
sim = solve(prob2, Tsit5(), trajectories = 100, batch_size = 20)
@test sim.converged == false

reduction = function (u, batch, I)
    return u + sum(batch), false
end
prob2 = EnsembleProblem(
    prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction, u_init = 0.0
)
sim2 = solve(prob2, Tsit5(), trajectories = 100, batch_size = 20)
@test sim2.converged == false
@test sum(sim.u) / length(sim.u) ≈ sim2.u / 100

struct SomeUserType end
output_func = function (sol, i)
    return (SomeUserType(), false)
end
prob2 = EnsembleProblem(prob, prob_func = prob_func, output_func = output_func)
sim2 = solve(prob2, Tsit5(), trajectories = 2)
@test sim2.converged && typeof(sim2.u) == Vector{SomeUserType}

using DiffEqBase, ForwardDiff, Test, InteractiveUtils
using ReverseDiff, SciMLStructures

u0 = 2.0
p = 2.0
t0 = 1.0

@test DiffEqBase.promote_u0(u0, p, t0) isa Float64
@test DiffEqBase.promote_u0(u0, p, t0) == 2.0
@test DiffEqBase.promote_u0(cis(u0), p, t0) isa ComplexF64
@test DiffEqBase.promote_u0(cis(u0), p, t0) == cis(2.0)

struct MyStruct{T, T2} <: Number
    x::T
    y::T2
end

struct MyStruct2{T, T2}
    x::T
    y::T2
    MyStruct2(x) = new{typeof(x), Any}(x)
end

struct MyStruct3{T, T2}
    x::T
    y::T2
    MyStruct3(x) = new{typeof(x), Float64}(x)
end

module Mod end

p_possibilities = [
    ForwardDiff.Dual(2.0), (ForwardDiff.Dual(2.0), 2.0),
    [ForwardDiff.Dual(2.0)], ([ForwardDiff.Dual(2.0)], 2.0),
    (2.0, ForwardDiff.Dual(2.0)), (; x = 2.0, y = ForwardDiff.Dual(2.0)),
    (; x = 2.0, y = [ForwardDiff.Dual(2.0)]), (; x = 2.0, y = [[ForwardDiff.Dual(2.0)]]),
    Set([2.0, ForwardDiff.Dual(2.0)]), (SciMLBase.NullParameters(), ForwardDiff.Dual(2.0)),
    ((), ForwardDiff.Dual(2.0)), ForwardDiff.Dual{Nothing}(ForwardDiff.Dual{MyStruct}(2.0)),
    (ForwardDiff.Dual(2.0)), [(1.0, ForwardDiff.Dual(1.0, (1.0,)))],
]

for p in p_possibilities
    @show p
    @test DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual
    local u0 = 2.0
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    @inferred DiffEqBase.anyeltypedual(p)
end

higher_order_p_possibilities = [
    ForwardDiff.Dual{Nothing}(ForwardDiff.Dual{MyStruct}(2.0)),
    (
        ForwardDiff.Dual{Nothing}(ForwardDiff.Dual{MyStruct}(2.0)),
        SciMLBase.NullParameters(),
    ),
    (
        ForwardDiff.Dual{Nothing}(ForwardDiff.Dual{MyStruct}(2.0)),
        ForwardDiff.Dual{Nothing}(2.0),
    ),
    (
        ForwardDiff.Dual{Nothing}(2.0),
        ForwardDiff.Dual{Nothing}(ForwardDiff.Dual{MyStruct}(2.0)),
    ),
]

for p in higher_order_p_possibilities
    @show p
    @test DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual
    @test DiffEqBase.anyeltypedual(p) <:
    ForwardDiff.Dual{Nothing, ForwardDiff.Dual{MyStruct, Float64, 0}, 0}
    local u0 = 2.0
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    @inferred DiffEqBase.anyeltypedual(p)
end

p_possibilities17 = [
    MyStruct(2.0, ForwardDiff.Dual(2.0)), [MyStruct(2.0, ForwardDiff.Dual(2.0))],
    [MyStruct(2.0, [2.0, ForwardDiff.Dual(2.0)])],
    [MyStruct(2.0, (2.0, ForwardDiff.Dual(2.0)))],
    ((;), ForwardDiff.Dual(2.0)), MyStruct3(ForwardDiff.Dual(2.0)),
    (Mod, ForwardDiff.Dual(2.0)), (() -> 2.0, ForwardDiff.Dual(2.0)),
    (Base.pointer([2.0]), ForwardDiff.Dual(2.0)),
]
push!(p_possibilities17, Returns((a = 2, b = 1.3, c = ForwardDiff.Dual(2.0f0))))

for p in p_possibilities17
    @show p
    @test DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual
    local u0 = 2.0
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}

    @inferred DiffEqBase.anyeltypedual(p)
    ci = InteractiveUtils.@code_typed DiffEqBase.anyeltypedual(p)
    @show filter(!=(Expr(:code_coverage_effect)), ci.first.code)
    #@test count(x -> (x != (Expr(:code_coverage_effect))) &&
    #                (x != GlobalRef(DiffEqBase, :Any)), ci.first.code) == 1
end

p_possibilities_uninferrred = [
    Dict(:x => 2.0, :y => ForwardDiff.Dual(2.0)),
    Dict(:x => 2.0, :y => [ForwardDiff.Dual(2.0)]),
    Dict(:x => 2.0, :y => [(; x = (ForwardDiff.Dual(2.0), 2.0), y = 2.0)]),
    Dict(:x => 2.0, :y => [(; x = [MyStruct(2.0, [2.0, ForwardDiff.Dual(2.0)])], y = 2.0)]),
    [MyStruct("2", [2.0, ForwardDiff.Dual(2.0)])],
    Dict(
        :x => [MyStruct("2", [2.0, MyStruct(ForwardDiff.Dual(2.0), 2.0)])],
        :y => ForwardDiff.Dual{MyStruct}(2.0)
    ),
    ((Dict(:x => nothing)), ForwardDiff.Dual(2.0)),
    MyStruct2(ForwardDiff.Dual(2.0)),
    [MyStruct2(ForwardDiff.Dual(2.0)), 2.0],

    # Vectors of non-number types won't infer
    [MyStruct(2.0, ForwardDiff.Dual(2.0))],
    (; x = 2.0, y = [[MyStruct3(ForwardDiff.Dual(2.0))]]),
    (; x = Vector{Float64}(undef, 2), y = [[MyStruct3(ForwardDiff.Dual(2.0))]]),
    (; x = Matrix{Any}(undef, 2, 2), y = [[MyStruct3(ForwardDiff.Dual(2.0))]]),
]

for p in p_possibilities_uninferrred
    @show p
    @test DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual
    local u0 = 2.0
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
end

p_possibilities_missed = [
    Set([2.0, "s", ForwardDiff.Dual(2.0)]),
    Set([2.0, ForwardDiff.Dual(2.0), SciMLBase.NullParameters()]),
    Set([Matrix{Float64}(undef, 2, 2), ForwardDiff.Dual(2.0)]),
]

for p in p_possibilities_missed
    @show p
    @test_broken DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual
    local u0 = 2.0
    @test_broken DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test_broken DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
end

p_possibilities_notdual = [
    (), (;), [2.0], [2.0, 2], [2.0, (2.0)], [2.0, MyStruct(2.0, 2.0f0)], pairs((;)),
]

for p in p_possibilities_notdual
    @show p
    @test !(DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual)
    local u0 = 2.0
    @test !(DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual)
    @test !(
        DiffEqBase.promote_u0([cis(u0)], p, t0) isa
            AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    )
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    @inferred DiffEqBase.anyeltypedual(p)
end

p_possibilities_notdual_uninferred = [
    [],

    # Undefs cause inference loss
    [2.0, MyStruct3(2.0)], [2.0, MyStruct2(2.0)], [2.0, MyStruct2(2.0), []],
    [Dict(:x => 2, "y" => 5), MyStruct2(2.0)],

    # Dictionaries can have inference issues
    Dict(:x => 2, :y => 5), Dict(:x => 2, "y" => 5),
]

# Also check circular references
# https://github.com/SciML/DiffEqBase.jl/issues/784

x = Any[[1.0, 2.0]]
push!(x, x)
push!(p_possibilities_notdual_uninferred, x)

struct X
    x::Any
end
x = Any[[1.0, 2.0]]
push!(x, X(x))
push!(p_possibilities_notdual_uninferred, x)

mutable struct Y
    x::Any
end
x = Y(1)
x.x = x
push!(p_possibilities_notdual_uninferred, x)

for p in p_possibilities_notdual_uninferred
    @test !(DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual)
    local u0 = 2.0
    @test !(DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual)
    @test !(
        DiffEqBase.promote_u0([cis(u0)], p, t0) isa
            AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    )
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
end

f(du, u, p, t) = du .= u
config = ForwardDiff.JacobianConfig(f, ones(5))

p_possibilities_configs = [
    (config, config), (config, 2.0), config, (; x = config, y = 2.0),
]

for p in p_possibilities_configs
    @show p
    @test !(DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual)
    local u0 = 2.0
    @test !(DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual)
    @test !(
        DiffEqBase.promote_u0([cis(u0)], p, t0) isa
            AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    )
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    @inferred DiffEqBase.anyeltypedual(p)
end

p_possibilities_configs_not_inferred = [
    [2.0, (2.0,), config], [2.0, config, MyStruct(2.0, 2.0f0)],
]

for p in p_possibilities_configs_not_inferred
    @show p
    @test !(DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual)
    local u0 = 2.0
    @test !(DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual)
    @test !(
        DiffEqBase.promote_u0([cis(u0)], p, t0) isa
            AbstractArray{<:Complex{<:ForwardDiff.Dual}}
    )
    u0 = ForwardDiff.Dual(2.0)
    @test DiffEqBase.promote_u0(u0, p, t0) isa ForwardDiff.Dual
    @test DiffEqBase.promote_u0([cis(u0)], p, t0) isa
        AbstractArray{<:Complex{<:ForwardDiff.Dual}}
end

# use `getfield` on `Pairs`, see https://github.com/JuliaLang/julia/pull/39448
@test_nowarn DiffEqBase.DualEltypeChecker(pairs((;)), 0)(Val(:data))

# https://discourse.julialang.org/t/type-instability-with-differentialequations-jl-when-using-nested-structs/109764/5
struct Fit
    m₁::Float64
    c₁::Float64
    m₂::Float64
    c₂::Float64

    function Fit()
        m₁ = 1.595
        c₁ = 3.438
        m₂ = 1.075
        c₂ = 3.484

        return new(m₁, c₁, m₂, c₂)
    end
end

struct EOS
    fit::Fit

    function EOS()
        fit = Fit()
        return new(fit)
    end
end

p = EOS()
@test !(DiffEqBase.anyeltypedual(p) <: ForwardDiff.Dual)
@inferred DiffEqBase.anyeltypedual(p)

# Check methods used for prevention of Dual-detection when using
# DiffResults.DiffResult in a wrapper.
# https://github.com/SciML/DiffEqBase.jl/issues/1009

struct OutsideWrapper{T}
    a::Float64
    b::T
end

struct InsideWrapper{T, S}
    du::T
    dual_du::S
end

f(x) = 2 * x[1] + 3 * x[2]^2
xdual = ones(
    ForwardDiff.Dual{ForwardDiff.Tag{DiffEqBase.OrdinaryDiffEqTag, Float64}, Float64, 1}, 2
)
x = [1.0, 1.0]
diffresult = ForwardDiff.DiffResults.GradientResult(x)
diffresult_dual = ForwardDiff.DiffResults.GradientResult(xdual)
iw = InsideWrapper(diffresult, diffresult_dual)
ow = OutsideWrapper(1.0, iw)

@test !(DiffEqBase.anyeltypedual(iw) <: ForwardDiff.Dual)
@test !(DiffEqBase.anyeltypedual(ow) <: ForwardDiff.Dual)
@inferred DiffEqBase.anyeltypedual(iw)
@inferred DiffEqBase.anyeltypedual(ow)

# Issue https://github.com/SciML/ModelingToolkit.jl/issues/2717
u0 = [1.0, 2.0, 3.0]
p = [1, 2]
t = ForwardDiff.Dual{ForwardDiff.Tag{DiffEqBase.OrdinaryDiffEqTag, Float64}, Float64, 1}(1.0)
@test DiffEqBase.promote_u0(u0, p, t) isa AbstractArray{<:ForwardDiff.Dual}
u0 = [1.0 + 1im, 2.0, 3.0]
@test DiffEqBase.promote_u0(u0, p, t) isa AbstractArray{<:Complex{<:ForwardDiff.Dual}}

# Issue https://github.com/SciML/NonlinearSolve.jl/issues/440
f_nlsolve(u, p, t) = [u[2], 1.5u[1]^2]
ode = ODEProblem(f_nlsolve, [0.0, 0.0], (0, 1))
@inferred DiffEqBase.anyeltypedual(ode)
ode = NonlinearProblem(f_nlsolve, [0.0, 0.0], (0, 1))
@inferred DiffEqBase.anyeltypedual(ode)

# Issue https://github.com/SciML/DiffEqBase.jl/issues/1021
f_1021(u, p, t) = 1.01 * u
struct Foo{T}
    sol::T
end
u0 = 1 / 2
tspan = (0.0, 1.0)
prob = ODEProblem{false}(f_1021, u0, tspan)
foo = SciMLBase.build_solution(
    prob, DiffEqBase.InternalEuler.FwdEulerAlg(), [u0, u0], [0.0, 1.0]
)
DiffEqBase.anyeltypedual((; x = foo))
DiffEqBase.anyeltypedual((; x = foo, y = prob.f))

@test DiffEqBase.anyeltypedual(ReverseDiff.track(ones(3))) == Any
@test DiffEqBase.anyeltypedual(typeof(ReverseDiff.track(ones(3)))) == Any
@test DiffEqBase.anyeltypedual(ReverseDiff.track(ones(ForwardDiff.Dual, 3))) ==
    eltype(ones(ForwardDiff.Dual, 3))
@test DiffEqBase.anyeltypedual(typeof(ReverseDiff.track(ones(ForwardDiff.Dual, 3)))) ==
    eltype(ones(ForwardDiff.Dual, 3))

struct FakeParameterObject{T}
    tunables::T
end

SciMLStructures.isscimlstructure(::FakeParameterObject) = true
function SciMLStructures.canonicalize(::SciMLStructures.Tunable, f::FakeParameterObject)
    return f.tunables, x -> FakeParameterObject(x), true
end

@test DiffEqBase.promote_u0(
    ones(3), FakeParameterObject(ReverseDiff.track(ones(3))), 0.0
) isa
    ReverseDiff.TrackedArray
@test DiffEqBase.promote_u0(1.0, FakeParameterObject(ReverseDiff.track(ones(3))), 0.0) isa
    ReverseDiff.TrackedReal
@test DiffEqBase.promote_u0(
    ones(3), FakeParameterObject(ReverseDiff.track(ones(ForwardDiff.Dual, 3))), 0.0
) isa
    ReverseDiff.TrackedArray{<:ForwardDiff.Dual}
@test DiffEqBase.promote_u0(
    1.0, FakeParameterObject(ReverseDiff.track(ones(ForwardDiff.Dual, 3))), 0.0
) isa
    ReverseDiff.TrackedReal{<:ForwardDiff.Dual}
@test DiffEqBase.promote_u0(NaN, [NaN], 0.0) isa Float64
@test DiffEqBase.promote_u0([1.0], [NaN], 0.0) isa Vector{Float64}

# totallength
val = rand(10)
par = rand(10)
u = ForwardDiff.Dual.(val, par)
@test DiffEqBase.totallength(val[1]) == 1
@test DiffEqBase.totallength(val) == length(val)
@test DiffEqBase.totallength(par) == length(par)
@test DiffEqBase.totallength(u[1]) ==
    DiffEqBase.totallength(val[1]) + DiffEqBase.totallength(par[1])
@test DiffEqBase.totallength(u) == sum(DiffEqBase.totallength, u)

module DiffEqBaseChainRulesCoreExt

using DiffEqBase
import DiffEqBase: numargs, AbstractSensitivityAlgorithm, AbstractDEProblem

import ChainRulesCore
import ChainRulesCore: NoTangent

function ChainRulesCore.frule(
        ::typeof(DiffEqBase.solve_up), prob,
        sensealg::Union{Nothing, AbstractSensitivityAlgorithm},
        u0, p, args...; originator = SciMLBase.ChainRulesOriginator(),
        kwargs...
    )
    return DiffEqBase._solve_forward(
        prob, sensealg, u0, p,
        originator, args...;
        kwargs...
    )
end

function ChainRulesCore.rrule(
        ::typeof(DiffEqBase.solve_up), prob::AbstractDEProblem,
        sensealg::Union{Nothing, AbstractSensitivityAlgorithm},
        u0, p, args...; originator = SciMLBase.ChainRulesOriginator(),
        kwargs...
    )
    return DiffEqBase._solve_adjoint(
        prob, sensealg, u0, p,
        originator, args...;
        kwargs...
    )
end

end

using Test
using ForwardDiff: Dual, gradient, partials

using DiffEqBase: ODE_DEFAULT_NORM
const internalnorm = ODE_DEFAULT_NORM

val = rand(10)
par = rand(10)
u = Dual.(val, par)
reference(val, par) = sqrt((sum(abs2, val) + sum(abs2, par)) / (length(val) + length(par)))
dual_real = internalnorm(u, 1)
dual_dual = internalnorm(u, u[1])
@test reference(val, par) ≈ dual_real
@test reference(val, par) ≈ dual_dual
@test partials(dual_dual, 1) ≈ gradient(x -> internalnorm(x, x[1]), val)'par

using OrdinaryDiffEq, DataFrames, Test, SymbolicIndexingInterface
f_2dlinear = (du, u, p, t) -> du .= 1.01u;
prob = ODEProblem(f_2dlinear, rand(2, 2), (0.0, 1.0));
sol1 = solve(prob, Euler(); dt = 1 // 2^(4));
df = DataFrame(sol1)
@test names(df) == ["timestamp", "value1", "value2", "value3", "value4"]

prob = ODEProblem(
    ODEFunction(
        f_2dlinear, sys = SymbolicIndexingInterface.SymbolCache([:a, :b, :c, :d], [], :t)
    ),
    rand(2, 2),
    (0.0, 1.0)
);
sol2 = solve(prob, Euler(); dt = 1 // 2^(4));
df = DataFrame(sol2)
@test names(df) == ["timestamp", "a", "b", "c", "d"]

# Precompilation workload for DiffEqBase
# This precompiles commonly used code paths to reduce TTFX

PrecompileTools.@setup_workload begin
    # Minimal setup for precompilation
    u0 = [1.0, 0.0, 0.0]
    u1 = [1.1, 0.1, 0.1]
    t = 0.0
    dt = 0.1
    α = 1.0e-6
    ρ = 1.0e-3

    PrecompileTools.@compile_workload begin
        # Precompile ODE_DEFAULT_NORM for Vector{Float64} (most common case)
        ODE_DEFAULT_NORM(u0, t)

        # Precompile NAN_CHECK for Vector{Float64}
        NAN_CHECK(u0)

        # Precompile INFINITE_OR_GIANT for Vector{Float64}
        INFINITE_OR_GIANT(u0)

        # Precompile ODE_DEFAULT_UNSTABLE_CHECK for Vector{Float64}
        # Using nothing for p since that's very common
        ODE_DEFAULT_UNSTABLE_CHECK(dt, u0, nothing, t)

        # Precompile ODE_DEFAULT_ISOUTOFDOMAIN
        ODE_DEFAULT_ISOUTOFDOMAIN(u0, nothing, t)

        # Precompile ODE_DEFAULT_PROG_MESSAGE
        ODE_DEFAULT_PROG_MESSAGE(dt, u0, nothing, t)

        # Precompile recursive_length for Vector{Float64}
        recursive_length(u0)

        # Precompile UNITLESS_ABS2 for Vector{Float64}
        UNITLESS_ABS2(u0)

        # Precompile calculate_residuals for Vector{Float64} (most common case)
        calculate_residuals(u0, u1, α, ρ, ODE_DEFAULT_NORM, t)

        # Precompile in-place version
        out = similar(u0)
        calculate_residuals!(out, u0, u1, α, ρ, ODE_DEFAULT_NORM, t)

        # Precompile with explicit differences
        ũ = u1 .- u0
        calculate_residuals(ũ, u0, u1, α, ρ, ODE_DEFAULT_NORM, t)
        calculate_residuals!(out, ũ, u0, u1, α, ρ, ODE_DEFAULT_NORM, t)

        # Precompile scalar versions (commonly used)
        ODE_DEFAULT_NORM(1.0, t)
        NAN_CHECK(1.0)
        INFINITE_OR_GIANT(1.0)
        ODE_DEFAULT_UNSTABLE_CHECK(dt, 1.0, nothing, t)
    end
end

using OrdinaryDiffEq
# https://github.com/SciML/DiffEqBase.jl/issues/1231
@testset "Successive different callbacks in same integration step" begin
    cb = ContinuousCallback(
        (u, t, integrator) -> t - 0.0,
        (integrator) -> push!(record, 0);
        abstol = 0.0
    )

    vcb = VectorContinuousCallback(
        (out, u, t, integrator) -> out .= (t - 1.0e-8, t - 2.0e-8, t - 2.0e-7),
        (integrator, event_index) -> push!(record, event_index),
        3;
        abstol = 0.0
    )

    f(u, p, t) = 1.0
    u0 = 0.0

    # Forward propagation with successive events
    record = []
    tspan = (-1.0, 1.0)
    prob = ODEProblem(f, u0, tspan)
    sol = solve(prob, Tsit5(), dt = 2.0, callback = CallbackSet(cb, vcb))
    @test record == [0, 1, 2, 3]

    # Backward propagation with successive events
    record = []
    tspan = (1.0, -1.0)
    prob = ODEProblem(f, u0, tspan)
    sol = solve(prob, Tsit5(), dt = 2.0, callback = CallbackSet(cb, vcb))
    @test record == [3, 2, 1, 0]

    # https://github.com/SciML/DiffEqBase.jl/issues/1268
    # Test that callback order does not affect event detection
    function rhs!(du, u, p, t)
        du[1] = -3sin(3t)
        du[2] = -sin(t)
    end
    affect1 = (integ,) -> push!(record, 1)
    affect2 = (integ,) -> push!(record, 2)
    cb1 = ContinuousCallback((u, i, integ) -> u[2], affect1, affect1; rootfind = SciMLBase.LeftRootFind, abstol = 0.0)
    cb2 = ContinuousCallback((u, i, integ) -> u[1], affect2, affect2; rootfind = SciMLBase.RightRootFind, abstol = 0.0)

    record = []
    prob = ODEProblem(rhs!, ones(2), (0.0, 2π); callback = CallbackSet(cb2, cb1))
    sol = solve(prob, Tsit5())
    @test record == [2, 2, 1, 2, 2, 1, 2, 2]

    record = []
    prob = ODEProblem(rhs!, ones(2), (0.0, 2π); callback = CallbackSet(cb1, cb2))
    sol = solve(prob, Tsit5())
    @test record == [2, 2, 1, 2, 2, 1, 2, 2]
end

@testset "Successive same event detection" begin
    @testset for affect_integrator in [false, true]
        @testset for tdir in [1, -1]
            poly(t) = (t - 0.1) * (t - 0.4) * (t - 0.8)
            function affect!(integrator, index = 1)
                push!(record, tdir * integrator.t)
                if affect_integrator
                    # nudge t backward to see if integrator avoids repeat detection
                    integrator.t = integrator.t - tdir * 1.0e-14
                end
            end
            abstol = affect_integrator ? 1.0e-14 : 0.0

            f(u, p, t) = 1.0
            u0 = 0.0
            tspan = tdir .* (0.0, 1.0)
            prob = ODEProblem(f, u0, tspan; dt = 0.25, maxiters = 100)

            # Linear roots (can step on exact root)

            cb = ContinuousCallback(
                (u, t, integrator) -> poly(tdir * t),
                affect!; abstol = abstol
            )

            record = []
            sol = solve(prob, Tsit5(), callback = cb)
            @test record == [0.1, 0.4, 0.8]

            vcb = VectorContinuousCallback(
                (out, u, t, integrator) -> out .= (poly(tdir * t), poly(tdir * t - 0.1)),
                affect!, 2; abstol = abstol
            )

            record = []
            sol = solve(prob, Tsit5(), callback = vcb)
            @test record == [0.1, 0.2, 0.4, 0.5, 0.8, 0.9]

            # Quadratic roots (cannot step on exact root)

            cb = ContinuousCallback(
                (u, t, integrator) -> poly(t^2),
                affect!; abstol = abstol
            )

            record = []
            sol = solve(prob, Tsit5(), callback = cb)
            @test record ≈ sqrt.([0.1, 0.4, 0.8])

            vcb = VectorContinuousCallback(
                (out, u, t, integrator) -> out .= (poly(t^2), poly(t^2 - 0.1)),
                affect!, 2; abstol = abstol
            )

            record = []
            sol = solve(prob, Tsit5(), callback = vcb)
            @test record ≈ sqrt.([0.1, 0.2, 0.4, 0.5, 0.8, 0.9])
        end
    end
end

module DiffEqBaseCUDAExt

using DiffEqBase, CUDA

function DiffEqBase.ODE_DEFAULT_NORM(
        u::CuArray{T}, t
    ) where {T <: Union{AbstractFloat, Complex}}
    return sqrt(sum(DiffEqBase.sse, u; init = DiffEqBase.sse(zero(T))) / DiffEqBase.totallength(u))
end

end

module DiffEqBaseForwardDiffExt

using DiffEqBase, ForwardDiff
using DiffEqBase.ArrayInterface
using DiffEqBase: Void, FunctionWrappersWrappers, OrdinaryDiffEqTag,
    AbstractTimeseriesSolution,
    RecursiveArrayTools, reduce_tup, _promote_tspan, has_continuous_callback
import DiffEqBase: hasdualpromote, wrapfun_oop, wrapfun_iip, prob2dtmin,
    promote_tspan, ODE_DEFAULT_NORM
import SciMLBase: isdualtype, DualEltypeChecker, sse, __sum

const dualT = ForwardDiff.Dual{ForwardDiff.Tag{OrdinaryDiffEqTag, Float64}, Float64, 1}
dualgen(::Type{T}) where {T} = ForwardDiff.Dual{ForwardDiff.Tag{OrdinaryDiffEqTag, T}, T, 1}
dualgen(::Type{T}, ::Val{CS}) where {T, CS} = ForwardDiff.Dual{ForwardDiff.Tag{OrdinaryDiffEqTag, T}, T, CS}

const NORECOMPILE_IIP_SUPPORTED_ARGS = (
    Tuple{
        Vector{Float64}, Vector{Float64},
        Vector{Float64}, Float64,
    },
    Tuple{
        Vector{Float64}, Vector{Float64},
        SciMLBase.NullParameters, Float64,
    },
)

const oop_arglists = (
    Tuple{Vector{Float64}, Vector{Float64}, Float64},
    Tuple{Vector{Float64}, SciMLBase.NullParameters, Float64},
    Tuple{Vector{Float64}, Vector{Float64}, dualT},
    Tuple{Vector{dualT}, Vector{Float64}, Float64},
    Tuple{Vector{dualT}, SciMLBase.NullParameters, Float64},
    Tuple{Vector{Float64}, SciMLBase.NullParameters, dualT},
)

const NORECOMPILE_OOP_SUPPORTED_ARGS = (
    Tuple{
        Vector{Float64},
        Vector{Float64}, Float64,
    },
    Tuple{
        Vector{Float64},
        SciMLBase.NullParameters, Float64,
    },
)
const oop_returnlists = (
    Vector{Float64}, Vector{Float64},
    ntuple(x -> Vector{dualT}, length(oop_arglists) - 2)...,
)

function wrapfun_oop(ff, inputs::Tuple = ())
    if !isempty(inputs)
        IT = Tuple{map(typeof, inputs)...}
        if IT ∉ NORECOMPILE_OOP_SUPPORTED_ARGS
            throw(NoRecompileArgumentError(IT))
        end
    end
    return FunctionWrappersWrappers.FunctionWrappersWrapper(
        ff, oop_arglists,
        oop_returnlists
    )
end

function wrapfun_iip(
        ff,
        inputs::Tuple{T1, T2, T3, T4}
    ) where {T1, T2, T3, T4}
    T = eltype(T2)
    dualT = dualgen(T)
    dualT1 = ArrayInterface.promote_eltype(T1, dualT)
    dualT2 = ArrayInterface.promote_eltype(T2, dualT)
    dualT4 = dualgen(promote_type(T, T4))

    iip_arglists = (
        Tuple{T1, T2, T3, T4},
        Tuple{dualT1, dualT2, T3, T4},
        Tuple{dualT1, T2, T3, dualT4},
        Tuple{dualT1, dualT2, T3, dualT4},
    )

    iip_returnlists = ntuple(x -> Nothing, 4)

    fwt = map(iip_arglists, iip_returnlists) do A, R
        FunctionWrappersWrappers.FunctionWrappers.FunctionWrapper{R, A}(Void(ff))
    end
    return FunctionWrappersWrappers.FunctionWrappersWrapper{typeof(fwt), false}(fwt)
end

# 3-arg version: compile FunctionWrapper variants with the specified chunk size.
# Uses chunk=CS for u-related duals (Jacobian computation) and chunk=1 for
# t-related duals (time derivative is always scalar, so chunk=1).
function wrapfun_iip(
        ff,
        inputs::Tuple{T1, T2, T3, T4},
        ::Val{CS}
    ) where {T1, T2, T3, T4, CS}
    T = eltype(T2)

    # Jacobian (u-derivative) uses chunk=CS
    dualT_jac = dualgen(T, Val(CS))
    dualT1_jac = ArrayInterface.promote_eltype(T1, dualT_jac)
    dualT2_jac = ArrayInterface.promote_eltype(T2, dualT_jac)

    # Time derivative uses chunk=1 (scalar differentiation w.r.t. t)
    dualT_time = dualgen(T)
    dualT1_time = ArrayInterface.promote_eltype(T1, dualT_time)
    dualT4_time = dualgen(promote_type(T, T4))

    iip_arglists = (
        Tuple{T1, T2, T3, T4},                                  # plain
        Tuple{dualT1_jac, dualT2_jac, T3, T4},                  # Jacobian (u dual, chunk=CS)
        Tuple{dualT1_time, T2, T3, dualT4_time},                # time derivative (chunk=1)
        Tuple{dualT1_jac, dualT2_jac, T3, dualT4_time},         # both
    )

    iip_returnlists = ntuple(x -> Nothing, 4)

    fwt = map(iip_arglists, iip_returnlists) do A, R
        FunctionWrappersWrappers.FunctionWrappers.FunctionWrapper{R, A}(Void(ff))
    end
    return FunctionWrappersWrappers.FunctionWrappersWrapper{typeof(fwt), false}(fwt)
end

const iip_arglists_default = (
    Tuple{
        Vector{Float64}, Vector{Float64}, Vector{Float64},
        Float64,
    },
    Tuple{
        Vector{Float64}, Vector{Float64},
        SciMLBase.NullParameters,
        Float64,
    },
    Tuple{Vector{dualT}, Vector{Float64}, Vector{Float64}, dualT},
    Tuple{Vector{dualT}, Vector{dualT}, Vector{Float64}, dualT},
    Tuple{Vector{dualT}, Vector{dualT}, Vector{Float64}, Float64},
    Tuple{
        Vector{dualT}, Vector{dualT}, SciMLBase.NullParameters,
        Float64,
    },
    Tuple{
        Vector{dualT}, Vector{Float64},
        SciMLBase.NullParameters, dualT,
    },
)
const iip_returnlists_default = ntuple(x -> Nothing, length(iip_arglists_default))

function wrapfun_iip(@nospecialize(ff))
    fwt = map(iip_arglists_default, iip_returnlists_default) do A, R
        FunctionWrappersWrappers.FunctionWrappers.FunctionWrapper{R, A}(Void(ff))
    end
    return FunctionWrappersWrappers.FunctionWrappersWrapper{typeof(fwt), false}(fwt)
end

function promote_tspan(u0::AbstractArray{<:ForwardDiff.Dual}, p, tspan, prob, kwargs)
    if (haskey(kwargs, :callback) && has_continuous_callback(kwargs[:callback])) ||
            (haskey(prob.kwargs, :callback) && has_continuous_callback(prob.kwargs[:callback]))
        return _promote_tspan(eltype(u0).(tspan), kwargs)
    else
        return _promote_tspan(tspan, kwargs)
    end
end

function promote_tspan(
        u0::AbstractArray{<:Complex{<:ForwardDiff.Dual}}, p, tspan, prob,
        kwargs
    )
    return _promote_tspan(real(eltype(u0)).(tspan), kwargs)
end

function promote_tspan(
        u0::AbstractArray{<:ForwardDiff.Dual}, p,
        tspan::Tuple{<:ForwardDiff.Dual, <:ForwardDiff.Dual}, prob, kwargs
    )
    return _promote_tspan(tspan, kwargs)
end
# Copy of the other prob2dtmin dispatch, just for optionality
function prob2dtmin(tspan, ::ForwardDiff.Dual, use_end_time)
    t1, t2 = tspan
    isfinite(t1) || throw(ArgumentError("t0 in the tspan `(t0, t1)` must be finite"))
    if use_end_time && isfinite(t2 - t1)
        return max(eps(t2), eps(t1))
    else
        return max(eps(typeof(t1)), eps(t1))
    end
end

function hasdualpromote(u0, t::Number)
    return hasmethod(
        ArrayInterface.promote_eltype,
        Tuple{Type{typeof(u0)}, Type{dualgen(eltype(u0))}}
    ) &&
        hasmethod(
        promote_rule,
        Tuple{Type{eltype(u0)}, Type{dualgen(eltype(u0))}}
    ) &&
        hasmethod(
        promote_rule,
        Tuple{Type{eltype(u0)}, Type{typeof(t)}}
    )
end

@inline ODE_DEFAULT_NORM(u::ForwardDiff.Dual, ::Any) = sqrt(sse(u))
@inline function ODE_DEFAULT_NORM(
        u::AbstractArray{<:ForwardDiff.Dual{Tag, T}},
        t::Any
    ) where {Tag, T}
    return sqrt(DiffEqBase.__sum(sse, u; init = sse(zero(T))) / DiffEqBase.totallength(u))
end
@inline ODE_DEFAULT_NORM(u::ForwardDiff.Dual, ::ForwardDiff.Dual) = sqrt(sse(u))
@inline function ODE_DEFAULT_NORM(
        u::AbstractArray{<:ForwardDiff.Dual{Tag, T}},
        ::ForwardDiff.Dual
    ) where {Tag, T}
    return sqrt(DiffEqBase.__sum(sse, u; init = sse(zero(T))) / DiffEqBase.totallength(u))
end

if !hasmethod(nextfloat, Tuple{ForwardDiff.Dual})
    # Type piracy. Should upstream
    function Base.nextfloat(d::ForwardDiff.Dual{T, V, N}) where {T, V, N}
        return ForwardDiff.Dual{T}(nextfloat(d.value), d.partials)
    end
    function Base.prevfloat(d::ForwardDiff.Dual{T, V, N}) where {T, V, N}
        return ForwardDiff.Dual{T}(prevfloat(d.value), d.partials)
    end
end

import PrecompileTools
PrecompileTools.@compile_workload begin
    # Scalar operations on Dual numbers (arithmetic, math functions, comparisons)
    d1 = dualT(1.0, ForwardDiff.Partials((0.5,)))
    d2 = dualT(2.0, ForwardDiff.Partials((1.0,)))
    s = 3.14

    # Arithmetic: Dual-Dual and Dual-scalar
    d1 + d2
    d1 - d2
    d1 * d2
    d1 / d2
    d1 + s
    s + d1
    d1 - s
    s - d1
    d1 * s
    s * d1
    d1 / s
    s / d1
    -d1
    abs(d1)

    # Powers and roots
    d1^2
    d1^3
    d2^0.5
    sqrt(d2)
    cbrt(d2)

    # Transcendental functions
    exp(d1)
    log(d2)
    sin(d1)
    cos(d1)
    tan(d1)
    asin(dualT(0.5, ForwardDiff.Partials((1.0,))))
    acos(dualT(0.5, ForwardDiff.Partials((1.0,))))
    atan(d1)
    atan(d1, d2)
    sinh(d1)
    cosh(d1)
    tanh(d1)

    # Comparisons (used in step size control, event detection)
    d1 < d2
    d1 > d2
    d1 <= d2
    d1 >= d2
    d1 == d2
    isnan(d1)
    isinf(d1)
    isfinite(d1)

    # min/max (used in limiters and error control)
    min(d1, d2)
    max(d1, d2)
    min(d1, s)
    max(d1, s)

    # Conversion and promotion
    zero(dualT)
    one(dualT)
    float(d1)
    ForwardDiff.value(d1)
    ForwardDiff.partials(d1)

    # Array operations on Vector{dualT}
    v1 = [d1, d2, dualT(0.0, ForwardDiff.Partials((0.0,)))]
    v2 = [d2, d1, dualT(1.0, ForwardDiff.Partials((0.1,)))]

    # Basic array ops
    v1 + v2
    v1 - v2
    v1 .* v2
    v1 ./ v2
    s .* v1
    v1 .+ s
    v1 .- s
    v1 .^ 2
    v1 .^ 0.5

    # In-place array operations
    out = similar(v1)
    out .= v1 .+ v2
    out .= v1 .- v2
    out .= v1 .* v2
    out .= s .* v1
    out .= v1 .* s .+ v2
    out .= v1 .* s .- v2 .* s

    # Reductions (used in norm calculations, error estimation)
    sum(v1)
    sum(abs2, v1)
    maximum(abs, v1)

    # LinearAlgebra operations
    using LinearAlgebra
    dot(v1, v2)
    norm(v1)
    norm(v1, Inf)
    norm(v1, 1)

    # copy / fill
    copy(v1)
    fill!(out, zero(dualT))

    # SubArray primitive broadcast operations for Float64 and Dual types.
    # These are generic building blocks used by any ODE function with views.
    # Note: fused multi-operand broadcast expressions (e.g. `dy .= k .* y1 .+ k .* y2 .* y3`)
    # create unique nested Broadcasted types per expression and cannot be generically precompiled.
    for T in (Float64, dualT)
        x = zeros(T, 4)
        dx = zeros(T, 4)
        sv1 = @view x[1:2]
        sv2 = @view x[3:4]
        dsv1 = @view dx[1:2]
        k = 0.04

        # Primitive SubArray broadcast operations
        dsv1 .= sv1
        dsv1 .= k .* sv1
        dsv1 .= sv1 .* sv2
        dsv1 .= sv1 .+ sv2
        dsv1 .= sv1 .- sv2
        dsv1 .= sv1 .^ 2
        dsv1 .= .-sv1
    end
end

end

using OrdinaryDiffEq, Test
using SciMLSensitivity
using Random
using DifferentiationInterface
using ADTypes: AutoForwardDiff, AutoMooncake

# Load backends for all versions (required for DifferentiationInterface extensions)
using ForwardDiff
using Mooncake

# Version-dependent imports
if VERSION <= v"1.11"
    using Zygote
    using ADTypes: AutoZygote
end
if VERSION <= v"1.11"
    using Enzyme
    using ADTypes: AutoEnzyme
end

# Define backends based on Julia version
# ForwardDiff: All versions
# Mooncake: All versions
# Zygote: Julia <= 1.11
# Enzyme: Julia <= 1.11
function get_test_backends()
    backends = Pair{String, Any}[]
    # ForwardDiff on all versions
    push!(backends, "ForwardDiff" => AutoForwardDiff())
    # Mooncake on all versions
    push!(backends, "Mooncake" => AutoMooncake(; config = nothing))
    # Zygote only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Zygote" => AutoZygote())
    end
    # Enzyme only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Enzyme" => AutoEnzyme())
    end
    return backends
end

function dt!(du, u, p, t)
    x, y = u
    α, β, δ, γ = p
    du[1] = dx = α * x - β * x * y
    return du[2] = dy = -δ * y + γ * x * y
end

n_par = 3
Random.seed!(2)
u0 = rand(2, n_par)
u0[:, 1] = [1.0, 1.0]
tspan = (0.0, 10.0)
p = [2.2, 1.0, 2.0, 0.4]
prob_ode = ODEProblem(dt!, u0[:, 1], tspan)

function test_loss(p1, prob)
    function prob_func(prob, i, repeat)
        @show i
        return remake(prob, u0 = u0[:, i])
    end

    #define ensemble problem
    ensembleprob = EnsembleProblem(prob, prob_func = prob_func)

    u = Array(
        solve(
            ensembleprob, Tsit5(), EnsembleThreads(), trajectories = n_par,
            p = p1,
            sensealg = ForwardDiffSensitivity(),
            saveat = 0.1, dt = 0.001
        )
    )[:, end, :]
    loss = sum(u)
    return loss
end

test_loss(p, prob_ode)

# Test gradient computation with DifferentiationInterface for each backend
# Note: Mooncake and Enzyme are excluded for ensemble tests
# Mooncake: StackOverflowError in rule compilation
# Enzyme: Issues with ensemble problem differentiation
backends = get_test_backends()
backends_for_ensemble = filter(b -> b[1] ∉ ("Mooncake", "Enzyme"), backends)
for (name, backend) in backends_for_ensemble
    @testset "Ensemble test_loss gradient with $name" begin
        @time gs = DifferentiationInterface.gradient(p -> test_loss(p, prob_ode), backend, p)
        @test gs isa Vector
    end
end

### https://github.com/SciML/DiffEqFlux.jl/issues/595

function fiip(du, u, p, t)
    du[1] = dx = p[1] * u[1] - p[2] * u[1] * u[2]
    return du[2] = dy = -p[3] * u[2] + p[4] * u[1] * u[2]
end

p = [1.5, 1.0, 3.0, 1.0];
u0 = [1.0; 1.0];
prob = ODEProblem(fiip, u0, (0.0, 10.0), p)
sol = solve(prob, Tsit5())

function sum_of_solution(x)
    _prob = remake(prob, u0 = x[1:2], p = x[3:end])
    return sum(solve(_prob, Tsit5(), saveat = 0.1))
end

# Test sum_of_solution gradient with all backends
for (name, backend) in backends
    @testset "sum_of_solution gradient with $name" begin
        gs = DifferentiationInterface.gradient(sum_of_solution, backend, [u0; p])
        @test gs isa Vector
    end
end

# Testing ensemble problem with ForwardDiff
N = 3
eu0 = rand(N, 2)
ep = rand(N, 4)

ensemble_prob = EnsembleProblem(
    prob,
    prob_func = (
        prob, i, repeat,
    ) -> remake(
        prob,
        u0 = eu0[i, :],
        p = ep[i, :],
        saveat = 0.1
    )
)
esol = solve(ensemble_prob, Tsit5(), trajectories = N)

cache = Ref{Any}()

function sum_of_e_solution(p)
    ensemble_prob = EnsembleProblem(
        prob,
        prob_func = (
            prob, i, repeat,
        ) -> remake(
            prob,
            u0 = eu0[i, :],
            p = p[i, :],
            saveat = 0.1
        )
    )
    sol = solve(
        ensemble_prob, Tsit5(), EnsembleSerial(), trajectories = N, abstol = 1.0e-12,
        reltol = 1.0e-12
    )
    z = Array(sol.u[1])
    cache[] = sol.u[1].t
    return sum(z) # just test for the first solutions, gradients should be zero for others
end

sum_of_e_solution(ep)

# Test ensemble AD with multiple backends and compare results
# Note: Mooncake and Enzyme are excluded for ensemble tests (same as above)
@testset "Ensemble AD comparison across backends" begin
    # Use ForwardDiff as reference
    x_ref = DifferentiationInterface.gradient(sum_of_e_solution, AutoForwardDiff(), ep)

    for (name, backend) in backends_for_ensemble
        @testset "sum_of_e_solution gradient with $name" begin
            x = DifferentiationInterface.gradient(sum_of_e_solution, backend, ep)
            @test x ≈ x_ref
        end
    end
    @test cache[] == 0:0.1:10.0 # test prob.kwargs is forwarded
end

struct OrdinaryDiffEqTag end

const NORECOMPILE_ARGUMENT_MESSAGE = """
No-recompile mode is only supported for state arguments
of type `Vector{Float64}`, time arguments of `Float64`
and parameter arguments of type `Vector{Float64}` or
`SciMLBase.NullParameters`.
"""

struct NoRecompileArgumentError <: Exception
    args::Any
end

function Base.showerror(io::IO, e::NoRecompileArgumentError)
    println(io, NORECOMPILE_ARGUMENT_MESSAGE)
    print(io, "Attempted arguments: ")
    return print(io, e.args)
end

function unwrap_fw(fw::FunctionWrapper)
    return fw.obj[]
end

# Default dispatch assumes no ForwardDiff, gets added in the new dispatch
function wrapfun_iip(ff, inputs)
    return FunctionWrappersWrappers.FunctionWrappersWrapper(
        Void(ff), (typeof(inputs),), (Nothing,)
    )
end

# 3-arg fallback: when ForwardDiff extension is not loaded, ignore chunk size
wrapfun_iip(ff, inputs, ::Val) = wrapfun_iip(ff, inputs)

function wrapfun_oop(ff, inputs)
    return FunctionWrappersWrappers.FunctionWrappersWrapper(
        ff, (typeof(inputs),), (typeof(inputs[1]),)
    )
end

# Wrap an in-place Jacobian function jac!(J, u, p, t) -> Nothing.
# Unlike the RHS, the Jacobian is not called with Dual numbers
# (the analytical Jacobian IS the derivative), so we only need
# a single FunctionWrapper variant.
function wrapfun_jac_iip(jac_f, inputs)
    return FunctionWrappersWrappers.FunctionWrappersWrapper(
        Void(jac_f), (typeof(inputs),), (Nothing,)
    )
end

module DiffEqBaseDynamicQuantitiesExt

using DiffEqBase
using DynamicQuantities
using LinearAlgebra
import DiffEqBase: default_factorize

@inline DiffEqBase.ODE_DEFAULT_NORM(u::UnionAbstractQuantity, t) = abs(ustrip(u))
@inline function DiffEqBase.UNITLESS_ABS2(x::UnionAbstractQuantity)
    return real(abs2(ustrip(x)))
end

DiffEqBase._rate_prototype(u, t::UnionAbstractQuantity, onet) = u / oneunit(t)
DiffEqBase.timedepentdtmin(t::UnionAbstractQuantity, dtmin) =
    abs(ustrip(dtmin / oneunit(t)) * oneunit(t))

# Rosenbrock/SDIRK solvers form W/J matrices with Quantity eltype. Factorize/solve in
# value-space (Float64), but return solutions with the RHS units.
struct DQUnitlessLU{F, UT}
    F::F
    ut::UT
end

@inline function _infer_ut(A::AbstractMatrix{<:UnionAbstractQuantity})
    @inbounds for a in A
        va = ustrip(a)
        if !iszero(va)
            return oneunit(inv(a))
        end
    end
    return oneunit(1.0)
end

function default_factorize(A::AbstractMatrix{<:UnionAbstractQuantity})
    isempty(A) && return DQUnitlessLU(
        lu(Matrix{Float64}(undef, 0, 0); check = false),
        oneunit(1.0),
    )
    ut = _infer_ut(A)
    return DQUnitlessLU(lu(ustrip.(A); check = false), ut)
end

function LinearAlgebra.ldiv!(
        x::AbstractVector{<:UnionAbstractQuantity},
        W::DQUnitlessLU,
        b::AbstractVector{<:UnionAbstractQuantity},
    )
    vb = ustrip.(b)
    vx = similar(vb)
    LinearAlgebra.ldiv!(vx, W.F, vb)
    @inbounds for i in eachindex(x)
        x[i] = vx[i] * (oneunit(b[i]) * W.ut)
    end
    return x
end

function Base.:(\)(W::DQUnitlessLU, b::AbstractVector{<:UnionAbstractQuantity})
    vb = ustrip.(b)
    vx = W.F \ vb
    out = similar(b)
    @inbounds for i in eachindex(out)
        out[i] = vx[i] * (oneunit(b[i]) * W.ut)
    end
    return out
end

end

using DiffEqBase, Test, RecursiveArrayTools
import SciMLBase: AbstractSciMLFunction

macro iop_def(funcdef::Expr)
    """Define in- and out-of-place functions simultaneously.

    Call on oop function definition, defines two functions with suffixes _op and _ip.
    """
    @assert funcdef.head ∈ (:function, :(=)) && funcdef.args[1].head == :call

    fname = funcdef.args[1].args[1]

    opname = Symbol("$(fname)_op")
    ipname = Symbol("$(fname)_ip")

    opdef = deepcopy(funcdef)
    opdef.args[1].args[1] = opname

    return quote
        $(esc(opdef))
        $(esc(ipname))(du, args...) = du .= $(esc(opname))(args...)
    end
end

function test_inplace(du, expected, f::AbstractSciMLFunction, args...)
    """Test the in-place version of a function."""
    fill!(du, NaN)
    f(du, args...)
    return @test du == expected
end

# Allocate du automatically based on type of expected result
function test_inplace(expected, f::AbstractSciMLFunction, args...)
    return test_inplace(similar(expected), expected, f, args...)
end

function test_iop(expected, f_op::AbstractSciMLFunction, f_ip::AbstractSciMLFunction, args...)
    """Test in- and out-of-place version of function both match expected value."""
    @test f_op(args...) == expected
    return test_inplace(expected, f_ip, args...)
end

@iop_def f(u, p, t) = p[1] .* u
u = [1.0, 2.0, 3.0]
p = [2.0]
t = 0.0

@testset "ODEFunction with default recompile flag" begin
    odefun = ODEFunction{false}(f_op)
    odefun_ip = ODEFunction{true}(f_ip)
    expected = f_op(u, p, t)
    test_iop(expected, odefun, odefun_ip, u, p, t)
end

@testset "ODEFunction with recompile flag: $rflag" for rflag in (true, false)
    odefun = ODEFunction{false, rflag}(f_op)
    odefun_ip = ODEFunction{true, rflag}(f_ip)
    expected = f_op(u, p, t)
    test_iop(expected, odefun, odefun_ip, u, p, t)
end

# SplitFunction
@iop_def f2(u, p, t) = u .^ 2
sfun = SplitFunction{false}(f_op, f2_op)
sfun_ip = SplitFunction{true}(f_ip, f2_ip; _func_cache = similar(u))
expected = f_op(u, p, t) + f2_op(u, p, t)
test_iop(expected, sfun, sfun_ip, u, p, t)

# DynamicalODEFunction
@iop_def dode_f1(v, u, p, t) = -u
@iop_def dode_f2(v, u, p, t) = p[1] .* v
dodefun = DynamicalODEFunction{false}(dode_f1_op, dode_f2_op)
dodefun_ip = DynamicalODEFunction{true}(dode_f1_ip, dode_f2_ip)
v = [4.0, 5.0, 6.0]
expected = ArrayPartition(dode_f1_op(v, u, p, t), dode_f2_op(v, u, p, t))
test_iop(expected, dodefun, dodefun_ip, ArrayPartition(v, u), p, t)

# DiscreteFunction
dfun = DiscreteFunction{false}(f_op)
dfun_ip = DiscreteFunction{true}(f_ip)
test_iop(f_op(u, p, t), dfun, dfun_ip, u, p, t)

# Type stability
f_analytic(u, p, t) = u
jac = (u, p, t) -> 1
@inferred ODEFunction{false}(f_op, jac = jac)
@inferred DiscreteFunction{false}(f_op, analytic = f_analytic)

using Unitful, OrdinaryDiffEq, ForwardDiff, Test
f(du, u, p, t) = du .= 3 * u"1/s" * u
prob = ODEProblem(f, [2.0u"m"], (0.0u"s", Inf * u"s"))
intg = init(prob, Tsit5())
@test_nowarn step!(intg, 0.02u"s", true)

@test SciMLBase.unitfulvalue(u"1/s") == u"1/s"
@test SciMLBase.value(ForwardDiff.Dual(1) * u"1/s") == 1
@test SciMLBase.unitfulvalue(ForwardDiff.Dual(1) * u"1/s") == u"1/s"

using Distributed
addprocs(2)
println("There are $(nprocs()) processes")

@everywhere begin
    using Pkg
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path = joinpath(pwd(), "..")))
    Pkg.instantiate()
    using OrdinaryDiffEq
    prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0))
    u0s = [rand() * prob.u0 for i in 1:2]
    function simple_prob_func(prob, i, repeat)
        println("Running trajectory $i")
        ODEProblem(prob.f, u0s[i], prob.tspan)
    end
end

ensemble_prob = EnsembleProblem(prob, prob_func = simple_prob_func)
sim = solve(ensemble_prob, Tsit5(), EnsembleSplitThreads(), trajectories = 2)

@everywhere function lorenz!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

u0 = [1.0, 0.0, 0.0]
tspan = (0.0, 100.0)
p = [1, 2.0, 3]
prob = ODEProblem(lorenz!, u0, tspan, p)

@everywhere function lorenz_prob_func(prob, i, repeat)
    prob = remake(prob, tspan = (rand(), 100.0), p = rand(3))
    return prob
end

ensemble_prob = EnsembleProblem(prob, prob_func = lorenz_prob_func, safetycopy = true)

println("Running EnsembleSerial()")
@test length(solve(ensemble_prob, Tsit5(), EnsembleSerial(), trajectories = 100)) == 100
println("Running EnsembleThreads()")
@test length(solve(ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 100)) == 100
println("Running EnsembleDistributed()")
@test length(solve(ensemble_prob, Tsit5(), EnsembleDistributed(), trajectories = 100)) ==
    100
println("Running EnsembleSplitThreads()")
@test length(solve(ensemble_prob, Tsit5(), EnsembleSplitThreads(), trajectories = 100)) ==
    100

module DiffEqBaseEnzymeExt

@static if isempty(VERSION.prerelease)
    using DiffEqBase
    import DiffEqBase: value
    using Enzyme
    import Enzyme: Const, MixedDuplicated
    using ChainRulesCore


    @inline function copy_or_reuse(config, val, idx)
        if Enzyme.EnzymeRules.overwritten(config)[idx] && ismutable(val)
            return deepcopy(val)
        else
            return val
        end
    end

    @inline function arg_copy(data, i)
        config, args = data
        copy_or_reuse(config, args[i].val, i + 5)
    end

    # Note these following functions are generally not considered user facing from within Enzyme.
    # They enable additional performance/usability here (e.g. inactive kwargs).
    # Contact wsmoses@ before modifying (and beware their semantics may change without semver).

    Enzyme.EnzymeRules.inactive_kwarg(::typeof(DiffEqBase.solve_up), prob, sensalg::Union{Nothing, DiffEqBase.AbstractSensitivityAlgorithm}, u0, p, args...; kwargs...) = nothing

    Enzyme.EnzymeRules.has_easy_rule(::typeof(DiffEqBase.solve_up), prob, sensalg::Union{Nothing, DiffEqBase.AbstractSensitivityAlgorithm}, u0, p, args...; kwargs...) = nothing

    function Enzyme.EnzymeRules.augmented_primal(
            config::Enzyme.EnzymeRules.RevConfigWidth{1},
            func::Const{typeof(DiffEqBase.solve_up)}, RTA::Union{Type{Duplicated{RT}}, Type{MixedDuplicated{RT}}}, prob,
            sensealg::Union{
                Const{Nothing}, Const{<:DiffEqBase.AbstractSensitivityAlgorithm},
            },
            u0, p, args...; kwargs...
        ) where {RT}

        res = DiffEqBase._solve_adjoint(
            copy_or_reuse(config, prob.val, 2), copy_or_reuse(config, sensealg.val, 3),
            copy_or_reuse(config, u0.val, 4), copy_or_reuse(config, p.val, 5),
            SciMLBase.EnzymeOriginator(), ntuple(Base.Fix1(arg_copy, (config, args)), Val(length(args)))...;
            kwargs...
        )

        primal = if Enzyme.EnzymeRules.needs_primal(config)
            res[1]
        else
            nothing
        end

        shadow = if Enzyme.EnzymeRules.needs_shadow(config)
            Enzyme.make_zero(res[1])::RT
        else
            nothing
        end
        tup = if Enzyme.EnzymeRules.needs_shadow(config)
            (shadow, res[2])
        else
            nothing
        end
        return Enzyme.EnzymeRules.augmented_rule_return_type(config, RTA)(primal, shadow, tup)
    end

    function Enzyme.EnzymeRules.reverse(
            config::Enzyme.EnzymeRules.RevConfigWidth{1},
            func::Const{typeof(DiffEqBase.solve_up)}, ::Union{Type{Duplicated{RT}}, Type{MixedDuplicated{RT}}}, tape, prob,
            sensealg::Union{
                Const{Nothing}, Const{<:DiffEqBase.AbstractSensitivityAlgorithm},
            },
            u0, p, args...; kwargs...
        ) where {RT}

        if Enzyme.EnzymeRules.needs_shadow(config)
            dres, clos = tape
            dres = dres::RT
            dargs = clos(dres)
            for (darg, ptr) in zip(dargs, (func, prob, sensealg, u0, p, args...))
                if ptr isa Enzyme.Const
                    continue
                end
                if darg == ChainRulesCore.NoTangent()
                    continue
                end
                if ptr isa MixedDuplicated
                    ptr.dval[] .+= darg
                else
                    ptr.dval .+= darg
                end
            end
            Enzyme.make_zero!(dres.u)
        end

        return ntuple(Returns(nothing), Val(length(args) + 4))
    end
end

end

module DiffEqBaseTrackerExt

using DiffEqBase
import DiffEqBase: value
import Tracker

# Support adaptive with non-tracked time
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::Tracker.TrackedArray, t)
    return sqrt(sum(abs2, DiffEqBase.value(u)) / length(u))
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{<:Tracker.TrackedReal, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((DiffEqBase.value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:Tracker.TrackedReal, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((DiffEqBase.value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline DiffEqBase.ODE_DEFAULT_NORM(u::Tracker.TrackedReal, t) = abs(DiffEqBase.value(u))

# Support TrackedReal time, don't drop tracking on the adaptivity there
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Tracker.TrackedArray,
        t::Tracker.TrackedReal
    )
    return sqrt(sum(abs2, u) / length(u))
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{<:Tracker.TrackedReal, N},
        t::Tracker.TrackedReal
    ) where {N}
    return sqrt(
        sum(x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]), zip(u, Iterators.repeated(t))) /
            length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:Tracker.TrackedReal, N},
        t::Tracker.TrackedReal
    ) where {N}
    return sqrt(
        sum(x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]), zip(u, Iterators.repeated(t))) /
            length(u)
    )
end
@inline DiffEqBase.ODE_DEFAULT_NORM(u::Tracker.TrackedReal, t::Tracker.TrackedReal) = abs(u)

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0::Tracker.TrackedArray,
        p::Tracker.TrackedArray, args...; kwargs...
    )
    return Tracker.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0::Tracker.TrackedArray, p, args...;
        kwargs...
    )
    return Tracker.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0, p::Tracker.TrackedArray, args...;
        kwargs...
    )
    return Tracker.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

Tracker.@grad function DiffEqBase.solve_up(
        prob,
        sensealg::Union{
            Nothing,
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
        },
        u0, p, args...;
        kwargs...
    )
    sol,
        pb_f = DiffEqBase._solve_adjoint(
        prob, sensealg, Tracker.data(u0), Tracker.data(p),
        SciMLBase.TrackerOriginator(), args...; kwargs...
    )

    if sol isa AbstractArray
        !hasfield(typeof(sol), :u) && return sol, pb_f # being safe here
        return sol.u, pb_f # AbstractNoTimeSolution isa AbstractArray
    end
    return convert(AbstractArray, sol), pb_f
end

end

"""
    initialize!(cb::CallbackSet,u,t,integrator::DEIntegrator)

Recursively apply `initialize!` and return whether any modified u
"""
function initialize!(cb::CallbackSet, u, t, integrator::DEIntegrator)
    return initialize!(
        u, t, integrator, false, cb.continuous_callbacks...,
        cb.discrete_callbacks...
    )
end
initialize!(cb::CallbackSet{Tuple{}, Tuple{}}, u, t, integrator::DEIntegrator) = false
function initialize!(
        u, t, integrator::DEIntegrator, any_modified::Bool,
        c::DECallback, cs::DECallback...
    )
    c.initialize(c, u, t, integrator)
    return initialize!(u, t, integrator, any_modified || integrator.u_modified, cs...)
end
function initialize!(
        u, t, integrator::DEIntegrator, any_modified::Bool,
        c::DECallback
    )
    c.initialize(c, u, t, integrator)
    return any_modified || integrator.u_modified
end

"""
    finalize!(cb::CallbackSet,u,t,integrator::DEIntegrator)

Recursively apply `finalize!` and return whether any modified u
"""
function finalize!(cb::CallbackSet, u, t, integrator::DEIntegrator)
    return finalize!(u, t, integrator, false, cb.continuous_callbacks..., cb.discrete_callbacks...)
end
finalize!(cb::CallbackSet{Tuple{}, Tuple{}}, u, t, integrator::DEIntegrator) = false
function finalize!(
        u, t, integrator::DEIntegrator, any_modified::Bool,
        c::DECallback, cs::DECallback...
    )
    c.finalize(c, u, t, integrator)
    return finalize!(u, t, integrator, any_modified || integrator.u_modified, cs...)
end
function finalize!(
        u, t, integrator::DEIntegrator, any_modified::Bool,
        c::DECallback
    )
    c.finalize(c, u, t, integrator)
    return any_modified || integrator.u_modified
end

# Helpers
function Base.isempty(cb::CallbackSet)
    return isempty(cb.continuous_callbacks) && isempty(cb.discrete_callbacks)
end
Base.isempty(cb::AbstractContinuousCallback) = false
Base.isempty(cb::AbstractDiscreteCallback) = false

has_continuous_callback(cb::DiscreteCallback) = false
has_continuous_callback(cb::ContinuousCallback) = true
has_continuous_callback(cb::VectorContinuousCallback) = true
has_continuous_callback(cb::CallbackSet) = !isempty(cb.continuous_callbacks)
has_continuous_callback(cb::Nothing) = false

rightfloat(t, tdir) = isone(tdir) ? nextfloat(t) : prevfloat(t)

# Callback handling

function get_tmp(integrator::DEIntegrator, callback)
    _tmp = get_tmp_cache(integrator)
    _tmp === nothing && return nothing
    _cache = first(_tmp)
    if callback.idxs === nothing
        tmp = _cache
    elseif !(callback.idxs isa Number)
        tmp = @view _cache[callback.idxs]
    else
        tmp = nothing
    end
    return tmp
end

function get_condition(integrator::DEIntegrator, callback, abst)
    tmp = get_tmp(integrator, callback)
    ismutable = !(tmp === nothing)
    if abst == integrator.t
        if callback.idxs === nothing
            tmp = integrator.u
        elseif callback.idxs isa Number
            tmp = integrator.u[callback.idxs]
        else
            tmp = @view integrator.u[callback.idxs]
        end
    elseif abst == integrator.tprev
        if callback.idxs === nothing
            tmp = integrator.uprev
        elseif callback.idxs isa Number
            tmp = integrator.uprev[callback.idxs]
        else
            tmp = @view integrator.uprev[callback.idxs]
        end
    else
        if ismutable
            if callback.idxs === nothing
                integrator(tmp, abst, Val{0})
            else
                integrator(tmp, abst, Val{0}, idxs = callback.idxs)
            end
        else
            if callback.idxs === nothing
                tmp = integrator(abst, Val{0})
            else
                tmp = integrator(abst, Val{0}, idxs = callback.idxs)
            end
        end
        # ismutable && !(callback.idxs isa Number) ? integrator(tmp,abst,Val{0},idxs=callback.idxs) :
        #                                                 tmp = integrator(abst,Val{0},idxs=callback.idxs)
    end
    integrator.sol.stats.ncondition += 1
    if callback isa VectorContinuousCallback
        callback.condition(
            @view(integrator.callback_cache.tmp_condition[1:(callback.len)]),
            tmp, abst, integrator
        )
        return @view(integrator.callback_cache.tmp_condition[1:(callback.len)])
    else
        return callback.condition(tmp, abst, integrator)
    end
end

# Use a generated function for type stability even when many callbacks are given
@inline function find_first_continuous_callback(
        integrator,
        callbacks::Vararg{
            AbstractContinuousCallback,
            N,
        }
    ) where {N}
    return find_first_continuous_callback(integrator, tuple(callbacks...))
end
@generated function find_first_continuous_callback(
        integrator,
        callbacks::NTuple{
            N,
            AbstractContinuousCallback,
        }
    ) where {N}
    ex = quote
        tmin, upcrossing,
            event_occurred, event_idx, residual = find_callback_time(
            integrator,
            callbacks[1], 1
        )
        identified_idx = 1
    end
    for i in 2:N
        ex = quote
            $ex
            tmin2, upcrossing2,
                event_occurred2, event_idx2, residual2 = find_callback_time(
                integrator,
                callbacks[$i],
                $i
            )
            if event_occurred2 && (!event_occurred || integrator.tdir * tmin2 < integrator.tdir * tmin)
                tmin = tmin2
                upcrossing = upcrossing2
                event_occurred = true
                event_idx = event_idx2
                identified_idx = $i
                residual = residual2
            end
        end
    end
    ex = quote
        $ex
        if event_occurred
            integrator.last_event_error = value(residual)
        end
        return tmin, upcrossing, event_occurred, event_idx, identified_idx, $N
    end
    return ex
end

@inline function find_callback_time(
        integrator, callback::VectorContinuousCallback,
        callback_idx
    )
    if callback.interp_points != 0
        addsteps!(integrator)
    end

    # Compute previous sign
    bottom_sign = @view(integrator.callback_cache.prev_sign[1:(callback.len)])
    bottom_t = integrator.tprev
    bottom_condition = get_condition(integrator, callback, integrator.tprev)
    @. bottom_sign = sign(bottom_condition)

    if integrator.event_last_time == callback_idx
        nudged_idx = integrator.vector_event_last_time
        # If there was a previous event, nudge tprev on the right
        # side of the root (if necessary) to avoid repeat detection

        if callback.interp_points == 0
            addsteps!(integrator)
        end

        # Evaluate condition slightly in future
        nudged_t = nudge_tprev(integrator, callback, ArrayInterface.allowed_getindex(bottom_condition, nudged_idx))
        tmp_condition = get_condition(integrator, callback, nudged_t)

        ArrayInterface.allowed_setindex!(bottom_sign, sign(ArrayInterface.allowed_getindex(tmp_condition, nudged_idx)), nudged_idx)
    else
        nudged_idx = -1
        nudged_t = bottom_t
    end

    # Check if an event occured
    event_occurred, event_idx, top_t, top_sign =
        check_event_occurence(integrator, callback, bottom_sign)

    # Find callback time if occurence
    if !event_occurred
        callback_t = integrator.t
        min_event_idx = 1
        residual = zero(eltype(bottom_condition))
    elseif isdiscrete(integrator.alg) || callback.rootfind == SciMLBase.NoRootFind
        callback_t = top_t
        min_event_idx = 1
        for i in 1:length(event_idx)
            if ArrayInterface.allowed_getindex(event_idx, i) == 1
                min_event_idx = i
                break
            end
        end
        residual = zero(eltype(bottom_condition))
    else
        callback_t = rightfloat(top_t, integrator.tdir)
        min_event_idx = -1
        for idx in 1:length(event_idx)
            if ArrayInterface.allowed_getindex(event_idx, idx) != 0
                function zero_func(abst, p = nothing)
                    return ArrayInterface.allowed_getindex(
                        get_condition(
                            integrator,
                            callback,
                            abst
                        ), idx
                    )
                end
                if iszero(ArrayInterface.allowed_getindex(top_sign, idx))
                    cbi_t = top_t
                else
                    if idx == nudged_idx
                        cbi_t = find_root(zero_func, (nudged_t, top_t), callback.rootfind)
                    else
                        cbi_t = find_root(zero_func, (bottom_t, top_t), callback.rootfind)
                    end
                end
                if integrator.tdir * cbi_t < integrator.tdir * callback_t
                    min_event_idx = idx
                    callback_t = cbi_t
                    residual = zero_func(cbi_t)
                end
            end
        end

        if min_event_idx < 0
            error("Callback handling failed. Please file an issue with code to reproduce.")
        end
    end

    return callback_t, ArrayInterface.allowed_getindex(bottom_sign, min_event_idx),
        event_occurred::Bool, min_event_idx::Int, residual
end

@inline function find_callback_time(
        integrator, callback::ContinuousCallback,
        callback_idx
    )
    if callback.interp_points != 0
        addsteps!(integrator)
    end

    # Compute previous sign
    bottom_t = integrator.tprev
    bottom_condition = get_condition(integrator, callback, bottom_t)
    if integrator.event_last_time == callback_idx
        # If there was a previous event, nudge tprev on the right
        # side of the root (if necessary) to avoid repeat detection

        if callback.interp_points == 0
            addsteps!(integrator)
        end

        bottom_t = nudge_tprev(integrator, callback, bottom_condition)
        bottom_condition = get_condition(integrator, callback, bottom_t)
    end
    bottom_sign = sign(bottom_condition)

    # Check if an event occured
    event_occurred, event_idx, top_t, top_sign =
        check_event_occurence(integrator, callback, bottom_sign)

    if !event_occurred
        callback_t = integrator.t
        residual = zero(bottom_condition)
    elseif isdiscrete(integrator.alg) || callback.rootfind == SciMLBase.NoRootFind || iszero(top_sign)
        callback_t = top_t
        residual = zero(bottom_condition)
    else
        # Find callback time
        zero_func(abst, p = nothing) = get_condition(integrator, callback, abst)
        callback_t = find_root(zero_func, (bottom_t, top_t), callback.rootfind)
        residual = zero_func(callback_t)
    end

    return callback_t, bottom_sign, event_occurred, event_idx, residual
end

"""
Return a nudged (if neccessary) value of `integrator.tprev` to avoid repeat event detection
- `integrator`
- `callback`: Last occuring callback
- `condition_tprev`: Condition of last occuring callback evaluated at `integrator.tprev`
"""
function nudge_tprev(integrator, callback, condition_tprev)
    # Assume the previous event might affect the condition/root
    return if abs(condition_tprev - integrator.last_event_error) <= callback.abstol
        # We are still close to the root
        right_t = integrator.tprev + integrator.dt * callback.repeat_nudge
    else
        # We are far away from the root, keep the current sign
        right_t = integrator.tprev
    end
end

"""
Determine if an event occured in the integration time step
"""
function check_event_occurence(integrator, callback, bottom_sign)
    top_t = integrator.t
    event_occurred, event_idx, top_sign =
        check_event_occurence_upto(integrator, callback, bottom_sign, top_t)

    if callback.interp_points != 0 && !isdiscrete(integrator.alg) &&
            any(iszero, event_idx)
        # Use the interpolants for safety checking
        ts = range(integrator.tprev, stop = integrator.t, length = callback.interp_points)
        for i in 2:length(ts)
            top_t = ts[i]
            event_occurred, event_idx, top_sign =
                check_event_occurence_upto(integrator, callback, bottom_sign, top_t)
            if event_occurred
                break
            end
        end
    end

    return event_occurred, event_idx, top_t, top_sign
end

"""
Determine if an event occured before `top_t``
"""
function check_event_occurence_upto(integrator, callback::ContinuousCallback, bottom_sign, top_t)
    top_sign = sign(get_condition(integrator, callback, top_t))
    event_occurred = is_event_occurence(bottom_sign, top_sign, callback.affect!, callback.affect_neg!)
    event_idx = event_occurred ? 1.0 : 0.0
    return event_occurred, event_idx, top_sign
end

function check_event_occurence_upto(integrator, callback::VectorContinuousCallback, bottom_sign, top_t)
    event_idx = top_condition = @views(integrator.callback_cache.next_condition[1:(callback.len)])
    top_sign = @view(integrator.callback_cache.next_sign[1:(callback.len)])
    copyto!(top_condition, get_condition(integrator, callback, top_t))
    @. top_sign = sign(top_condition)

    # Determine event occurence
    event_occurred = findall_events!(
        top_condition, callback.affect!, callback.affect_neg!,
        bottom_sign
    )
    return event_occurred, event_idx, top_sign
end

"""
Find either exact or floating point precision root of `f`.
If the exact root cannot be represented, return closest floating point number depending on `rootfind`

Assumes that:
 - `tup[1] < tup[2]` for a forward integration
 - `tup[1] > tup[2]` for a backward integration
 - The nonlinear solver return left/right roots in the same order as `tup[1]`/`tup[2]`
"""
function find_root(f, tup, rootfind::SciMLBase.RootfindOpt)
    sol = solve(
        IntervalNonlinearProblem{false}(f, tup),
        ModAB(), abstol = 0.0, reltol = 0.0
    )
    if rootfind == SciMLBase.LeftRootFind
        return sol.left
    else
        return sol.right
    end
end

"""
findall_events!(next_sign,affect!,affect_neg!,prev_sign)

Modifies `next_sign` to be an array of booleans for if there is a sign change
in the interval between prev_sign and next_sign.
Return `true` if any event occured.
"""
function findall_events!(
        next_sign::Union{Array, SubArray}, affect!::F1, affect_neg!::F2,
        prev_sign::Union{Array, SubArray}
    ) where {F1, F2}
    @inbounds for i in 1:length(prev_sign)
        next_sign[i] = (
            (prev_sign[i] < 0 && affect! !== nothing) ||
                (prev_sign[i] > 0 && affect_neg! !== nothing)
        ) &&
            prev_sign[i] * next_sign[i] <= 0
    end
    return any(isone, next_sign)
end

function findall_events!(next_sign, affect!::F1, affect_neg!::F2, prev_sign) where {F1, F2}
    hasaffect::Bool = affect! !== nothing
    hasaffectneg::Bool = affect_neg! !== nothing
    f = (n, p) -> ((p < 0 && hasaffect) || (p > 0 && hasaffectneg)) && p * n <= 0
    A = map!(f, next_sign, next_sign, prev_sign)
    return any(isone, next_sign)
end

"""
Return `true` if an event occured.
"""
function is_event_occurence(prev_sign::Number, next_sign::Number, affect!::F1, affect_neg!::F2) where {F1, F2}
    return (
        (prev_sign < 0 && affect! !== nothing) ||
            (prev_sign > 0 && affect_neg! !== nothing)
    ) && prev_sign * next_sign <= 0
end

function apply_callback!(
        integrator,
        callback::Union{ContinuousCallback, VectorContinuousCallback},
        cb_time, prev_sign, event_idx
    )
    if isadaptive(integrator)
        set_proposed_dt!(
            integrator,
            integrator.tdir * max(
                nextfloat(integrator.opts.dtmin),
                integrator.tdir * callback.dtrelax * integrator.dt
            )
        )
    end

    change_t_via_interpolation!(
        integrator, cb_time, Val{:false}, callback.initializealg
    )

    # handle saveat
    _, savedexactly = savevalues!(integrator)
    saved_in_cb = true

    @inbounds if callback.save_positions[1]
        # if already saved then skip saving
        savedexactly || savevalues!(integrator, true)
    end

    integrator.u_modified = true

    if prev_sign < 0
        if callback.affect! === nothing
            integrator.u_modified = false
        else
            callback isa VectorContinuousCallback ?
                callback.affect!(integrator, event_idx) : callback.affect!(integrator)
        end
    elseif prev_sign > 0
        if callback.affect_neg! === nothing
            integrator.u_modified = false
        else
            callback isa VectorContinuousCallback ?
                callback.affect_neg!(integrator, event_idx) : callback.affect_neg!(integrator)
        end
    end

    if integrator.u_modified
        reeval_internals_due_to_modification!(
            integrator, callback_initializealg = callback.initializealg
        )

        @inbounds if callback.save_positions[2]
            savevalues!(integrator, true)
            if !isdefined(integrator.opts, :save_discretes) || integrator.opts.save_discretes
                if callback isa VectorContinuousCallback
                    SciMLBase.save_discretes!(integrator, callback, event_idx)
                else
                    SciMLBase.save_discretes!(integrator, callback)
                end
            end
            saved_in_cb = true
        end
        return true, saved_in_cb
    end
    return false, saved_in_cb
end

#Base Case: Just one
@inline function apply_discrete_callback!(integrator, callback::DiscreteCallback)
    saved_in_cb = false
    if callback.condition(integrator.u, integrator.t, integrator)
        # handle saveat
        _, savedexactly = savevalues!(integrator)
        saved_in_cb = true
        @inbounds if callback.save_positions[1]
            # if already saved then skip saving
            savedexactly || savevalues!(integrator, true)
        end
        integrator.u_modified = true
        callback.affect!(integrator)
        if integrator.u_modified
            reeval_internals_due_to_modification!(
                integrator, false, callback_initializealg = callback.initializealg
            )
        end
        @inbounds if callback.save_positions[2]
            savevalues!(integrator, true)
            if !isdefined(integrator.opts, :save_discretes) || integrator.opts.save_discretes
                SciMLBase.save_discretes!(integrator, callback)
            end
            saved_in_cb = true
        end
    end
    integrator.sol.stats.ncondition += 1
    return integrator.u_modified, saved_in_cb
end

#Starting: Get bool from first and do next
@inline function apply_discrete_callback!(integrator, callback::DiscreteCallback, args...)
    return apply_discrete_callback!(
        integrator, apply_discrete_callback!(integrator, callback)...,
        args...
    )
end

@inline function apply_discrete_callback!(
        integrator, discrete_modified::Bool,
        saved_in_cb::Bool, callback::DiscreteCallback,
        args...
    )
    bool,
        saved_in_cb2 = apply_discrete_callback!(
        integrator,
        apply_discrete_callback!(
            integrator,
            callback
        )...,
        args...
    )
    return discrete_modified || bool, saved_in_cb || saved_in_cb2
end

@inline function apply_discrete_callback!(
        integrator, discrete_modified::Bool,
        saved_in_cb::Bool, callback::DiscreteCallback
    )
    bool, saved_in_cb2 = apply_discrete_callback!(integrator, callback)
    return discrete_modified || bool, saved_in_cb || saved_in_cb2
end

function max_vector_callback_length_int(cs::CallbackSet)
    return max_vector_callback_length_int(cs.continuous_callbacks...)
end
max_vector_callback_length_int() = nothing
function max_vector_callback_length_int(continuous_callbacks...)
    all(cb -> cb isa ContinuousCallback, continuous_callbacks) && return nothing
    maxlen = -1
    for cb in continuous_callbacks
        if cb isa VectorContinuousCallback && cb.len > maxlen
            maxlen = cb.len
        end
    end
    return maxlen
end

function max_vector_callback_length(cs::CallbackSet)
    continuous_callbacks = cs.continuous_callbacks
    maxlen_cb = nothing
    maxlen = -1
    for cb in continuous_callbacks
        if cb isa VectorContinuousCallback && cb.len > maxlen
            maxlen = cb.len
            maxlen_cb = cb
        end
    end
    return maxlen_cb
end

"""
$(TYPEDEF)
"""
mutable struct CallbackCache{conditionType, signType}
    tmp_condition::conditionType
    next_condition::conditionType
    next_sign::signType
    prev_sign::signType
end

function CallbackCache(
        u, max_len, ::Type{conditionType},
        ::Type{signType}
    ) where {conditionType, signType}
    tmp_condition = similar(u, conditionType, max_len)
    next_condition = similar(u, conditionType, max_len)
    next_sign = similar(u, signType, max_len)
    prev_sign = similar(u, signType, max_len)
    return CallbackCache(tmp_condition, next_condition, next_sign, prev_sign)
end

function CallbackCache(
        max_len, ::Type{conditionType},
        ::Type{signType}
    ) where {conditionType, signType}
    tmp_condition = zeros(conditionType, max_len)
    next_condition = zeros(conditionType, max_len)
    next_sign = zeros(signType, max_len)
    prev_sign = zeros(signType, max_len)
    return CallbackCache(tmp_condition, next_condition, next_sign, prev_sign)
end

using Test

using DiffEqBase, ForwardDiff
using DiffEqBase: prob2dtmin, timedepentdtmin, _rate_prototype
using Unitful
using ForwardDiff: Dual, Tag

@testset "tspan2dtmin" begin
    # we only need to test very rough equality since timestepping isn't science.
    function approxoftype(a, b; rtol = 0.5)
        return typeof(a) === typeof(b) && isapprox(a, b; rtol = rtol)
    end
    function tspan2dtmin(tspan; kwargs...)
        prob2dtmin(ODEProblem((u, p, t) -> u, 1, tspan); kwargs...)
    end
    @test approxoftype(tspan2dtmin((10, 100.0)), eps(100.0))
    @test approxoftype(tspan2dtmin((-10000.0, 100.0)), eps(10000.0))
    @test tspan2dtmin((1, 2)) === 0
    @test approxoftype(tspan2dtmin((1 // 10, 2 // 10)), 1 // 2^33)
    @test approxoftype(tspan2dtmin((2 // 10, Inf)), eps(1.0))
    @test approxoftype(tspan2dtmin((2 // 1, Inf)), eps(2.0))
    @test approxoftype(tspan2dtmin((0, Inf)), eps(1.0))
    @test approxoftype(tspan2dtmin((0.0, Inf)), eps(1.0))
    @test approxoftype(tspan2dtmin((0.0, 1.0e-6)), eps(1.0e-6))
    @test approxoftype(tspan2dtmin((1.0e6, 1.0e6 + 1)), eps(1.0e6))
    @test_throws ArgumentError tspan2dtmin((Inf, 100.0))
    @test approxoftype(tspan2dtmin((0.0f0, 1.0f5); use_end_time = false), eps(1.0f0))
    @test approxoftype(timedepentdtmin(10.0f0, eps(1.0f0)), eps(10.0f0))
    @test approxoftype(timedepentdtmin(10, eps(1.0f0)), eps(1.0f0))
end

@testset "prob2dtmin" begin
    @test prob2dtmin((0.0, 10.0), 1.0, false) == eps(Float64)
    @test prob2dtmin((0.0f0, 10.0f0), 1.0f0, false) == eps(Float32)
    @test prob2dtmin((0.0, 10.0), ForwardDiff.Dual(1.0), false) == eps(Float64)
end

@testset "_rate_prototype" begin
    @test _rate_prototype([1.0f0], 1.0, 1.0) isa Vector{Float32}
    td = Dual{Tag{typeof(+), Float64}}(2.0, 1.0)
    @test _rate_prototype([1.0f0], td, td) isa Vector{Float32}
    xd = [Dual{Tag{typeof(+), Float32}}(2.0, 1.0)]
    @test _rate_prototype(xd, 1.0, 1.0) isa typeof(xd)
    @test _rate_prototype([u"1f0m"], u"1.0s", 1.0) isa typeof([u"1f0m/s"])
end

using DiffEqBase, Test
using Distributions

@test DiffEqBase.promote_tspan((0.0, 1.0)) == (0.0, 1.0)
@test DiffEqBase.promote_tspan((0, 1.0)) == (0.0, 1.0)
@test DiffEqBase.promote_tspan(1.0) == (0.0, 1.0)
@test DiffEqBase.promote_tspan(nothing) == (nothing, nothing)
@test DiffEqBase.promote_tspan(Real[0, 1.0]) == (0.0, 1.0)

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/1776
# promote_tspan(u0, p, tspan, prob, kwargs)
@test DiffEqBase.promote_tspan((0, 1)) == (0, 1)
@test DiffEqBase.promote_tspan(nothing, nothing, (0, 1), nothing, (dt = 1,)) == (0, 1)
@test DiffEqBase.promote_tspan(nothing, nothing, (0, 1), nothing, (dt = 1 / 2,)) ==
    (0.0, 1.0)

prob = ODEProblem((u, p, t) -> u, (p, t0) -> p[1], (p) -> (0.0, p[2]), (2.0, 1.0))
prob2 = DiffEqBase.get_concrete_problem(prob, true)

@test prob2.u0 == 2.0
@test prob2.tspan == (0.0, 1.0)

prob = ODEProblem((u, p, t) -> u, (p, t) -> Normal(p, 1), (0.0, 1.0), 1.0)
prob2 = DiffEqBase.get_concrete_problem(prob, true)
@test typeof(prob2.u0) == Float64

kwargs(; kw...) = kw
prob = ODEProblem((u, p, t) -> u, 1.0, nothing)
prob2 = DiffEqBase.get_concrete_problem(prob, true, tspan = (1.2, 3.4))
@test prob2.tspan === (1.2, 3.4)

prob = ODEProblem((u, p, t) -> u, nothing, nothing)
prob2 = DiffEqBase.get_concrete_problem(prob, true, u0 = 1.01, tspan = (1.2, 3.4))
@test prob2.u0 === 1.01

prob = ODEProblem((u, p, t) -> u, 1.0, (0, 1))
prob2 = DiffEqBase.get_concrete_problem(prob, true)
@test prob2.tspan == (0.0, 1.0)

prob = DDEProblem(
    (u, h, p, t) -> -h(p, t - p[1]), (p, t0) -> p[2], (p, t) -> 0,
    (p) -> (0.0, p[3]), (1.0, 2.0, 3.0); constant_lags = (p) -> [p[1]]
)
prob2 = DiffEqBase.get_concrete_problem(prob, true)

@test prob2.u0 == 2.0
@test prob2.tspan == (0.0, 3.0)
@test prob2.constant_lags == [1.0]

using OrdinaryDiffEq, ForwardDiff, FiniteDiff, SciMLSensitivity, Zygote, Test

# Regression test for ForwardDiff AD through ContinuousCallback root-finding.
# This catches issues like https://github.com/SciML/DiffEqBase.jl/issues/1275
# where the bracketing solver (e.g. ModAB) fails to handle ForwardDiff.Dual numbers
# correctly during event detection, producing NaN derivatives.

@testset "ForwardDiff AD through ContinuousCallback" begin
    function f(du, u, p, t)
        du[1] = u[2]
        du[2] = -p[1]
    end

    # Callback triggers when u[1] crosses zero (bouncing ball condition)
    # and modifies the state (reverses velocity with coefficient of restitution)
    function condition(u, t, integrator)
        u[1]
    end

    function affect!(integrator)
        integrator.u[2] = -integrator.p[2] * integrator.u[2]
    end

    cb = ContinuousCallback(condition, affect!)

    function solve_and_extract(p)
        u0 = [1.0, 0.0]
        tspan = (0.0, 3.0)
        prob = ODEProblem(f, u0, tspan, p)
        sol = solve(prob, Tsit5(), callback = cb, abstol = 1.0e-12, reltol = 1.0e-12)
        return [sol.u[end][1], sol.u[end][2]]
    end

    # Test over a range of parameter values to cover different callback timings
    @testset "p1 = $p1" for p1 in 0.5:0.5:5.0
        p = [p1, 0.8]
        dijac = ForwardDiff.jacobian(solve_and_extract, p)
        findiff = FiniteDiff.finite_difference_jacobian(solve_and_extract, p)
        @test all(isfinite, dijac)
        @test dijac ≈ findiff rtol = 1.0e-5
    end
end

# Test with mutable closure (from OrdinaryDiffEq AD tests pattern)
@testset "ForwardDiff AD through ContinuousCallback with mutable closure" begin
    function f2(du, u, p, t)
        du[1] = -p[1] * u[1]
        du[2] = p[1] * u[1] - u[2]
    end

    called = Ref(false)

    function condition2(u, t, integrator)
        u[1] - 0.5
    end

    function affect2!(integrator)
        called[] = true
        integrator.p[2] = zero(integrator.p[2])
    end

    cb2 = ContinuousCallback(condition2, affect2!)

    function solve_with_closure(x)
        called[] = false
        u0 = [1.0, 0.0]
        tspan = (0.0, 5.0)
        prob = ODEProblem(f2, u0, tspan, copy(x))
        sol = solve(prob, Tsit5(), callback = cb2, abstol = 1.0e-12, reltol = 1.0e-12)
        return [sol.u[end][1], sol.u[end][2]]
    end

    @testset "x = $x" for x in 0.1:0.1:1.0
        p = [x, 1.0]
        dijac = ForwardDiff.jacobian(solve_with_closure, p)
        findiff = FiniteDiff.finite_difference_jacobian(solve_with_closure, p)
        @test all(isfinite, dijac)
        @test dijac ≈ findiff rtol = 1.0e-5
    end
end

# Regression test for Zygote/ReverseDiff AD through ContinuousCallback.
# ReverseDiff.TrackedReal cannot be converted to Float64, so storing the
# callback residual in integrator.last_event_error requires unwrapping
# via `value()`.
@testset "Zygote AD through ContinuousCallback" begin
    function f_zyg(du, u, p, t)
        du[1] = u[2]
        du[2] = -p[1]
    end

    function condition_zyg(u, t, integrator)
        u[1]
    end

    function affect_zyg!(integrator)
        integrator.u[2] = -integrator.p[2] * integrator.u[2]
    end

    cb_zyg = ContinuousCallback(condition_zyg, affect_zyg!)

    function loss_zyg(p)
        prob = ODEProblem(f_zyg, [1.0, 0.0], (0.0, 1.0), p)
        sol = solve(prob, Tsit5(), callback = cb_zyg,
            abstol = 1e-14, reltol = 1e-14, save_everystep = false)
        return sum(sol.u[end])
    end

    p = [9.8, 0.8]
    grad = Zygote.gradient(loss_zyg, p)[1]
    findiff_grad = FiniteDiff.finite_difference_gradient(loss_zyg, p)
    @test all(isfinite, grad)
    @test grad ≈ findiff_grad rtol = 1e-3
end

# This is a simple example showing how forward and backward Euler
# could be wrapped

module InternalEuler

using DiffEqBase, LinearAlgebra

# make a algorithm type
abstract type EulerAlgs <: DiffEqBase.AbstractODEAlgorithm end

struct FwdEulerAlg <: EulerAlgs end

struct BwdEulerAlg <: EulerAlgs end

function DiffEqBase.solve(
        prob::DiffEqBase.AbstractODEProblem{uType, tType, isinplace},
        Alg::FwdEulerAlg;
        dt = (prob.tspan[2] - prob.tspan[1]) / 100,
        tstops = tType[],
        kwargs...
    ) where {uType, tType, isinplace}
    u0 = prob.u0
    f = prob.f
    tspan = prob.tspan
    p = prob.p

    if isempty(tstops)
        tstops = tspan[1]:dt:tspan[2]
    end
    @assert tstops[1] == tspan[1]

    nt = length(tstops)
    out = Vector{uType}(undef, nt)
    out[1] = copy(u0)
    tmp = copy(u0)
    for i in 2:nt
        t = tstops[i]
        dt = t - tstops[i - 1]
        if isinplace
            f(tmp, out[i - 1], p, t)
            out[i] = out[i - 1] + dt * tmp
        else
            out[i] = out[i - 1] + dt * f(out[i - 1], p, t)
        end
    end
    # make solution type
    return DiffEqBase.build_solution(prob, Alg, tstops, out)
end

function DiffEqBase.solve(
        prob::DiffEqBase.AbstractODEProblem{uType, tType, isinplace},
        Alg::BwdEulerAlg;
        dt = (prob.tspan[2] - prob.tspan[1]) / 100,
        tstops = tType[],
        tol = 1.0e-5,
        maxiter = 100,
        kwargs...
    ) where {uType, tType, isinplace}
    u0 = prob.u0
    f = prob.f
    tspan = prob.tspan
    p = prob.p
    # TODO: fix numparameters as it picks up the Jacobian
    #    @assert !isinplace "Only out of place functions supported"
    @assert DiffEqBase.has_jac(f) "Provide Jacobian as f(::Val{:jac}, ...)"

    if isempty(tstops)
        tstops = tspan[1]:dt:tspan[2]
    end
    @assert tstops[1] == tspan[1]

    nt = length(tstops)
    out = Vector{uType}(undef, nt)
    out[1] = copy(u0)
    for i in 2:nt
        t = tstops[i]
        dt = t - tstops[i - 1]
        out[i] = newton(t, dt, out[i - 1], p, f, f.jac, tol, maxiter)
    end
    # make solution type
    return DiffEqBase.build_solution(prob, Alg, tstops, out)
end

function newton(t, dt, u_last, p, f, jac, tol, maxiter)
    res = (u) -> u - u_last - dt * f(u, p, t)
    u = u_last + dt * f(u_last, p, t) # forward Euler step as first guess
    for i in 1:maxiter
        du = -(I - dt * jac(u, p, t)) \ res(u)
        u += du
        norm(du, Inf) < tol && return u
    end
    error("Newton not converged")
end

end

@static if isdefined(SciMLBase, :DEStats)
    const Stats = SciMLBase.DEStats
else
    """
    $(TYPEDEF)

    Statistics from the differential equation solver about the solution process.

    ## Fields

    - nf: Number of function evaluations. If the differential equation is a split function,
      such as a `SplitFunction` for implicit-explicit (IMEX) integration, then `nf` is the
      number of function evaluations for the first function (the implicit function)
    - nf2: If the differential equation is a split function, such as a `SplitFunction`
      for implicit-explicit (IMEX) integration, then `nf2` is the number of function
      evaluations for the second function, i.e. the function treated explicitly. Otherwise
      it is zero.
    - nw: The number of W=I-gamma*J (or W=I/gamma-J) matrices constructed during the solving
      process.
    - nsolve: The number of linear solves `W\b` required for the integration.
    - njacs: Number of Jacobians calculated during the integration.
    - nnonliniter: Total number of iterations for the nonlinear solvers.
    - nnonlinconvfail: Number of nonlinear solver convergence failures.
    - ncondition: Number of calls to the condition function for callbacks.
    - naccept: Number of accepted steps.
    - nreject: Number of rejected steps.
    - maxeig: Maximum eigenvalue over the solution. This is only computed if the
      method is an auto-switching algorithm.
    """
    mutable struct Stats
        nf::Int
        nf2::Int
        nw::Int
        nsolve::Int
        njacs::Int
        nnonliniter::Int
        nnonlinconvfail::Int
        ncondition::Int
        naccept::Int
        nreject::Int
        maxeig::Float64
    end

    Base.@deprecate_binding DEStats Stats false

    Stats(x::Int = -1) = Stats(x, x, x, x, x, x, x, x, x, x, 0.0)

    function Base.show(io::IO, s::Stats)
        println(io, summary(s))
        @printf io "%-50s %-d\n" "Number of function 1 evaluations:" s.nf
        @printf io "%-50s %-d\n" "Number of function 2 evaluations:" s.nf2
        @printf io "%-50s %-d\n" "Number of W matrix evaluations:" s.nw
        @printf io "%-50s %-d\n" "Number of linear solves:" s.nsolve
        @printf io "%-50s %-d\n" "Number of Jacobians created:" s.njacs
        @printf io "%-50s %-d\n" "Number of nonlinear solver iterations:" s.nnonliniter
        @printf io "%-50s %-d\n" "Number of nonlinear solver convergence failures:" s.nnonlinconvfail
        @printf io "%-50s %-d\n" "Number of rootfind condition calls:" s.ncondition
        @printf io "%-50s %-d\n" "Number of accepted steps:" s.naccept
        @printf io "%-50s %-d" "Number of rejected steps:" s.nreject
        iszero(s.maxeig) || @printf io "\n%-50s %-d" "Maximum eigenvalue recorded:" s.maxeig
    end
end

using OrdinaryDiffEq, Test
function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 1.0)
prob = ODEProblem(lorenz, u0, tspan)
sol = solve(prob, Tsit5(), save_idxs = 1)
@inferred solve(prob, Tsit5())
@inferred solve(prob, Tsit5(), save_idxs = 1)
@test_broken @inferred(remake(prob, u0 = Float32[1.0; 0.0; 0.0])) ==
    remake(prob, u0 = Float32[1.0; 0.0; 0.0])
@test_broken @inferred(solve(prob, Tsit5(), u0 = Float32[1.0; 0.0; 0.0])) ==
    solve(prob, Tsit5(), u0 = Float32[1.0; 0.0; 0.0])

prob = ODEProblem{true, SciMLBase.FullSpecialize}(lorenz, u0, tspan)

@inferred SciMLBase.wrapfun_iip(prob.f, (u0, u0, Float64[], tspan[1]))
@inferred remake(prob, u0 = [1.0; 0.0; 0.0])
@inferred remake(prob, u0 = Float32[1.0; 0.0; 0.0])
@test_broken @inferred(solve(prob, Tsit5(), u0 = Float32[1.0; 0.0; 0.0])) ==
    solve(prob, Tsit5(), u0 = Float32[1.0; 0.0; 0.0])

prob = ODEProblem(lorenz, Float32[1.0; 0.0; 0.0], tspan)
@inferred solve(prob, Tsit5(), save_idxs = 1)
@test_broken @inferred(solve(prob, Tsit5(), u0 = [1.0; 0.0; 0.0])) ==
    solve(prob, Tsit5(), u0 = [1.0; 0.0; 0.0])
remake(prob, u0 = [1.0; 0.0; 0.0])

u0_32 = Float32[1.0; 0.0; 0.0]
@inferred SciMLBase.wrapfun_iip(prob.f, (u0_32, u0_32, Float32[], tspan[1]))
@test_broken @inferred(
    ODEFunction{
        isinplace(prob), SciMLBase.FunctionWrapperSpecialize,
    }(prob.f)
) ==
    ODEFunction{isinplace(prob), SciMLBase.FunctionWrapperSpecialize}(prob.f)
@inferred remake(prob, u0 = [1.0; 0.0; 0.0])
@test_broken @inferred(solve(prob, Tsit5(), u0 = [1.0; 0.0; 0.0])) ==
    solve(prob, Tsit5(), u0 = [1.0; 0.0; 0.0])

function f(du, u, p, t)
    du[1] = p.a
    return du[2] = p.b
end

const alg = Tsit5()

function solve_ode(f::F, p::P, ensemblealg; kwargs...) where {F, P}
    tspan = (0.0, 1.0)
    Δt = tspan[2] - tspan[1]
    dt = 1 / 252
    nodes = Int(ceil(Δt / dt) + 1)
    t = T = [tspan[1] + (i - 1) * dt for i in 1:nodes]

    # if I do not set {true}, prob type Any...
    prob = ODEProblem{true}(f, [0.0, 0.0], tspan, p)
    # prob = ODEProblem(f, [0., 0.], tspan, p)

    prob_func = (prob, i, repeat) -> begin
        remake(prob, tspan = (T[i + 1], t[1]))
    end

    # ensemble problem
    odes = EnsembleProblem(prob, prob_func = prob_func)

    sol = OrdinaryDiffEq.solve(
        odes, OrdinaryDiffEq.Tsit5(), ensemblealg,
        trajectories = nodes - 1, saveat = -dt;
        kwargs...
    )

    return sol
end
@inferred solve_ode(f, (a = 1, b = 1), EnsembleSerial())
@inferred solve_ode(f, (a = 1, b = 1), EnsembleThreads())
@test_broken @inferred(solve_ode(f, (a = 1, b = 1), EnsembleDistributed())) ==
    solve_ode(f, (a = 1, b = 1), EnsembleDistributed())
@test_broken @inferred(solve_ode(f, (a = 1, b = 1), EnsembleSplitThreads())) ==
    solve_ode(f, (a = 1, b = 1), EnsembleSplitThreads())
@inferred solve_ode(f, (a = 1, b = 1), EnsembleSerial(), save_idxs = 1)
@inferred solve_ode(f, (a = 1, b = 1), EnsembleThreads(), save_idxs = 1)
@test_broken @inferred(
    solve_ode(
        f, (a = 1, b = 1), EnsembleDistributed(), save_idxs = 1
    )
) ==
    solve_ode(f, (a = 1, b = 1), EnsembleDistributed(), save_idxs = 1)
@test_broken @inferred(
    solve_ode(
        f, (a = 1, b = 1), EnsembleSplitThreads(), save_idxs = 1
    )
) ==
    solve_ode(f, (a = 1, b = 1), EnsembleSplitThreads(), save_idxs = 1)

using StochasticDiffEq, Test
u0 = 1 / 2
ff(u, p, t) = u
gg(u, p, t) = u
dt = 1 // 2^(4)
tspan = (0.0, 1.0)
prob = SDEProblem(ff, gg, u0, (0.0, 1.0))
sol = solve(prob, EM(), dt = dt)
@inferred solve(prob, EM(), dt = dt)
@inferred solve(prob, EM(), dt = dt, save_idxs = 1)

# the following are setup per how integrators are implemented in OrdinaryDiffEq and
# StochasticDiffEq and provide dispatch points that JumpProcesses and others can use.

function get_tstops(integ::DEIntegrator)
    error("get_tstops not implemented for integrators of type $(nameof(typeof(integ)))")
end
function get_tstops_array(integ::DEIntegrator)
    error("get_tstops_array not implemented for integrators of type $(nameof(typeof(integ)))")
end
function get_tstops_max(integ::DEIntegrator)
    error("get_tstops_max not implemented for integrators of type $(nameof(typeof(integ)))")
end

using Test, RecursiveArrayTools, StaticArrays, ForwardDiff

using DiffEqBase: UNITLESS_ABS2, recursive_length, ODE_DEFAULT_NORM

@test recursive_length(1.0) == 1

n = UNITLESS_ABS2(3.0 + 4.0im)
@test n == 25.0
@test typeof(n) <: Real

@test ODE_DEFAULT_NORM(3.0 + 4.0im, 0.0) == 5.0

u1 = ones(3)
@test UNITLESS_ABS2(u1) == 3.0
@test recursive_length(u1) == 3
@test ODE_DEFAULT_NORM(u1, 0.0) == 1.0

u2 = [SA[1.0 1.0; 1.0 1.0] for i in 1:3]
@test UNITLESS_ABS2(u2) == 12.0
@test recursive_length(u2) == 12
@test ODE_DEFAULT_NORM(u2, 0.0) == 1.0

u3 = VectorOfArray([ones(5), ones(5)])
@test UNITLESS_ABS2(u3) == 10.0
@test recursive_length(u3) == 10
@test ODE_DEFAULT_NORM(u3, 0.0) == 1.0

u4 = ArrayPartition(u1, u2, u3)
@test UNITLESS_ABS2(u4) == 25.0
@test recursive_length(u4) == 25
@test ODE_DEFAULT_NORM(u4, 0.0) == 1.0

u5 = ArrayPartition(u4, u4)
@test UNITLESS_ABS2(u5) == 50.0
@test recursive_length(u5) == 50
@test ODE_DEFAULT_NORM(u5, 0.0) == 1.0

u6 = ArrayPartition(1.0, 1.0)
@test UNITLESS_ABS2(u6) == 2.0
@test recursive_length(u6) == 2
@test ODE_DEFAULT_NORM(u6, 0.0) == 1.0

u7 = ArrayPartition(u1, ones(0))
@test UNITLESS_ABS2(u7) == 3.0
@test recursive_length(u7) == 3
@test ODE_DEFAULT_NORM(u7, 0.0) == 1.0

@test ODE_DEFAULT_NORM(Float64[], 0.0) == 0.0

# https://github.com/SciML/DiffEqBase.jl/issues/1023
u8 = ForwardDiff.Dual{:b}.(ForwardDiff.Dual{:a}.([1.0, 2.0, 3.0], true), true)
u8_ref = 1.2909944487358056
@test ODE_DEFAULT_NORM(u8, 4.0) isa Float64
@test ODE_DEFAULT_NORM(u8, 4.0) ≈ u8_ref
@test ODE_DEFAULT_NORM(u8, ForwardDiff.Dual{:b}(4.0, true)) isa Float64
@test ODE_DEFAULT_NORM(u8, ForwardDiff.Dual{:b}(4.0, true)) ≈ u8_ref

using DiffEqBase
using SciMLBase: @add_kwonly, add_kwonly
using LinearAlgebra, Test

@add_kwonly function f(a, b; c = 3, d = 4)
    (a, b, c, d)
end
@test f(1, 2) == (1, 2, 3, 4)
@test f(a = 1, b = 2) == (1, 2, 3, 4)
@test_throws ErrorException f()

@add_kwonly g(a, b; c = 3, d = 4) = (a, b, c, d)
@test g(1, 2) == (1, 2, 3, 4)
@test g(a = 1, b = 2) == (1, 2, 3, 4)

@add_kwonly h(; c = 3, d = 4) = (c, d)
@test h() == (3, 4)

@test_throws ErrorException add_kwonly(:(i(c = 3, d = 4) = (c, d)))

dprob = DiscreteProblem((u, p, t) -> 2u, 0.5, (0.0, 1.0))
@test remake(dprob) == dprob
@test remake(dprob; u0 = 1.0).u0 == 1.0

oprob = ODEProblem((u, p, t) -> 2u, 0.5, (0.0, 1.0))
@test_broken remake(oprob) == oprob # fails due to change to mutable struct due to === fallback
@test remake(oprob; u0 = 1.0).u0 == 1.0

sprob = SDEProblem((u, p, t) -> 2u, (u, p, t) -> 2u, 0.5, (0.0, 1.0))
@test remake(sprob) == sprob
@test remake(sprob; u0 = 1.0).u0 == 1.0

daeprob = DAEProblem((du, u, p, t) -> du - 2u, 0.5, 0.5, (0.0, 1.0))
@test remake(daeprob) == daeprob
@test remake(daeprob; u0 = 1.0).u0 == 1.0

ddeprob = DDEProblem((du, u, h, p, t) -> -2u, 0.5, (p, t) -> 0.0, (0.0, 1.0))
@test remake(ddeprob) == ddeprob
@test remake(daeprob; u0 = 1.0).u0 == 1.0

function f(du, u, p, t)
    du[1] = 0.2u[1]
    return du[2] = 0.4u[2]
end
u0 = ones(2)
tspan = (0, 1.0)

# Create a ODEProblem and test remake:
prob1 = SplitODEProblem(f, f, u0, tspan, Dict(), callback = nothing)
prob2 = @inferred remake(prob1; u0 = prob1.u0 .+ 1)
@test prob1.f === prob2.f
@test prob1.p === prob2.p
@test prob1.u0 .+ 1 ≈ prob2.u0
@test prob1.tspan == prob2.tspan
@test prob1.kwargs[:callback] === prob2.kwargs[:callback]
@test prob1.problem_type === prob2.problem_type

prob2 = @inferred remake(prob1; u0 = prob1.u0 .+ 1, callback = :test)
@test prob2.kwargs[:callback] == :test

# Test remake with SplitFunction:
prob1 = SplitODEProblem((u, p, t) -> u / 2, (u, p, t) -> 2u, 1.0, (0.0, 1.0))
prob2 = remake(
    prob1;  # prob1 is a ODEProblem
    f = remake(
        prob1.f;  # prob1.f is a SplitFunction
        f2 = (u, p, t) -> 3u
    )
)

# Test remake with NoiseProblem (a struct w/o isinplace type parameter):
struct DummyNoiseProcess <: SciMLBase.AbstractNoiseProcess{Int, 1, Nothing, true}
    dummy::Any
end
tspan1 = (0.0, 1.0)
tspan2 = (0.0, 2.0)
noise1 = NoiseProblem(DummyNoiseProcess(Dict()), tspan1);
noise2 = remake(noise1; tspan = tspan2);
@test noise1.noise === noise2.noise
@test noise1.tspan == tspan1
@test noise2.tspan == tspan2
@test noise1.tspan != noise2.tspan

# Test remake with TwoPointBVPFunction (manually defined):
f1 = SciMLBase.TwoPointBVPFunction((u, p, t) -> 1, ((u_a, p) -> 2, (u_b, p) -> 2))
@test_broken f2 = remake(f1; bc = ((u_a, p) -> 3, (u_b, p) -> 4))
@test_broken f1.bc() == 1
@test_broken f2.bc() == 2

# Testing remake for no recompile
u0 = [0; 2.0]
tspan = (0.0, 6.3)
prob = ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}((du, u, p, t) -> 2u, u0, tspan)

prob2 = remake(prob; u0 = [1; 2])
@test prob2.u0 == [1; 2]
@test prob2.f.f isa SciMLBase.FunctionWrappersWrappers.FunctionWrappersWrapper
prob2 = remake(prob; p = (1, 2))
@test remake(prob; p = (1, 2)).p == (1, 2)
@test prob2.f.f isa SciMLBase.FunctionWrappersWrappers.FunctionWrappersWrapper
SciMLBase.unwrapped_f(prob2.f)

using Test
using DiffEqBase
using DynamicQuantities
using LinearAlgebra

@testset "DiffEqBaseDynamicQuantitiesExt" begin
    # Basic quantity hooks
    q = 3.0u"m"
    @test DiffEqBase.ODE_DEFAULT_NORM(q, 0.0) == 3.0

    qc = (3.0 + 4.0im)u"m"
    @test DiffEqBase.UNITLESS_ABS2(qc) == 25.0

    r = DiffEqBase._rate_prototype(2.0u"m", 4.0u"s", 1)
    @test isapprox(ustrip(r), 2.0)
    @test oneunit(r) == oneunit(1.0u"m") / oneunit(1.0u"s")

    dt = DiffEqBase.timedepentdtmin(1.0u"s", 1.0u"ms")
    @test isapprox(ustrip(dt), 0.001)
    @test oneunit(dt) == oneunit(1.0u"s")

    # Factorization bridge for Quantity matrices
    A = [2.0u"m" 0.0u"m"; 0.0u"m" 4.0u"m"]
    b = [4.0u"m", 8.0u"m"]

    W = DiffEqBase.default_factorize(A)
    x = W \ b
    @test maximum(abs.(ustrip.(A * x .- b))) ≤ 1.0e-12

    x2 = similar(b)
    ldiv!(x2, W, b)
    @test maximum(abs.(ustrip.(A * x2 .- b))) ≤ 1.0e-12

    # _infer_ut fallback when all entries are zero
    Az = fill(0.0u"m", 2, 2)
    Wz = DiffEqBase.default_factorize(Az)
    @test Wz.ut == oneunit(1.0)

    # empty-matrix path (coverage + sanity)
    A0 = Matrix{typeof(1.0u"m")}(undef, 0, 0)
    W0 = DiffEqBase.default_factorize(A0)
    b0 = typeof(1.0u"m")[]
    @test length(W0 \ b0) == 0
end

function abs2_and_sum(x, y)
    return reduce(+, x, init = zero(real(value(eltype(x))))) +
        reduce(+, y, init = zero(real(value(eltype(y)))))
end
UNITLESS_ABS2(x::Number) = abs2(x)

function UNITLESS_ABS2(x::AbstractArray{<:Number})
    return mapreduce(UNITLESS_ABS2, +, x, init = zero(real(value(eltype(x)))))
end

function UNITLESS_ABS2(x::AbstractArray)
    return mapreduce(UNITLESS_ABS2, abs2_and_sum, x, init = zero(real(value(eltype(x)))))
end
function UNITLESS_ABS2(x::RecursiveArrayTools.AbstractVectorOfArray)
    return mapreduce(UNITLESS_ABS2, abs2_and_sum, x.u, init = zero(real(value(eltype(x)))))
end
function UNITLESS_ABS2(x::RecursiveArrayTools.ArrayPartition)
    return mapreduce(UNITLESS_ABS2, abs2_and_sum, x.x, init = zero(real(value(eltype(x)))))
end

UNITLESS_ABS2(f::F, x::Number) where {F} = abs2(f(x))
function UNITLESS_ABS2(f::F, x::AbstractArray) where {F}
    return mapreduce(
        UNITLESS_ABS2 ∘ f, abs2_and_sum, x;
        init = zero(real(value(eltype(x))))
    )
end
function UNITLESS_ABS2(f::F, x::RecursiveArrayTools.ArrayPartition) where {F}
    return mapreduce(
        UNITLESS_ABS2 ∘ f, abs2_and_sum, x.x;
        init = zero(real(value(eltype(x))))
    )
end

recursive_length(u::AbstractArray{<:Number}) = length(u)
recursive_length(u::Number) = length(u)
recursive_length(u::AbstractArray{<:AbstractArray}) = sum(recursive_length, u)
recursive_length(u::RecursiveArrayTools.ArrayPartition) = sum(recursive_length, u.x)
recursive_length(u::RecursiveArrayTools.VectorOfArray) = sum(recursive_length, u.u)
function recursive_length(
        u::AbstractArray{
            <:StaticArraysCore.StaticArray{S, <:Number},
        }
    ) where {S}
    return prod(Size(eltype(u))) * length(u)
end

ODE_DEFAULT_NORM(u::Union{AbstractFloat, Complex}, t) = @fastmath abs(u)

function ODE_DEFAULT_NORM(f::F, u::Union{AbstractFloat, Complex}, t) where {F}
    return @fastmath abs(f(u))
end

function ODE_DEFAULT_NORM(u::Array{T}, t) where {T <: Union{AbstractFloat, Complex}}
    x = zero(T)
    @inbounds @fastmath for ui in u
        x += abs2(ui)
    end
    return Base.FastMath.sqrt_fast(real(x) / max(length(u), 1))
end

function ODE_DEFAULT_NORM(
        f::F,
        u::Union{Array{T}, Iterators.Zip{<:Tuple{Vararg{Array{T}}}}},
        t
    ) where {F, T <: Union{AbstractFloat, Complex}}
    x = zero(T)
    @inbounds @fastmath for ui in u
        x += abs2(f(ui))
    end
    return Base.FastMath.sqrt_fast(real(x) / max(length(u), 1))
end

function ODE_DEFAULT_NORM(
        u::StaticArraysCore.StaticArray{<:Tuple, T},
        t
    ) where {T <: Union{AbstractFloat, Complex}}
    return Base.FastMath.sqrt_fast(real(sum(abs2, u)) / max(length(u), 1))
end

function ODE_DEFAULT_NORM(
        f::F, u::StaticArraysCore.StaticArray{<:Tuple, T},
        t
    ) where {F, T <: Union{AbstractFloat, Complex}}
    return Base.FastMath.sqrt_fast(real(sum(abs2 ∘ f, u)) / max(length(u), 1))
end

function ODE_DEFAULT_NORM(
        u::Union{
            AbstractArray,
            RecursiveArrayTools.AbstractVectorOfArray,
        },
        t
    )
    return Base.FastMath.sqrt_fast(UNITLESS_ABS2(u) / max(recursive_length(u), 1))
end

function ODE_DEFAULT_NORM(f::F, u::AbstractArray, t) where {F}
    return Base.FastMath.sqrt_fast(UNITLESS_ABS2(f, u) / max(recursive_length(u), 1))
end

ODE_DEFAULT_NORM(u, t) = norm(u)
ODE_DEFAULT_NORM(f::F, u, t) where {F} = norm(f.(u))

ODE_DEFAULT_ISOUTOFDOMAIN(u, p, t) = false
function ODE_DEFAULT_PROG_MESSAGE(dt, u::Array, p, t)
    tmp = u[1]
    for i in eachindex(u)
        tmp = ifelse(abs(u[i]) > abs(tmp), u[i], tmp)
    end
    return "dt=" * string(dt) * "\nt=" * string(t) * "\nmax u=" * string(tmp)
end
function ODE_DEFAULT_PROG_MESSAGE(dt, u, p, t)
    return "dt=" * string(dt) * "\nt=" * string(t) * "\nmax u=" * string(maximum(abs.(u)))
end

NAN_CHECK(x::Number) = isnan(x)
NAN_CHECK(x::Enum) = false
function NAN_CHECK(x::Union{AbstractArray, RecursiveArrayTools.AbstractVectorOfArray})
    return any(
        NAN_CHECK, x
    )
end
NAN_CHECK(x::RecursiveArrayTools.ArrayPartition) = any(NAN_CHECK, x.x)

INFINITE_OR_GIANT(x::Number) = !isfinite(x)
function INFINITE_OR_GIANT(
        x::Union{
            AbstractArray, RecursiveArrayTools.AbstractVectorOfArray,
        }
    )
    return any(
        INFINITE_OR_GIANT, x
    )
end
INFINITE_OR_GIANT(x::RecursiveArrayTools.ArrayPartition) = any(INFINITE_OR_GIANT, x.x)
ODE_DEFAULT_UNSTABLE_CHECK(dt, u, p, t) = false
function ODE_DEFAULT_UNSTABLE_CHECK(dt, u::Union{Number, AbstractArray{<:Number}}, p, t)
    return INFINITE_OR_GIANT(u)
end

using DiffEqBase, DiffEqBase.InternalEuler

# Try it
ff = ODEFunction(
    (u, p, t) -> u,
    jac = (u, p, t) -> 1.0,
    analytic = (u0, p, t) -> u0 * exp(t)
)

dt = 0.01
prob = ODEProblem(ff, 1.0, (0.0, 1.0))
sol = solve(prob, InternalEuler.FwdEulerAlg(), tstops = 0:dt:1)
sol2 = solve(prob, InternalEuler.BwdEulerAlg(), tstops = 0:dt:1)

#using Plots
#plot(sol)
#plot!(sol2)
#plot!(sol2, plot_analytic=true)

#using DiffEqDevTools
#dts = 1./2.^(8:-1:4)
#sim = test_convergence(dts,p2,BwdEulerAlg())
#@show sim.𝒪est[:final]
#plot(sim)

using OrdinaryDiffEq, DiffEqBase, Test

# Basic auto callback merging test
do_nothing = DiscreteCallback(
    (u, t, integrator) -> true,
    integrator -> nothing
)
problem = ODEProblem(
    (u, p, t) -> -u,
    1.0, (0.0, 1.0),
    callback = do_nothing
)
solve(
    problem, Euler(),
    dt = 0.1,
    callback = do_nothing
)

@testset "Callback merging through solve" begin
    # Test that callbacks passed to problem constructor are properly merged
    # with callbacks passed to solve

    function lorenz!(du, u, p, t)
        du[1] = 10.0(u[2] - u[1])
        du[2] = u[1] * (28.0 - u[3]) - u[2]
        du[3] = u[1] * u[2] - (8 / 3) * u[3]
    end
    u0 = [1.0, 0.0, 0.0]
    tspan = (0.0, 1.0)

    # Create two callbacks that track when they're called
    cb1_called = Ref(false)
    condition1(u, t, integrator) = t - 0.3
    affect1!(integrator) = (cb1_called[] = true)
    cb1 = ContinuousCallback(condition1, affect1!)

    cb2_called = Ref(false)
    condition2(u, t, integrator) = t - 0.7
    affect2!(integrator) = (cb2_called[] = true)
    cb2 = ContinuousCallback(condition2, affect2!)

    # Test 1: Callback in problem constructor only
    cb1_called[] = false
    prob = ODEProblem(lorenz!, u0, tspan; callback = cb1)
    sol = solve(prob, Tsit5())
    @test cb1_called[]
    @test sol.t[end] ≈ 1.0

    # Test 2: Callback in solve only
    cb2_called[] = false
    prob = ODEProblem(lorenz!, u0, tspan)
    sol = solve(prob, Tsit5(); callback = cb2)
    @test cb2_called[]
    @test sol.t[end] ≈ 1.0

    # Test 3: Callbacks in both (should merge by default)
    cb1_called[] = false
    cb2_called[] = false
    prob = ODEProblem(lorenz!, u0, tspan; callback = cb1)
    sol = solve(prob, Tsit5(); callback = cb2)
    @test cb1_called[]
    @test cb2_called[]
    @test sol.t[end] ≈ 1.0

    # Test 4: merge_callbacks = false (solve callback should override)
    cb1_called[] = false
    cb2_called[] = false
    prob = ODEProblem(lorenz!, u0, tspan; callback = cb1)
    sol = solve(prob, Tsit5(); callback = cb2, merge_callbacks = false)
    @test !cb1_called[]  # cb1 should not be called
    @test cb2_called[]   # cb2 should be called
    @test sol.t[end] ≈ 1.0
end

@testset "Callback merging through init" begin
    # Test that callbacks are properly merged when using init instead of solve

    function simple!(du, u, p, t)
        du[1] = -u[1]
    end
    u0 = [1.0]
    tspan = (0.0, 1.0)

    cb1_called = Ref(false)
    condition1(u, t, integrator) = t - 0.3
    affect1!(integrator) = (cb1_called[] = true)
    cb1 = ContinuousCallback(condition1, affect1!)

    cb2_called = Ref(false)
    condition2(u, t, integrator) = t - 0.7
    affect2!(integrator) = (cb2_called[] = true)
    cb2 = ContinuousCallback(condition2, affect2!)

    # Test: Callbacks in both problem and init (should merge)
    cb1_called[] = false
    cb2_called[] = false
    prob = ODEProblem(simple!, u0, tspan; callback = cb1)
    integrator = init(prob, Tsit5(); callback = cb2)
    solve!(integrator)
    @test cb1_called[]
    @test cb2_called[]
end

@testset "Other kwargs merging" begin
    # Test that non-callback kwargs are properly merged by checking they're accessible

    function simple!(du, u, p, t)
        du[1] = -u[1]
    end
    u0 = [1.0]
    tspan = (0.0, 1.0)

    # Test that problem kwargs are preserved and solve kwargs override
    prob = ODEProblem(simple!, u0, tspan; abstol = 1.0e-10, saveat = 0.1)

    # Both abstol and saveat should be used
    sol = solve(prob, Tsit5())
    @test sol.t ≈ [i * 0.1 for i in 0:10]  # saveat from problem kwargs

    # Override saveat, keep abstol
    sol = solve(prob, Tsit5(); saveat = 0.5)
    @test sol.t ≈ [0.0, 0.5, 1.0]  # saveat from solve kwargs

    # Test with save_everystep
    prob_everystep = ODEProblem(simple!, u0, tspan; save_everystep = false, saveat = 0.5)
    sol = solve(prob_everystep, Tsit5())
    @test sol.t ≈ [0.0, 0.5, 1.0]  # Only saved at saveat times, not every step

    # Override save_everystep
    sol = solve(prob_everystep, Tsit5(); save_everystep = true)
    @test length(sol.t) > 3  # Should save at more than just saveat times
end

@testset "kwargshandle merging" begin
    # Test that kwargshandle is properly respected from problem kwargs

    function simple!(du, u, p, t)
        du[1] = -u[1]
    end
    u0 = [1.0]
    tspan = (0.0, 1.0)

    # Problem with KeywordArgSilent should not warn on invalid kwargs
    prob = ODEProblem(
        simple!, u0, tspan;
        kwargshandle = SciMLBase.KeywordArgSilent,
        invalid_kwarg = "should be ignored"
    )
    @test_nowarn sol = solve(prob, Tsit5())

    # Problem with KeywordArgWarn and invalid kwarg should warn
    prob = ODEProblem(
        simple!, u0, tspan;
        kwargshandle = SciMLBase.KeywordArgWarn,
        invalid_kwarg = "should warn"
    )
    @test_logs (:warn, SciMLBase.KWARGWARN_MESSAGE) sol = solve(prob, Tsit5())

    # Default should error on invalid kwargs
    prob = ODEProblem(simple!, u0, tspan; invalid_kwarg = "should error")
    @test_throws SciMLBase.CommonKwargError sol = solve(prob, Tsit5())
end

module DiffEqBaseSparseArraysExt

import SparseArrays
import DiffEqBase: NAN_CHECK, INFINITE_OR_GIANT

function NAN_CHECK(x::SparseArrays.AbstractSparseMatrixCSC)
    return any(NAN_CHECK, SparseArrays.nonzeros(x))
end
function INFINITE_OR_GIANT(x::SparseArrays.AbstractSparseMatrixCSC)
    return any(INFINITE_OR_GIANT, SparseArrays.nonzeros(x))
end

end

using OrdinaryDiffEq

function lorenz!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

u0 = BigFloat[1.0; 0.0; 0.0]
tspan = (big(0.0), big(100.0))
prob = ODEProblem(lorenz!, u0, tspan)
sol = solve(prob, Tsit5(), save_everystep = false)

x = sol.u[end]

import LinearAlgebra.norm
function condition(u, t, integrator)
    return norm(u - x) - 0.1
end

affect!(integrator) = terminate!(integrator)

cb = ContinuousCallback(condition, affect!)

sol2 = solve(prob, Tsit5(), save_everystep = false, callback = cb)

using OrdinaryDiffEq

## https://github.com/SciML/DifferentialEquations.jl/issues/1013

mutable struct SomeObject
    position::Any
    velocity::Any
    trajectory::Any
end

object = SomeObject(0, 1, nothing)

# Current dynamics don't involve the object for the sake of MWE, but they could.
function dynamics(du, u, p, t)
    du[1] = u[2]
    return du[2] = -u[2]
end

for i in 1:2
    initial_state = [0, 0]
    tspan = (0.0, 5.0)
    prob = ODEProblem(dynamics, initial_state, tspan, object)
    sol = solve(prob, Tsit5())
    object.trajectory = sol
end

# https://github.com/SciML/DiffEqBase.jl/issues/1003

f(u, p, t) = 1.01 * u
u0 = 1 / 2
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
sol = solve(prob, Tsit5(), reltol = 1.0e-8, abstol = 1.0e-8)

prob2 = ODEProblem((du, u, p, t) -> du[1] = 1, [0.0], (0, 10), (; x = sol))
solve(prob2, Tsit5())

using OrdinaryDiffEq, StochasticDiffEq, Test, Sundials

f_oop(u, p, t) = 2u
u0 = 0.5
tspan = (0.0, 1.0)
prob = ODEProblem(f_oop, u0, tspan)
sol = solve(prob, Tsit5())

function f_iip(du, u, p, t)
    return du .= 2.0 * u
end
prob = ODEProblem(f_iip, u0, tspan)
@test_throws SciMLBase.IncompatibleInitialConditionError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, u0, tspan)
sol = solve(prob, Tsit5())
sol = solve(prob, nothing, alg = Tsit5())
sol = init(prob, nothing, alg = Tsit5())

prob = ODEProblem{false}(f_oop, 1.0 + im, tspan)
@test_throws SciMLBase.ComplexSupportError solve(prob, CVODE_Adams())

@test_throws SciMLBase.ProblemSolverPairingError solve(prob, DFBDF())
@test_throws SciMLBase.NonSolverError solve(prob, 5.0)

prob = ODEProblem{false}(f_oop, u0, (nothing, nothing))
@test_throws SciMLBase.NoTspanError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, u0, (NaN, 1.0))
@test_throws SciMLBase.NaNTspanError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, u0, (1.0, NaN))
@test_throws SciMLBase.NaNTspanError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, Any[1.0, 1.0f0], tspan)
@test_throws SciMLBase.NonConcreteEltypeError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, (1.0, 1.0f0), tspan)
@test_throws SciMLBase.TupleStateError solve(prob, Tsit5())

prob = ODEProblem{false}(f_oop, u0, (0.0 + im, 1.0))
@test_throws SciMLBase.ComplexTspanError solve(prob, Tsit5())

for u0 in ([0.0, 0.0], nothing)
    local fmm = ODEFunction(f_oop, mass_matrix = zeros(3, 3))
    local prob = ODEProblem(fmm, u0, (0.0, 1.0))
    @test_throws SciMLBase.IncompatibleMassMatrixError solve(prob, Tsit5())
end

# Allow empty mass matrix for empty u0
fmm = ODEFunction((du, u, t) -> nothing, mass_matrix = zeros(0, 0))
prob = ODEProblem(fmm, nothing, (0.0, 1.0))
sol = solve(prob, Tsit5())
@test isa(sol, SciMLBase.ODESolution)

f_sde(du, u, p, t) = du .= 1.01u
function g(du, u, p, t)
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[1, 3] = 0.9u[1]
    du[1, 4] = 0.12u[1]
    du[2, 1] = 1.2u[2]
    du[2, 2] = 0.2u[2]
    du[2, 3] = 0.3u[2]
    return du[2, 4] = 1.8u[2]
end

prob = SDEProblem(
    f_sde,
    g,
    randn(ComplexF64, 2),
    (0.0, 1.0),
    noise_rate_prototype = complex(zeros(2, 4)),
    noise = StochasticDiffEq.RealWienerProcess(0.0, zeros(3))
)
@test_throws SciMLBase.NoiseSizeIncompatibilityError solve(prob, LambaEM())

function g!(du, u, p, t)
    du[1] .= u[1] + ones(3, 3)
    return du[2] .= ones(3, 3)
end
u0 = [zeros(3, 3), zeros(3, 3)]
prob = ODEProblem(g!, u0, (0, 1.0))
@test_throws SciMLBase.NonNumberEltypeError solve(prob, Tsit5())

module DiffEqBaseFlexUnitsExt

using DiffEqBase
import SciMLBase: unitfulvalue, value
using FlexUnits

# Support adaptive errors should be errorless for exponentiation
value(::Type{Quantity{T, U}}) where {T, U} = T
value(x::Quantity{T, U}) where {T, U} = dstrip(x)

unitfulvalue(::Type{T}) where {T <: Quantity} = T
unitfulvalue(x::Quantity) = x

@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{
            <:Quantity,
            N,
        },
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:Quantity, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline DiffEqBase.ODE_DEFAULT_NORM(u::Quantity, t) = abs(value(u))
@inline function DiffEqBase.UNITLESS_ABS2(x::Quantity)
    return real(abs2(dstrip(x)))
end

DiffEqBase._rate_prototype(u, t::Quantity, onet) = u / unit(t)
end

using OrdinaryDiffEq, DiffEqCallbacks, LinearAlgebra

# https://github.com/SciML/DiffEqBase.jl/issues/564 : Fixed
gravity = 9.8
stiffness = 500
equilibrium_length = 1
T = 5.0

f(u, p, t) = begin
    x1, x2, dx1, dx2 = u
    length = abs(x2 - x1)
    spring_force = stiffness * (equilibrium_length - length)
    ddx1 = -gravity - spring_force
    ddx2 = -gravity + spring_force
    if x1 <= 0
        ddx1 = max(0, ddx1)
    end
    if x2 <= 0
        ddx2 = max(0, ddx2)
    end
    [dx1, dx2, ddx1, ddx2]
end

sol = solve(
    ODEProblem(f, [5.0, 6.0, 0.0, 0.0], (0.0, T)),
    Rodas5P(),
    callback = ContinuousCallback(
        (u, _, _) -> u[1],
        (integrator) -> (integrator.u[1] = 0; integrator.u[3] = 0)
    ),
    # callback = ContinuousCallback((u, _, _) -> u[1], (integrator) -> (integrator.u[3] = 0)),
    reltol = 1.0e-5,
    abstol = 1.0e-5
)

@show sol.stats

# https://github.com/SciML/DiffEqBase.jl/issues/553 : Floating point issue is resolved but some other error occurs
function model(du, u, p, t)
    du[1] = 0.0
    for i in 2:(length(du) - 1)
        du[i] = p[i] * (u[i - 1] - u[i])
    end
    du[end] = p[end] * (p[1] * u[end - 1] - u[end])
    return nothing
end

perror = [
    1.0,
    0.02222434508140991,
    0.017030281542289794,
    0.015917011145559996,
    0.1608874463597176,
    0.13128016561792297,
    0.11056834258380167,
    0.5222141958458832,
    1.0711942201995688,
    0.2672878398678257,
    8.900058706990183,
    0.010760065201065117,
    0.016319181296867765,
    2.2693845639611925,
    0.2152216345154439,
    0.029186712540925457,
    0.21419429135100806,
    0.029177617589788596,
    0.03064986043089549,
    0.023280222517122397,
    6.931251277770224,
]
y_max = 0.002604806609572015
u0 = [1, zeros(length(perror) - 1)...]
tspan = (0.0, 5000.0)

condition(u, t, i) = (t == 1.0)
affect!(i) = (i.u[1] = 0.0)

condition2(u, t, i) = u[end] - y_max / 2.0
t_half_1 = 0.0
affect2!(i) = (t_half_1 = i.t)

prob = ODEProblem(model, u0, tspan, perror)
sol = solve(
    prob,
    Rosenbrock23();
    callback = CallbackSet(
        PositiveDomain(),
        DiscreteCallback(condition, affect!),
        ContinuousCallback(condition2, affect2!, terminate!)
    ),
    tstops = [1.0],
    force_dtmin = true
)

# https://github.com/SciML/DiffEqBase.jl/issues/515 : Fixed

using StaticArrays
using MultiScaleArrays

t_last = 0.0
function attactor(du, u, p, t)
    α, β = p
    n = length(u.nodes)
    return for k in 1:n
        du.nodes[k] = zero(du.nodes[k])
        for j in 1:n
            if (k == j)
                du.nodes[k] .+= [
                    u.nodes[k][3],
                    u.nodes[k][4],
                    -β * u.nodes[k][3],
                    -β * u.nodes[k][4],
                ]
            else
                du.nodes[k][3:4] .+= α * (u.nodes[j][1:2] - u.nodes[k][1:2])
            end
        end
    end
end

struct Thingy{B} <: AbstractMultiScaleArrayLeaf{B}
    values::Vector{B}
end

struct PhysicsLaw{T <: AbstractMultiScaleArray, B <: Number} <:
    AbstractMultiScaleArrayHead{B}
    nodes::Vector{T}
    values::Vector{B}
    end_idxs::Vector{Int}
end

Newton = construct(
    PhysicsLaw,
    [
        Thingy([-700.0, -350.0, 0.0, 0.0]),
        Thingy([-550.0, -150.0, 0.0, 0.0]),
        Thingy([-600.0, 15.0, 0.0, 10.0]),
        Thingy([200.0, -200.0, 5.0, -5.0]),
    ]
)

parameters = [1.0e-2, 0.06]

function condition(out, u, t, integrator)
    i = 0
    n = length(u.nodes)
    for k in 1:n
        for l in (k + 1):n
            i += 1
            out[i] = sum(abs2, u.nodes[k][1:2] .- u.nodes[l][1:2]) - 10000
        end
    end
    return
end

function collision_affect!(integrator, idx)
    i = 0
    u = integrator.u
    n = length(u.nodes)
    return for k in 1:n
        for l in (k + 1):n
            i += 1
            if idx == i
                x₁ = u.nodes[k][1:2]
                v₁ = u.nodes[k][3:4]
                x₂ = u.nodes[l][1:2]
                v₂ = u.nodes[l][3:4]
                # https://stackoverflow.com/a/35212639
                v₁ = (v₁ - 2 / (1 + 1) * (dot(v₁ - v₂, x₁ - x₂) / sum(abs2, x₁ - x₂) * (x₁ - x₂)))
                v₂ = -(v₂ - 2 / (1 + 1) * (dot(v₂ - v₁, x₂ - x₁) / sum(abs2, x₂ - x₁) * (x₂ - x₁)))

                println("Collision handled.")

                m = (x₁ + x₂) / 2

                u.nodes[k][3:4] .= v₁
                u.nodes[l][3:4] .= v₂

                set_u!(integrator, u)
                println(sqrt(sum(abs2, x₁ .- x₂)) - 100, ":", v₁ ./ v₂)
                println(
                    norm(v₁), ":", norm(v₂), ":", integrator.t, ":",
                    integrator.t - t_last
                )
                global t_last = integrator.t
                break
            end
        end
    end
end

cback = VectorContinuousCallback(
    condition,
    collision_affect!,
    (x -> Int(((x - 1) * x) / 2))(length(Newton.nodes))
)

problemp = ODEProblem(attactor, Newton, (0.0, Inf), parameters)

world = init(problemp, AutoTsit5(Rosenbrock23()); save_everystep = false, callback = cback)

dt = 0.2

for i in 1:1000
    step!(world, dt)
end

## https://github.com/SciML/OrdinaryDiffEq.jl/issues/1528

function f!(out, u, p, t)
    out[1] = 0
    out[2] = u[3]
    return out[3] = -1.0 * (u[2] - u[1])
end
u0 = [0, 0, 1.0]
function cond!(out, u, t, i)
    out[1] = u[3]
    return nothing
end
function terminate_affect!(int, idx)
    return terminate!(int)
end
cb = VectorContinuousCallback(cond!, terminate_affect!, nothing, 1)

u0 = [0.0, 0.0, 1.0]
prob = ODEProblem(f!, u0, (0.0, 10.0); callback = cb)
soln = solve(prob, Tsit5())
@test soln.t[end] ≈ 4.712347213360699

odefun = ODEFunction((u, p, t) -> [u[2], u[2] - p]; mass_matrix = [1 0; 0 0])
callback = PresetTimeCallback(0.5, integ -> (integ.p = -integ.p))
prob = ODEProblem(odefun, [0.0, -1.0], (0.0, 1), 1; callback)
#test that reinit happens for both FSAL and non FSAL integrators
@testset "dae re-init" for alg in [FBDF(), Rodas5P()]
    sol = solve(prob, alg)
    # test that the callback flipping p caused u[2] to get flipped.
    first_t = findfirst(isequal(0.5), sol.t)
    @test sol.u[first_t][2] == -sol.u[first_t + 1][2]
end

daefun = DAEFunction((du, u, p, t) -> [du[1] - u[2], u[2] - p])
prob = DAEProblem(
    daefun, [0.0, 0.0], [0.0, -1.0], (0.0, 1), 1;
    differential_vars = [true, false], callback
)
sol = solve(prob, DFBDF())
# test that the callback flipping p caused u[2] to get flipped.
first_t = findfirst(isequal(0.5), sol.t)
@test sol.u[first_t][2] == -sol.u[first_t + 1][2]

using StochasticDiffEq, DiffEqBase,
    OrdinaryDiffEq, DiffEqBase.EnsembleAnalysis
using Test

import SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear

prob = prob_sde_linear
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10, adaptive = false)

m = timestep_mean(sim, 3)
m2, v = timestep_meanvar(sim, 3)
med = timestep_median(sim, 3)
quant = timestep_quantile(sim, 0.5, 3)
@test quant ≈ med
@test m ≈ m2
m3, m4, c = timestep_meancov(sim, 3, 3)
@test m ≈ m3
@test v ≈ c
m3, m4, c = timestep_meancor(sim, 3, 3)
@test c ≈ one(c)
vecarr = timeseries_steps_mean(sim)
vecarr = timeseries_steps_median(sim)
vecarr = timeseries_steps_quantile(sim, 0.5)
m_series, v_series = timeseries_steps_meanvar(sim)
summ = EnsembleSummary(sim)

m4, v4 = m_series.u[3], v_series.u[3]
covar_mat = timeseries_steps_meancov(sim)[3, 3]
@test m ≈ m4
@test v ≈ v4
@test m ≈ covar_mat[1]
@test m ≈ covar_mat[2]
@test v ≈ covar_mat[3]

@test (get_timestep(sim, 1)...,) == (get_timepoint(sim, 0.0)...,)
@test (get_timestep(sim, 2)...,) == (get_timepoint(sim, 1 // 2^(3))...,)
@test (get_timestep(sim, 3)...,) == (get_timepoint(sim, 1 // 2^(2))...,)

sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10)
m = timepoint_mean(sim, 0.5)
med = timepoint_median(sim, 0.6)
quant = timepoint_quantile(sim, 0.5, 0.6)
@test quant ≈ med
m2, v = timepoint_meanvar(sim, 0.5)
@test m ≈ m2
m3, m4, c = timepoint_meancov(sim, 0.5, 0.5)
@test m ≈ m3
@test v ≈ c
m3, m4, c = timepoint_meancor(sim, 0.5, 0.5)
@test c ≈ one(c)
m_series = timeseries_point_mean(sim, 0:(1 // 2^(3)):1)
m_series = timeseries_point_median(sim, 0:(1 // 2^(3)):1)
m_series = timeseries_point_quantile(sim, 0.5, 0:(1 // 2^(3)):1)
m_series, v_series = timeseries_point_meanvar(sim, 0:(1 // 2^(3)):1)
summ = EnsembleSummary(sim, 0:(1 // 2^(3)):1)
m5, v5 = m_series.u[5], v_series.u[5]
@test m ≈ m5
@test v ≈ v5
m6, m7, v6 = timeseries_point_meancov(sim, 0:(1 // 2^(3)):1, 0:(1 // 2^(3)):1)[5, 5]
@test m ≈ m6
@test m ≈ m7
@test v ≈ v6

prob = prob_sde_2Dlinear
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10, adaptive = false)

m = timestep_mean(sim, 3)
m2, v = timestep_meanvar(sim, 3)
med = timestep_median(sim, 3)
quant = timestep_quantile(sim, 0.5, 3)
@test quant ≈ med
@test m ≈ m2
m3, m4, c = timestep_meancov(sim, 3, 3)
@test m ≈ m3
@test v ≈ c
m3, m4, c = timestep_meancor(sim, 3, 3)
@test c ≈ ones(size(c)...)
vecarr = timeseries_steps_mean(sim)
vecarr = timeseries_steps_median(sim)
vecarr = timeseries_steps_quantile(sim, 0.5)
m_series, v_series = timeseries_steps_meanvar(sim)
summ = EnsembleSummary(sim)

m4, v4 = m_series.u[3], v_series.u[3]
covar_mat = timeseries_steps_meancov(sim)[3, 3]
@test m ≈ m4
@test v ≈ v4
@test m ≈ covar_mat[1]
@test m ≈ covar_mat[2]
@test v ≈ covar_mat[3]

@test (get_timestep(sim, 1)...,) == (get_timepoint(sim, 0.0)...,)
@test (get_timestep(sim, 2)...,) == (get_timepoint(sim, 1 // 2^(3))...,)
@test (get_timestep(sim, 3)...,) == (get_timepoint(sim, 1 // 2^(2))...,)

sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10)
m = timepoint_mean(sim, 0.5)
med = timepoint_median(sim, 0.6)
quant = timepoint_quantile(sim, 0.5, 0.6)
@test quant ≈ med
m2, v = timepoint_meanvar(sim, 0.5)
@test m ≈ m2
m3, m4, c = timepoint_meancov(sim, 0.5, 0.5)
@test m ≈ m3
@test v ≈ c
m3, m4, c = timepoint_meancor(sim, 0.5, 0.5)
@test c ≈ ones(size(c)...)
m_series = timeseries_point_mean(sim, 0:(1 // 2^(3)):1)
m_series = timeseries_point_median(sim, 0:(1 // 2^(3)):1)
m_series = timeseries_point_quantile(sim, 0.5, 0:(1 // 2^(3)):1)
m_series, v_series = timeseries_point_meanvar(sim, 0:(1 // 2^(3)):1)
summ = EnsembleSummary(sim, 0:(1 // 2^(3)):1)
m5, v5 = m_series.u[5], v_series.u[5]
@test m ≈ m5
@test v ≈ v5
m6, m7, v6 = timeseries_point_meancov(sim, 0:(1 // 2^(3)):1, 0:(1 // 2^(3)):1)[5, 5]
@test m ≈ m6
@test m ≈ m7
@test v ≈ v6

module DiffEqBaseGTPSAExt

using DiffEqBase
import DiffEqBase: ODE_DEFAULT_NORM
import SciMLBase: value, unitfulvalue
using GTPSA

value(x::TPS) = scalar(x)
value(::Type{<:TPS{T}}) where {T} = T

unitfulvalue(x::TPS) = scalar(x)
unitfulvalue(::Type{<:TPS{T}}) where {T} = T

ODE_DEFAULT_NORM(u::TPS, t) = normTPS(u)
ODE_DEFAULT_NORM(f::F, u::TPS, t) where {F} = normTPS(f(u))

function ODE_DEFAULT_NORM(u::AbstractArray{<:TPS}, t)
    x = zero(real(GTPSA.numtype(eltype(u))))
    @inbounds @fastmath for ui in u
        x += normTPS(ui)^2
    end
    return Base.FastMath.sqrt_fast(x / max(length(u), 1))
end

function ODE_DEFAULT_NORM(f::F, u::AbstractArray{<:TPS}, t) where {F}
    x = zero(real(GTPSA.numtype(eltype(u))))
    @inbounds @fastmath for ui in u
        x += normTPS(f(ui))^2
    end
    return Base.FastMath.sqrt_fast(x / max(length(u), 1))
end

end

module DiffEqBaseMooncakeExt

using DiffEqBase, Mooncake
using DiffEqBase: SciMLBase
using SciMLBase: ADOriginator, ChainRulesOriginator, MooncakeOriginator
import Mooncake: rrule!!, CoDual, zero_fcodual, @is_primitive,
    @from_rrule, @zero_adjoint, @mooncake_overlay, MinimalCtx,
    NoPullback

@from_rrule(
    MinimalCtx,
    Tuple{
        typeof(DiffEqBase.solve_up),
        DiffEqBase.AbstractDEProblem,
        Union{Nothing, DiffEqBase.AbstractSensitivityAlgorithm},
        Any,
        Any,
        Any,
    },
    true,
)

# Dispatch for auto-alg
@from_rrule(
    MinimalCtx,
    Tuple{
        typeof(DiffEqBase.solve_up),
        DiffEqBase.AbstractDEProblem,
        Union{Nothing, DiffEqBase.AbstractSensitivityAlgorithm},
        Any,
        Any,
    },
    true,
)

end

using OrdinaryDiffEq
using Test

# Test for SubArray support with ODEProblem
# Regression test for https://github.com/SciML/OrdinaryDiffEq.jl/issues/2900
# Fixed in https://github.com/SciML/DiffEqBase.jl/pull/1219

@testset "SubArray as initial conditions" begin
    # Test 1: Simple ODE with SubArray initial conditions
    @testset "Basic ODE with SubArray" begin
        f(du, u, p, t) = du .= u
        u0_full = ones(10)
        u0 = @view u0_full[1:5]

        # This should not throw NoFunctionWrapperFoundError
        prob = ODEProblem(f, u0, (0.0, 1.0))
        sol = solve(prob, Tsit5())

        @test sol.retcode == ReturnCode.Success
        @test length(sol.u[end]) == 5
    end

    # Test 2: Simple pendulum with SubArray initial conditions
    @testset "Simple pendulum with SubArray" begin
        g = 9.81
        L = 1.0

        # Initial Conditions as SubArray
        u₀ = @view [0, π / 60][:]  # Initial speed and initial angle
        tspan = (0.0, 6.3)

        # Define the pendulum problem
        function simplependulum(du, u, p, t)
            θ = u[1]
            dθ = u[2]
            du[1] = dθ
            du[2] = -(g / L) * θ
        end

        # This should not throw NoFunctionWrapperFoundError
        prob = ODEProblem(simplependulum, u₀, tspan)
        integrator = init(prob, Tsit5(); reltol = 1.0e-6)

        @test integrator !== nothing

        # Solve and verify the solution
        sol = solve(prob, Tsit5(); reltol = 1.0e-6)
        @test sol.retcode == ReturnCode.Success
        @test length(sol.u[end]) == 2
    end

    # Test 3: Various SubArray slicing patterns
    @testset "Different SubArray patterns" begin
        f(du, u, p, t) = du .= 2u

        # Test different ways to create SubArrays
        @testset "range slice" begin
            arr = [1.0, 2.0, 3.0]
            u0 = @view arr[1:2]
            prob = ODEProblem(f, u0, (0.0, 1.0))
            sol = solve(prob, Tsit5())
            @test sol.retcode == ReturnCode.Success
        end

        @testset "colon slice" begin
            arr = [1.0, 2.0, 3.0]
            u0 = @view arr[:]
            prob = ODEProblem(f, u0, (0.0, 1.0))
            sol = solve(prob, Tsit5())
            @test sol.retcode == ReturnCode.Success
        end

        @testset "offset range" begin
            arr = [1.0, 2.0, 3.0]
            u0 = @view arr[2:3]
            prob = ODEProblem(f, u0, (0.0, 1.0))
            sol = solve(prob, Tsit5())
            @test sol.retcode == ReturnCode.Success
        end

        @testset "view of constructed array" begin
            arr = ones(5)
            u0 = @view arr[1:3]
            prob = ODEProblem(f, u0, (0.0, 1.0))
            sol = solve(prob, Tsit5())
            @test sol.retcode == ReturnCode.Success
        end
    end
end

using DiffEqBase, Test

# Verify that the Bool path of `_process_verbose_param` is type-stable when
# the Bool is a compile-time literal (the default `verbose = true` case from
# `solve`/`init`). Without `Base.@constprop :aggressive`, both branches return
# different concrete `DEVerbosity{...}` parameterizations and the result is a
# `Union{...}` that poisons inference all the way through `solve`.

@testset "_process_verbose_param inference" begin
    # Val-dispatch is unconditionally type-stable.
    @inferred DiffEqBase._process_verbose_param(Val(true))
    @inferred DiffEqBase._process_verbose_param(Val(false))

    # Constprop on literal Bool resolves to a single concrete type.
    f_true() = DiffEqBase._process_verbose_param(true)
    f_false() = DiffEqBase._process_verbose_param(false)
    @test Base.return_types(f_true, ())[1] === typeof(DiffEqBase.DEFAULT_VERBOSE)
    @test Base.return_types(f_false, ())[1] === typeof(DiffEqBase.NONE_VERBOSE)
end

using OrdinaryDiffEq
function f(du, u, p, t)
    return du[1] = 1.01 * u[1]
end
u0 = [0.0, 0.0]
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
n = 100

initial_conditions = range(0, stop = 1, length = n)
function prob_func(prob, i, repeat)
    prob.u0[1] = initial_conditions[i]
    return prob
end
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim_1 = solve(
    ensemble_prob, Tsit5(), EnsembleThreads(),
    trajectories = 100
)
sim_2 = solve(
    ensemble_prob, Tsit5(), EnsembleDistributed(),
    trajectories = 100
)
ss_sol_1 = hcat(collect(EnsembleAnalysis.get_timepoint(sim_1, 0))...);
ss_sol_2 = hcat(collect(EnsembleAnalysis.get_timepoint(sim_2, 0))...);

ss_sol_1[1, :] == initial_conditions
ss_sol_2[1, :] == initial_conditions

module DiffEqBaseReverseDiffExt

using DiffEqBase
import DiffEqBase: value
import ReverseDiff
import DiffEqBase.ArrayInterface

# Support adaptive with non-tracked time
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::ReverseDiff.TrackedArray, t)
    return sqrt(sum(abs2, DiffEqBase.value(u)) / length(u))
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{<:ReverseDiff.TrackedReal, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((DiffEqBase.value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:ReverseDiff.TrackedReal, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((DiffEqBase.value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::ReverseDiff.TrackedReal, t)
    return abs(DiffEqBase.value(u))
end

# Support TrackedReal time, don't drop tracking on the adaptivity there
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::ReverseDiff.TrackedArray,
        t::ReverseDiff.TrackedReal
    )
    return sqrt(sum(abs2, u) / length(u))
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{<:ReverseDiff.TrackedReal, N},
        t::ReverseDiff.TrackedReal
    ) where {N}
    return sqrt(
        sum(x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]), zip(u, Iterators.repeated(t))) /
            length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:ReverseDiff.TrackedReal, N},
        t::ReverseDiff.TrackedReal
    ) where {N}
    return sqrt(
        sum(x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]), zip(u, Iterators.repeated(t))) /
            length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::ReverseDiff.TrackedReal,
        t::ReverseDiff.TrackedReal
    )
    return abs(u)
end

# `ReverseDiff.TrackedArray`
function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0::ReverseDiff.TrackedArray,
        p::ReverseDiff.TrackedArray, args...; kwargs...
    )
    return ReverseDiff.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0, p::ReverseDiff.TrackedArray,
        args...; kwargs...
    )
    return ReverseDiff.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0::ReverseDiff.TrackedArray, p,
        args...; kwargs...
    )
    return ReverseDiff.track(DiffEqBase.solve_up, prob, sensealg, u0, p, args...; kwargs...)
end

# `AbstractArray{<:ReverseDiff.TrackedReal}`
function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        },
        u0::AbstractArray{<:ReverseDiff.TrackedReal},
        p::AbstractArray{<:ReverseDiff.TrackedReal}, args...;
        kwargs...
    )
    return DiffEqBase.solve_up(
        prob, sensealg, ArrayInterface.aos_to_soa(u0),
        ArrayInterface.aos_to_soa(p), args...;
        kwargs...
    )
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0,
        p::AbstractArray{<:ReverseDiff.TrackedReal},
        args...; kwargs...
    )
    return DiffEqBase.solve_up(
        prob, sensealg, u0, ArrayInterface.aos_to_soa(p), args...; kwargs...
    )
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.AbstractDEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        }, u0::ReverseDiff.TrackedArray,
        p::AbstractArray{<:ReverseDiff.TrackedReal},
        args...; kwargs...
    )
    return DiffEqBase.solve_up(
        prob, sensealg, u0, ArrayInterface.aos_to_soa(p), args...; kwargs...
    )
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.DEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        },
        u0::AbstractArray{<:ReverseDiff.TrackedReal}, p,
        args...; kwargs...
    )
    return DiffEqBase.solve_up(
        prob, sensealg, ArrayInterface.aos_to_soa(u0), p, args...; kwargs...
    )
end

function DiffEqBase.solve_up(
        prob::DiffEqBase.DEProblem,
        sensealg::Union{
            SciMLBase.AbstractOverloadingSensitivityAlgorithm,
            Nothing,
        },
        u0::AbstractArray{<:ReverseDiff.TrackedReal}, p::ReverseDiff.TrackedArray,
        args...; kwargs...
    )
    return DiffEqBase.solve_up(
        prob, sensealg, ArrayInterface.aos_to_soa(u0), p, args...; kwargs...
    )
end

# Required becase ReverseDiff.@grad function DiffEqBase.solve_up is not supported!
import DiffEqBase: solve_up
ReverseDiff.@grad function solve_up(prob, sensealg, u0, p, args...; kwargs...)
    out = DiffEqBase._solve_adjoint(
        prob, sensealg, ReverseDiff.value(u0),
        ReverseDiff.value(p),
        SciMLBase.ReverseDiffOriginator(), args...; kwargs...
    )
    function actual_adjoint(_args...)
        original_adjoint = out[2](_args...)
        if isempty(args) # alg is missing
            tuple(original_adjoint[1:4]..., original_adjoint[6:end]...)
        else
            original_adjoint
        end
    end
    Array(out[1]), actual_adjoint
end

end

using ModelingToolkit, OrdinaryDiffEq, SteadyStateDiffEq, Test
using StaticArrays
using ModelingToolkit: t_nounits as t, D_nounits as D
using DifferentiationInterface
using ADTypes: AutoForwardDiff, AutoMooncake

# Load backends for all versions (required for DifferentiationInterface extensions)
using ForwardDiff
using Mooncake

# Version-dependent imports
if VERSION <= v"1.11"
    using Zygote
    using ADTypes: AutoZygote
end
if VERSION <= v"1.11"
    using Enzyme
    using ADTypes: AutoEnzyme
end

# Define backends based on Julia version
function get_test_backends()
    backends = Pair{String, Any}[]
    push!(backends, "ForwardDiff" => AutoForwardDiff())
    push!(backends, "Mooncake" => AutoMooncake(; config = nothing))
    if VERSION <= v"1.11"
        push!(backends, "Zygote" => AutoZygote())
    end
    if VERSION <= v"1.11"
        push!(backends, "Enzyme" => AutoEnzyme())
    end
    return backends
end

@variables x(t) y(t)
eqs = [
    0 ~ x - y
    0 ~ y
]

@named sys = System(eqs, t)
sys = mtkcompile(sys)

prob = ODEProblem(sys, Pair[], (0, 10.0))
sol = solve(prob, Tsit5())

@test sol.dense
@test sol[x] == [0.0, 0.0]
@test sol[y] == [0.0, 0.0]

for kwargs in [
        Dict(:saveat => 0:0.1:1),
        Dict(:save_start => false),
        Dict(:save_end => false),
    ]
    local sol = solve(prob, kwargs...)
    local init_integ = init(prob, kwargs...)
    solve!(init_integ)
    local step_integ = init(prob, kwargs...)
    step!(step_integ, prob.tspan[end] - prob.tspan[begin])
    @test sol.u[end] == init_integ.u
    @test sol.t[end] == init_integ.t
    @test sol.u[end] == step_integ.u
    @test sol.t[end] == step_integ.t
end

@variables x y
eqs = [
    0 ~ x - y
    0 ~ y
]

@named sys = System(eqs, [x, y], [])
sys = mtkcompile(sys)
prob = NonlinearProblem(sys, [])

sol = solve(prob, DynamicSS(Tsit5()))

@test sol[x] == 0.0
@test sol[y] == 0.0

# https://github.com/SciML/NonlinearSolve.jl/issues/387

using NonlinearSolve
function unsat(du, u, p)
    return du[1] = 1
end
unsat_f = NonlinearFunction(unsat; resid_prototype = zeros(1))
unsatprob = NonlinearLeastSquaresProblem(unsat_f, nothing)
sol = solve(unsatprob) # Success
@test sol.retcode == SciMLBase.ReturnCode.Failure
@test sol.resid == [1.0]

# Issue#2664
@testset "remake type promotion with empty initial conditions" begin
    @parameters P
    @variables x(t)
    # numerical ODE: x′(t) = P with x(0) = 0
    sys_num = mtkcompile(System([D(x) ~ P], t, [x], [P]; name = :sys))
    prob_num_uninit = ODEProblem(sys_num, [x => 0.0, P => NaN], (0.0, 1.0)) # uninitialized problem
    x_at_1_num(P) = solve(remake(prob_num_uninit; p = [sys_num.P => P]), Tsit5())(
        1.0, idxs = x
    )

    # analytical solution: x(t) = P*t
    sys_anal = mtkcompile(System([x ~ P * t], t, [x], [P]; name = :sys))
    prob_anal_uninit = ODEProblem(sys_anal, [P => NaN], (0.0, 1.0))
    x_at_1_anal(P) = solve(remake(prob_anal_uninit; p = [sys_anal.P => P]), Tsit5())(
        1.0, idxs = x
    )

    @test_nowarn x_at_1_num(1.0)
    @test_nowarn x_at_1_anal(1.0)
    # Test derivative with multiple AD backends
    # Note: Mooncake, Zygote, and Enzyme are excluded because they cannot handle complex MTK types
    # Mooncake: MooncakeRuleCompilationError
    # Zygote: BoundsError in AtomicArrayDict iteration
    # Enzyme: StackOverflowError in EnzymeInterpreter
    backends = filter(b -> b[1] ∉ ("Mooncake", "Zygote", "Enzyme"), get_test_backends())
    for (name, backend) in backends
        @test_nowarn DifferentiationInterface.derivative(x_at_1_num, backend, 1.0)
        @test_nowarn DifferentiationInterface.derivative(x_at_1_anal, backend, 1.0)
    end
end

@testset "Null OOP NonlinearLeastSquaresProblem" begin
    fn = NonlinearFunction{false}(; resid_prototype = SA[1.0]) do u, p
        return zero(u)
    end
    prob = NonlinearLeastSquaresProblem(fn, nothing)
    sol = solve(prob)
    @test sol.resid isa SVector{1, Float64}
end

@testset "`u_modified!` works on null integrators" begin
    prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))
    integ = init(prob, Tsit5())
    @test_nowarn SciMLBase.u_modified!(integ, Float64[])
    @test SciMLBase.successful_retcode(SciMLBase.check_error(integ))
end

@testset "`step!` without dt" begin
    prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))
    integ = init(prob, Tsit5())
    @test_nowarn step!(integ)
    @test integ.t ≈ 1.0
end

# https://github.com/SciML/ModelingToolkit.jl/issues/4078
@testset "Null problem with callbacks" begin
    using DiffEqCallbacks

    # Test 1: has_callbacks detection - null problem WITHOUT callbacks takes fast path
    prob_no_cb = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))
    sol_no_cb = solve(prob_no_cb, Tsit5())
    @test sol_no_cb.retcode == SciMLBase.ReturnCode.Success
    @test sol_no_cb.t == [0.0, 1.0]

    # Test 2: has_callbacks detection - null problem WITH callbacks should NOT take fast path
    # But works in OrdinaryDiffEq.jl path
    callback_called = Ref(false)
    cb = DiscreteCallback((u, t, integrator) -> t >= 0.5, integrator -> callback_called[] = true)
    prob_with_cb = ODEProblem(Returns(nothing), nothing, (0.0, 1.0))
    sol = solve(prob_with_cb, Tsit5(); callback = cb, tstops = [0.5])
    @test sol.retcode == SciMLBase.ReturnCode.Success
    @test callback_called[]

    # Test 3: ODE with state + DiscreteCallback - callbacks should trigger
    # Using raw ODE (not MTK) to avoid API changes
    callback_triggered = Ref(false)
    cb_trigger = DiscreteCallback(
        (u, t, integrator) -> t >= 0.5 && !callback_triggered[],
        integrator -> (callback_triggered[] = true)
    )
    prob_with_state = ODEProblem((du, u, p, t) -> (du[1] = 0.0), [0.0], (0.0, 1.0))
    sol_with_state = solve(prob_with_state, Tsit5(); callback = cb_trigger, tstops = [0.5])

    @test sol_with_state.retcode == SciMLBase.ReturnCode.Success
    @test callback_triggered[]

    # Test 4: init with null problem + callback works in OrdinaryDiffEq.jl path
    sol = solve(prob_with_cb, Tsit5(); callback = cb)
    @test sol.retcode == SciMLBase.ReturnCode.Success
    @test callback_triggered[]
end

using Test, RecursiveArrayTools, StaticArrays, SparseArrays

using DiffEqBase: NAN_CHECK

@test !NAN_CHECK(3.0 + 4.0im)
@test NAN_CHECK(NaN)

u1 = ones(3)
@test !NAN_CHECK(u1)
u1′ = copy(u1)
u1′[2] = NaN
@test NAN_CHECK(u1′)

u2 = [SA[1.0 1.0; 1.0 1.0] for i in 1:3]
@test !NAN_CHECK(u2)
u2′ = copy(u2)
u2′[2] = SA[1.0 NaN; 1.0 1.0]
@test NAN_CHECK(u2′)

u3 = VectorOfArray([ones(5), ones(5)])
@test !NAN_CHECK(u3)
u3′ = recursivecopy(u3)
u3′[3, 2] = NaN
@test NAN_CHECK(u3′)

u4 = ArrayPartition(u1, u2, u3)
@test !NAN_CHECK(u4)
u4_1 = ArrayPartition(u1′, u2, u3)
@test NAN_CHECK(u4_1)
u4_2 = ArrayPartition(u1, u2′, u3)
@test NAN_CHECK(u4_2)
u4_3 = ArrayPartition(u1, u2, u3′)
@test NAN_CHECK(u4_3)

@test !NAN_CHECK(ArrayPartition(u4, u4))
@test NAN_CHECK(ArrayPartition(u4, u4_1))
@test NAN_CHECK(ArrayPartition(u4, u4_2))
@test NAN_CHECK(ArrayPartition(u4, u4_3))

u5 = spzeros(1, 1)
@test !NAN_CHECK(u5)
u5[1, 1] = NaN
@test NAN_CHECK(u5)

using Test
using DiffEqBase
using Aqua

@testset "Aqua tests (performance)" begin
    # This tests that we don't accidentally run into
    # https://github.com/JuliaLang/julia/issues/29393
    # Aqua.test_unbound_args(DiffEqBase) # fails
    ua = Aqua.detect_unbound_args_recursively(DiffEqBase)
    @test length(ua) == 0
    # Uncomment for debugging:
    # @show ua

    # See: https://github.com/SciML/OrdinaryDiffEq.jl/issues/1750
    # Test that we're not introducing method ambiguities across deps
    ambs = Aqua.detect_ambiguities(DiffEqBase; recursive = true)
    pkg_match(pkgname, pkdir::Nothing) = false
    pkg_match(pkgname, pkdir::AbstractString) = occursin(pkgname, pkdir)
    filter!(x -> pkg_match("DiffEqBase", pkgdir(last(x).module)), ambs)

    # Uncomment for debugging:
    # for method_ambiguity in ambs
    #     @show method_ambiguity
    # end
    @warn "Number of method ambiguities: $(length(ambs))"
    @test length(ambs) ≤ 4
end

@testset "Aqua tests (additional)" begin
    Aqua.test_undefined_exports(DiffEqBase)
    Aqua.test_stale_deps(DiffEqBase)
    Aqua.test_deps_compat(DiffEqBase)
    Aqua.test_project_extras(DiffEqBase)
    Aqua.test_project_toml_formatting(DiffEqBase)
    # Aqua.test_piracy(DiffEqBase) # failing
end

nothing

using DiffEqBase.InternalEuler, SciMLBase, DiffEqBase, Test

# Here's the problem to solve

struct LorenzFunction <: Function
    syms::Vector{Symbol}
end

function (::LorenzFunction)(u, p, t)
    return [10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
end
lorenz = LorenzFunction([:x, :y, :z])

u0 = [1.0, 5.0, 10.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan)
dt = 0.1
sol = solve(prob, InternalEuler.FwdEulerAlg(), tstops = 0:dt:1)
syms = [:x, :y, :z]

@test SciMLBase.interpret_vars([(0, 1), (1, 3), (4, 5)], sol) == [
    (SciMLBase.DEFAULT_PLOT_FUNC, 0, 1),
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 3),
    (SciMLBase.DEFAULT_PLOT_FUNC, 4, 5),
]
@test SciMLBase.interpret_vars([1, (1, 3), (4, 5)], sol) == [
    (SciMLBase.DEFAULT_PLOT_FUNC, 0, 1),
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 3),
    (SciMLBase.DEFAULT_PLOT_FUNC, 4, 5),
]
@test SciMLBase.interpret_vars([1, 3, 4], sol) == [
    (SciMLBase.DEFAULT_PLOT_FUNC, 0, 1),
    (SciMLBase.DEFAULT_PLOT_FUNC, 0, 3),
    (SciMLBase.DEFAULT_PLOT_FUNC, 0, 4),
]
@test SciMLBase.interpret_vars(([1, 2, 3], [4, 5, 6]), sol) == [
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 4),
    (SciMLBase.DEFAULT_PLOT_FUNC, 2, 5),
    (SciMLBase.DEFAULT_PLOT_FUNC, 3, 6),
]
@test SciMLBase.interpret_vars((1, [2, 3, 4]), sol) == [
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 2),
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 3),
    (SciMLBase.DEFAULT_PLOT_FUNC, 1, 4),
]

f(x, y) = (x + y, y)
@test SciMLBase.interpret_vars([(f, 0, 1), (1, 3), (4, 5)], sol) ==
    [(f, 0, 1), (SciMLBase.DEFAULT_PLOT_FUNC, 1, 3), (SciMLBase.DEFAULT_PLOT_FUNC, 4, 5)]
@test SciMLBase.interpret_vars([1, (f, 1, 3), (4, 5)], sol) ==
    [(SciMLBase.DEFAULT_PLOT_FUNC, 0, 1), (f, 1, 3), (SciMLBase.DEFAULT_PLOT_FUNC, 4, 5)]
@test SciMLBase.interpret_vars([1, (f, 0, 1), (1, 2)], sol) ==
    [(SciMLBase.DEFAULT_PLOT_FUNC, 0, 1), (f, 0, 1), (SciMLBase.DEFAULT_PLOT_FUNC, 1, 2)]
@test SciMLBase.interpret_vars([(1, 2)], sol) ==
    [(SciMLBase.DEFAULT_PLOT_FUNC, 1, 2)]
@test SciMLBase.interpret_vars((f, 1, 2), sol) == [(f, 1, 2)]

"""
$(TYPEDEF)

Holds a tableau which defines an explicit Runge-Kutta method.
"""
mutable struct ExplicitRKTableau{MType <: AbstractMatrix, VType <: AbstractVector, S, IType} <:
    ODERKTableau
    A::MType
    c::VType
    α::VType
    αEEst::VType
    d::VType # dense output coefficients
    stages::Int
    order::Int
    adaptiveorder::Int #The lower order of the pair. Only used for adaptivity.
    fsal::Bool
    stability_size::S
    B_interp::IType
end
function ExplicitRKTableau(
        A::MType, c::VType, α::VType, order;
        adaptiveorder = 0, αEEst = similar(α, 0),
        fsal = false, stability_size = 0.0,
        d = similar(α, 0), B_interp::IType = nothing
    ) where {MType, VType, IType}
    S = typeof(stability_size)
    return ExplicitRKTableau{MType, VType, S, IType}(
        A, c, α, αEEst, d, length(α), order, adaptiveorder,
        fsal, stability_size, B_interp
    )
end

"""
$(TYPEDEF)

Holds a tableau which defines an implicit Runge-Kutta method.
"""
mutable struct ImplicitRKTableau{MType <: AbstractMatrix, VType <: AbstractVector} <:
    ODERKTableau
    A::MType
    c::VType
    α::VType
    αEEst::VType
    stages::Int
    order::Int
    adaptiveorder::Int #The lower order of the pair. Only used for adaptivity.
end
function ImplicitRKTableau(
        A::MType, c::VType, α::VType, order;
        adaptiveorder = 0, αEEst = VType()
    ) where {MType, VType}
    return ImplicitRKTableau{MType, VType}(A, c, α, αEEst, length(α), order, adaptiveorder)
end

using LinearAlgebra, OrdinaryDiffEq, Test
using SciMLSensitivity  # Required for reverse-mode AD
using DifferentiationInterface
using ADTypes: AutoForwardDiff, AutoMooncake

# Load backends for all versions (required for DifferentiationInterface extensions)
using ForwardDiff
using Mooncake

# Version-dependent imports
if VERSION <= v"1.11"
    using Zygote
    using ADTypes: AutoZygote
end
if VERSION <= v"1.11"
    using Enzyme
    using ADTypes: AutoEnzyme
end

# Define backends based on Julia version
# ForwardDiff: All versions
# Mooncake: All versions
# Zygote: Julia <= 1.11
# Enzyme: Julia <= 1.11
function get_test_backends()
    backends = Pair{String, Any}[]
    # ForwardDiff on all versions
    push!(backends, "ForwardDiff" => AutoForwardDiff())
    # Mooncake on all versions
    push!(backends, "Mooncake" => AutoMooncake(; config = nothing))
    # Zygote only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Zygote" => AutoZygote())
    end
    # Enzyme only on Julia <= 1.11
    if VERSION <= v"1.11"
        push!(backends, "Enzyme" => AutoEnzyme())
    end
    return backends
end

# setup
pd = 3

## ode with complex numbers
H0 = rand(ComplexF64, pd, pd)
A = rand(ComplexF64, pd, pd)
function f!(du, u, p, t)
    a, b, c = p
    du .= (A * u) * (a * cos(b * t + c))
    du .+= H0 * u
    return nothing
end

## time span
tspan = (0.0, 1.0)

## initial state
u0 = hcat(normalize(rand(ComplexF64, pd)), normalize(rand(pd)))

## ode problem
prob0 = ODEProblem(
    f!, u0, tspan, rand(3); saveat = range(tspan..., length = 3),
    reltol = 1.0e-6,
    alg = Tsit5()
)
## final state cost
cost(u) = abs2(tr(first(u)'u[2])) - abs2(tr(first(u)'last(u)))

## real loss function via complex ode
function loss(p)
    prob = remake(prob0; p)
    sol = solve(prob)
    return cost(sol.u) + sum(p) / 10
end

## same problem via reals
### realify complex ode problem
function real_f(du, u, p, t)
    complex_u = complex.(selectdim(u, 3, 1), selectdim(u, 3, 2))
    complex_du = copy(complex_u)
    prob0.f(complex_du, complex_u, p, t)
    selectdim(du, 3, 1) .= real(complex_du)
    selectdim(du, 3, 2) .= imag(complex_du)
    return nothing
end
prob0_real = remake(prob0; f = real_f, u0 = cat(real(prob0.u0), imag(prob0.u0); dims = 3))
### real loss function via real ode
function loss_via_real(p)
    prob = remake(prob0_real; p)
    sol = solve(prob)
    u = [complex.(selectdim(u, 3, 1), selectdim(u, 3, 2)) for u in sol.u]
    return cost(u) + sum(p) / 10
end

# assert
@assert eltype(last(solve(prob0).u)) <: Complex
@assert eltype(last(solve(prob0_real).u)) <: Real
function assert_fun()
    p0 = rand(3)
    return isapprox(loss(p0), loss_via_real(p0); rtol = 1.0e-4)
end
@assert all([assert_fun() for _ in 1:(2^6)])

# test ad with DifferentiationInterface using multiple backends
backends = get_test_backends()
# Note: Mooncake and Enzyme are excluded due to issues with complex number ODE differentiation
backends_for_complex = filter(b -> b[1] ∉ ("Mooncake", "Enzyme"), backends)

function test_ad_with_backend(backend, name)
    p0 = rand(3)
    grad_real = DifferentiationInterface.gradient(loss_via_real, backend, p0)
    grad_complex = DifferentiationInterface.gradient(loss, backend, p0)
    any(isnan.(grad_complex)) &&
        @warn "NaN detected in gradient using ode with complex numbers with $name !!"
    any(isnan.(grad_real)) && @warn "NaN detected in gradient using realified ode with $name !!"
    rel_err = norm(grad_complex - grad_real) / max(norm(grad_complex), norm(grad_real))
    return isapprox(grad_complex, grad_real; rtol = 1.0e-6) ? true : (@show name, rel_err; false)
end

@testset "Complex number AD tests" begin
    for (name, backend) in backends_for_complex
        @testset "AD via ode with complex numbers ($name)" begin
            @time @test all([test_ad_with_backend(backend, name) for _ in 1:(2^6)])
        end
    end
end

module DiffEqBaseMPIExt

using DiffEqBase
import MPI

if isdefined(MPI, :AbstractMultiRequest)
    function DiffEqBase.anyeltypedual(
            ::Type{T},
            counter = 0
        ) where {T <: MPI.AbstractMultiRequest}
        return Any
    end
end

end

module DiffEqBaseMonteCarloMeasurementsExt

using DiffEqBase
import DiffEqBase: value
using MonteCarloMeasurements

# Support adaptive steps should be errorless
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{
            <:MonteCarloMeasurements.AbstractParticles,
            N,
        }, t
    ) where {N}
    return sqrt(
        mean(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        )
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{
            <:MonteCarloMeasurements.AbstractParticles,
            N,
        },
        t::AbstractArray{
            <:MonteCarloMeasurements.AbstractParticles,
            N,
        }
    ) where {N}
    return sqrt(
        mean(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(value.(t)))
        )
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::MonteCarloMeasurements.AbstractParticles, t)
    return abs(value(u))
end

end

# ncondition tests
using OrdinaryDiffEq, Test

function f(u, p, t)
    return 5 * u
end
u0 = [1.0, 1.0]
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
x = Ref(0)

condition = function (u, t, integrator)
    x[] += 1
    return 0
end
affect! = function (integrator) end
cb = ContinuousCallback(condition, affect!)
sol = solve(prob, Vern9(), callback = cb)
@test x[] == sol.stats.ncondition

condition = function (u, t, integrator)
    x[] += 1
    return t - 0.46
end
x[] = 0
cb = ContinuousCallback(condition, affect!)
sol = solve(prob, Vern9(), callback = cb)
@test x[] == sol.stats.ncondition

condition = function (u, t, integrator)
    x[] += 1
    return 1
end
x[] = 0
cb = ContinuousCallback(condition, affect!)
sol = solve(prob, Vern9(), callback = cb)
@test x[] == sol.stats.ncondition

condition = function (u, t, integrator)
    x[] += 1
    return true
end
x[] = 0
cb = DiscreteCallback(condition, affect!)
sol = solve(prob, Vern9(), callback = cb)
@test x[] == sol.stats.ncondition

using Pkg
using SafeTestsets
using Test

const GROUP = get(ENV, "GROUP", "All")
const is_APPVEYOR = (Sys.iswindows() && haskey(ENV, "APPVEYOR"))

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

function activate_static_env()
    Pkg.activate("static")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

function activate_gpu_env()
    Pkg.activate("gpu")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

@time begin
    if GROUP == "All" || GROUP == "Core"
        @time @safetestset "Callbacks" include("callbacks.jl")
        @time @safetestset "Plot Vars" include("plot_vars.jl")
        @time @safetestset "Problem Creation Tests" include("problem_creation_tests.jl")
        @time @safetestset "Export tests" include("export_tests.jl")
        @time @safetestset "Remake tests" include("remake_tests.jl")
        @time @safetestset "High Level solve Interface" include("high_level_solve.jl")
        @time @safetestset "DiffEqFunction tests" include("diffeqfunction_tests.jl")
        @time @safetestset "Internal Euler" include("internal_euler_test.jl")
        @time @safetestset "Norm" include("norm.jl")
        @time @safetestset "Utils" include("utils.jl")
        @time @safetestset "ForwardDiff Dual Detection" include("forwarddiff_dual_detection.jl")
        @time @safetestset "ODE default norm" include("ode_default_norm.jl")
        @time @safetestset "ODE default unstable check" include("ode_default_unstable_check.jl")
        @time @safetestset "Problem Kwargs Merging" include("problem_kwargs_merging.jl")
    end

    if !is_APPVEYOR && GROUP == "Downstream"
        activate_downstream_env()
        @time @safetestset "Kwarg Warnings" include("downstream/kwarg_warn.jl")
        @time @safetestset "Solve Error Handling" include("downstream/solve_error_handling.jl")
        @time @safetestset "Null DE Handling" include("downstream/null_de.jl")
        @time @safetestset "StaticArrays + AD" include("downstream/static_arrays_ad.jl")
        @time @safetestset "Unitful" include("downstream/unitful.jl")
        @time @safetestset "FlexUnits" include("downstream/flexunits.jl")
        @time @safetestset "Dual Detection Solution" include("downstream/dual_detection_solution.jl")
        @time @safetestset "Null Parameters" include("downstream/null_params_test.jl")
        @time @safetestset "Ensemble Simulations" include("downstream/ensemble.jl")
        @time @safetestset "Ensemble Analysis" include("downstream/ensemble_analysis.jl")
        @time @safetestset "Ensemble Thread Safety" include("downstream/ensemble_thread_safety.jl")
        @time @safetestset "Inference Tests" include("downstream/inference.jl")
        @time @safetestset "Table Inference Tests" include("downstream/tables.jl")
        @time @safetestset "Default linsolve with structure" include("downstream/default_linsolve_structure.jl")
        @time @safetestset "Callback Merging Tests" include("downstream/callback_merging.jl")
        @time @safetestset "Callback Detection Tests" include("downstream/callback_detection.jl")
        @time @safetestset "LabelledArrays Tests" include("downstream/labelledarrays.jl")
        @time @safetestset "GTPSA Tests" include("downstream/gtpsa.jl")
        @time @safetestset "SubArray Support" include("downstream/subarray_support.jl")
    end

    if !is_APPVEYOR && GROUP == "Static"
        activate_static_env()
        @time @safetestset "Static Checks" include("static/static_checks.jl")
    end

    if !is_APPVEYOR && GROUP == "Downstream2"
        activate_downstream_env()
        @time @safetestset "Prob Kwargs" include("downstream/prob_kwargs.jl")
        @time @safetestset "Unwrapping" include("downstream/unwrapping.jl")
        @time @safetestset "Callback BigFloats" include("downstream/bigfloat_events.jl")
        @time @safetestset "DE stats" include("downstream/stats_tests.jl")
        isempty(VERSION.prerelease) &&
            @time @safetestset "Ensemble AD Tests" include("downstream/ensemble_ad.jl")
        @time @safetestset "Community Callback Tests" include("downstream/community_callback_tests.jl")
        @time @safetestset "AD via ode with complex numbers" include("downstream/complex_number_ad.jl")
        @time @safetestset "Callback AD Tests" include("downstream/callback_ad.jl")
        @time @testset "Distributed Ensemble Tests" include("downstream/distributed_ensemble.jl")
    end

    if !is_APPVEYOR && GROUP == "GPU"
        activate_gpu_env()
        @time @safetestset "Simple GPU" include("gpu/simple_gpu.jl")
    end
end

module DiffEqBaseUnitfulExt

using DiffEqBase
import SciMLBase: unitfulvalue, value
using Unitful

# Support adaptive errors should be errorless for exponentiation
value(x::Type{Unitful.AbstractQuantity{T, D, U}}) where {T, D, U} = T
value(x::Unitful.AbstractQuantity) = x.val

unitfulvalue(x::Type{T}) where {T <: Unitful.AbstractQuantity} = T
unitfulvalue(x::Unitful.AbstractQuantity) = x

@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::AbstractArray{
            <:Unitful.AbstractQuantity,
            N,
        },
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline function DiffEqBase.ODE_DEFAULT_NORM(
        u::Array{<:Unitful.AbstractQuantity, N},
        t
    ) where {N}
    return sqrt(
        sum(
            x -> DiffEqBase.ODE_DEFAULT_NORM(x[1], x[2]),
            zip((value(x) for x in u), Iterators.repeated(t))
        ) / length(u)
    )
end
@inline DiffEqBase.ODE_DEFAULT_NORM(u::Unitful.AbstractQuantity, t) = abs(value(u))
@inline function DiffEqBase.UNITLESS_ABS2(x::Unitful.AbstractQuantity)
    return real(abs2(x) / oneunit(x) * oneunit(x))
end

DiffEqBase._rate_prototype(u, t, onet) = u / unit(t)
end

"""
    calculate_residuals(ũ, u₀, u₁, α, ρ, internalnorm, t)

Calculate element-wise residuals
```math
\\frac{ũ}{α+\\max{|u₀|,|u₁|}*ρ}
```
"""
@inline @muladd function calculate_residuals(
        ũ::Number, u₀::Number, u₁::Number,
        α, ρ, internalnorm, t
    )
    @fastmath ũ / (α + max(internalnorm(u₀, t), internalnorm(u₁, t)) * ρ)
end

@inline function calculate_residuals(
        ũ::Array{T}, u₀::Array{T}, u₁::Array{T}, α::T2,
        ρ::Real, internalnorm,
        t
    ) where
    {T <: Number, T2 <: Number}
    out = similar(ũ)
    calculate_residuals!(out, ũ, u₀, u₁, α, ρ, internalnorm, t)
    return out
end

@inline function calculate_residuals(ũ, u₀, u₁, α, ρ, internalnorm, t)
    return @.. broadcast = false calculate_residuals(ũ, u₀, u₁, α, ρ, internalnorm, t)
end

"""
    calculate_residuals(u₀, u₁, α, ρ, internalnorm, t)

Calculate element-wise residuals
```math
\\frac{u₁ - u₀}{α+\\max{|u₀|,|u₁|}*ρ}
```
"""

@inline @muladd function calculate_residuals(
        u₀::Number, u₁::Number,
        α, ρ, internalnorm, t
    )
    @fastmath (u₁ - u₀) / (α + max(internalnorm(u₀, t), internalnorm(u₁, t)) * ρ)
end

@inline function calculate_residuals(
        u₀::Array{T}, u₁::Array{T}, α::T2,
        ρ::Real, internalnorm,
        t
    ) where {T <: Number, T2 <: Number}
    out = similar(u₀)
    calculate_residuals!(out, u₀, u₁, α, ρ, internalnorm, t)
    return out
end

@inline function calculate_residuals(u₀, u₁, α, ρ, internalnorm, t)
    return @.. broadcast = false calculate_residuals(u₀, u₁, α, ρ, internalnorm, t)
end

"""
    calculate_residuals(E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, t)

Return element-wise residuals
```math
\\frac{δ E₁ + E₂}{α+\\max{scalarnorm(u₀),scalarnorm(u₁)}*ρ}.
```
"""
@inline @muladd function calculate_residuals(
        E₁::Number, E₂::Number, u₀::Number, u₁::Number,
        α::Real, ρ::Real, δ::Number, scalarnorm, t
    )
    @fastmath (δ * E₁ + E₂) / (α + max(scalarnorm(u₀, t), scalarnorm(u₁, t)) * ρ)
end

@inline function calculate_residuals(
        E₁::Array{<:Number}, E₂::Array{<:Number},
        u₀::Array{<:Number}, u₁::Array{<:Number}, α::Real,
        ρ::Real, δ::Number, scalarnorm, t
    )
    out = similar(u₀)
    calculate_residuals!(out, E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, t)
    return out
end

@inline function calculate_residuals(E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, t)
    return @.. broadcast = false calculate_residuals(E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, t)
end

# Inplace Versions

"""
    DiffEqBase.calculate_residuals!(out, ũ, u₀, u₁, α, ρ, thread=False())

Save element-wise residuals
```math
\\frac{ũ}{α+\\max{|u₀|,|u₁|}*ρ}
```
in `out`.

The argument `thread` determines whether internal broadcasting on
appropriate CPU arrays should be serial (`thread = False()`, default)
or use multiple threads (`thread = True()`) when Julia is started
with multiple threads.
"""
@inline function calculate_residuals!(
        out, ũ, u₀, u₁, α, ρ, internalnorm, t,
        thread::Union{False, True} = False()
    )
    @.. broadcast = false thread = thread out = calculate_residuals(
        ũ, u₀, u₁, α, ρ, internalnorm,
        t
    )
    return nothing
end

@inline function calculate_residuals!(
        out::Array, ũ::Array, u₀::Array, u₁::Array, α::Number,
        ρ::Number, internalnorm::F, t, ::False
    ) where {F}
    @inbounds @simd ivdep for i in eachindex(out, ũ, u₀, u₁)
        out[i] = calculate_residuals(ũ[i], u₀[i], u₁[i], α, ρ, internalnorm, t)
    end
    return nothing
end

"""
    calculate_residuals!(out, u₀, u₁, α, ρ, thread=False())

Save element-wise residuals
```math
\\frac{u₁ - u₀}{α+\\max{|u₀|,|u₁|}*ρ}
```
in `out`.

The argument `thread` determines whether internal broadcasting on
appropriate CPU arrays should be serial (`thread = False()`, default)
or use multiple threads (`thread = True()`) when Julia is started
with multiple threads.
"""
@inline function calculate_residuals!(
        out, u₀, u₁, α, ρ, internalnorm, t,
        thread::Union{False, True} = False()
    )
    return @.. broadcast = false thread = thread out = calculate_residuals(u₀, u₁, α, ρ, internalnorm, t)
end

"""
    calculate_residuals!(out, E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, thread=False())

Calculate element-wise residuals
```math
\\frac{δ E₁ + E₂}{α+\\max{scalarnorm(u₀),scalarnorm(u₁)}*ρ}.
```

The argument `thread` determines whether internal broadcasting on
appropriate CPU arrays should be serial (`thread = False()`, default)
or use multiple threads (`thread = True()`) when Julia is started
with multiple threads.
"""
@inline function calculate_residuals!(
        out, E₁, E₂, u₀, u₁, α, ρ, δ, scalarnorm, t,
        thread::Union{False, True} = False()
    )
    @.. broadcast = false thread = thread out = calculate_residuals(
        E₁, E₂, u₀, u₁, α, ρ, δ,
        scalarnorm, t
    )
    return out
end

using OrdinaryDiffEq, Test
function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan, alg = Tsit5())
@test_nowarn sol = solve(prob, reltol = 1.0e-6)
sol = solve(prob, reltol = 1.0e-6)
@test sol.alg isa Tsit5

new_u0 = rand(3)
sol = solve(prob, u0 = new_u0)
@test sol.prob.u0 === new_u0

module DiffEqBase
if isdefined(Base, :Experimental) &&
        isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end

import PrecompileTools

import FastPower
@deprecate fastpow(x, y) FastPower.fastpower(x, y)

using ArrayInterface

using StaticArraysCore # data arrays

using LinearAlgebra, Printf

using DocStringExtensions

using FunctionWrappers: FunctionWrapper

using MuladdMacro


using FastBroadcast: @.., True, False

using Static: reduce_tup

import RecursiveArrayTools
import TruncatedStacktraces

using Setfield


using Markdown

using ConcreteStructs: @concrete
using FastClosures: @closure

import FunctionWrappersWrappers

using SciMLBase

using SciMLOperators: AbstractSciMLOperator, AbstractSciMLScalarOperator, DEFAULT_UPDATE_FUNC

using SciMLBase: @def, DEIntegrator, AbstractDEProblem,
    AbstractDiffEqInterpolation,
    DECallback, AbstractDEOptions, DECache, AbstractContinuousCallback,
    AbstractDiscreteCallback, AbstractLinearProblem,
    AbstractNonlinearProblem,
    AbstractOptimizationProblem, AbstractSteadyStateProblem,
    AbstractJumpProblem,
    AbstractNoiseProblem, AbstractEnsembleProblem,
    AbstractDynamicalODEProblem,
    AbstractDEAlgorithm, StandardODEProblem, AbstractIntegralProblem,
    AbstractSensitivityAlgorithm, AbstractODEAlgorithm,
    AbstractSDEAlgorithm, AbstractDDEAlgorithm, AbstractDAEAlgorithm,
    AbstractSDDEAlgorithm, AbstractRODEAlgorithm, AbstractBVPAlgorithm,
    DAEInitializationAlgorithm,
    AbstractSteadyStateAlgorithm, AbstractODEProblem,
    AbstractDiscreteProblem, AbstractNonlinearAlgorithm,
    AbstractSDEProblem, AbstractRODEProblem, AbstractDDEProblem,
    AbstractDAEProblem, AbstractSDDEProblem, AbstractBVProblem,
    AbstractTimeseriesSolution, AbstractNoTimeSolution, numargs,
    AbstractODEFunction, AbstractSDEFunction, AbstractRODEFunction,
    AbstractDDEFunction, AbstractSDDEFunction, AbstractDAEFunction,
    AbstractNonlinearFunction, AbstractEnsembleSolution,
    AbstractODESolution, AbstractRODESolution, AbstractDAESolution,
    AbstractDDESolution,
    EnsembleAlgorithm, EnsembleSolution, EnsembleSummary,
    NonlinearSolution,
    TimeGradientWrapper, TimeDerivativeWrapper, UDerivativeWrapper,
    UJacobianWrapper, ParamJacobianWrapper, JacobianWrapper,
    check_error!, has_jac, has_tgrad, has_Wfact, has_Wfact_t, has_paramjac,
    AbstractODEIntegrator, AbstractSDEIntegrator, AbstractRODEIntegrator,
    AbstractDDEIntegrator, AbstractSDDEIntegrator,
    AbstractDAEIntegrator, unwrap_cache, has_reinit, reinit!,
    postamble!, last_step_failed, islinear, has_stats,
    initialize_dae!, build_solution, solution_new_retcode,
    solution_new_tslocation, plot_indices, NonlinearAliasSpecifier,
    NullParameters, isinplace, AbstractADType, AbstractDiscretization,
    DISCRETE_OUTOFPLACE_DEFAULT, DISCRETE_INPLACE_DEFAULT,
    has_analytic, calculate_solution_errors!, AbstractNoiseProcess,
    has_colorvec, parameterless_type, undefined_exports,
    is_diagonal_noise, AbstractDiffEqFunction, sensitivity_solution,
    interp_summary, AbstractHistoryFunction, LinearInterpolation,
    ConstantInterpolation, HermiteInterpolation, SensitivityInterpolation,
    NoAD, @add_kwonly,
    calculate_ensemble_errors, isconstant,
    DEFAULT_REDUCTION, isautodifferentiable,
    isadaptive, isdiscrete, has_syms, AbstractAnalyticalSolution,
    RECOMPILE_BY_DEFAULT, wrap_sol, has_destats

import SciMLBase: solve, init, step!, solve!, __init, __solve, update_coefficients!,
    update_coefficients, isadaptive, wrapfun_oop, wrapfun_iip,
    unwrap_fw, promote_tspan, set_u!, set_t!, set_ut!,
    extract_alg, checkkwargs, has_kwargs, _concrete_solve_adjoint, _concrete_solve_forward,
    eltypedual, get_updated_symbolic_problem, get_concrete_p, get_concrete_u0, promote_u0,
    isconcreteu0, isconcretedu0, get_concrete_du0, _reshape, value, unitfulvalue, anyeltypedual, allowedkeywords,
    sse, totallength, __sum, DualEltypeChecker, KeywordArgError, KeywordArgWarn, KeywordArgSilent, KWARGWARN_MESSAGE, KWARGERROR_MESSAGE,
    CommonKwargError, IncompatibleInitialConditionError, NO_DEFAULT_ALGORITHM_MESSAGE, NoDefaultAlgorithmError, NO_TSPAN_MESSAGE, NoTspanError,
    NAN_TSPAN_MESSAGE, NaNTspanError, NON_SOLVER_MESSAGE, NonSolverError, NOISE_SIZE_MESSAGE, NoiseSizeIncompatibilityError, PROBSOLVER_PAIRING_MESSAGE,
    ProblemSolverPairingError, compatible_problem_types, DIRECT_AUTODIFF_INCOMPATIBILITY_MESSAGE, DirectAutodiffError, NONNUMBER_ELTYPE_MESSAGE, NonNumberEltypeError,
    GENERIC_NUMBER_TYPE_ERROR_MESSAGE, GenericNumberTypeError, COMPLEX_SUPPORT_ERROR_MESSAGE, ComplexSupportError, COMPLEX_TSPAN_ERROR_MESSAGE, ComplexTspanError,
    TUPLE_STATE_ERROR_MESSAGE, TupleStateError, MASS_MATRIX_ERROR_MESSAGE, IncompatibleMassMatrixError, LATE_BINDING_TSTOPS_ERROR_MESSAGE, LateBindingTstopsNotSupportedError,
    NONCONCRETE_ELTYPE_MESSAGE, NonConcreteEltypeError, _vec

import SciMLStructures

using Reexport
Reexport.@reexport using SciMLBase

SciMLBase.isfunctionwrapper(x::FunctionWrapper) = true

# Rootfinder for callbacks
using BracketingNonlinearSolve: ModAB

import SymbolicIndexingInterface as SII

## Extension Functions

## Types

"""
$(TYPEDEF)
"""
abstract type Tableau end

"""
$(TYPEDEF)
"""
abstract type ODERKTableau <: Tableau end

"""
$(TYPEDEF)
"""
abstract type DECostFunction end

import SciMLBase: Void, unwrapped_f

include("utils.jl")
include("stats.jl")
include("calculate_residuals.jl")
include("tableaus.jl")
include("dae_initialization.jl")

include("callbacks.jl")
include("common_defaults.jl")
include("solve.jl")
include("internal_euler.jl")
include("norecompile.jl")
include("integrator_accessors.jl")

# This is only used for oop stiff solvers
default_factorize(A) = lu(A; check = false)

if isdefined(SciMLBase, :AbstractParameterizedFunction)
    import SciMLBase: AbstractParameterizedFunction
else
    """
    $(TYPEDEF)
    """
    abstract type AbstractParameterizedFunction{iip} <: AbstractODEFunction{iip} end
end

"""
$(TYPEDEF)
"""
struct ConvergenceSetup{P, C}
    probs::P
    convergence_axis::C
end

export initialize!, finalize!

export SensitivityADPassThrough

include("precompilation.jl")

end # module

@verbosity_specifier DEVerbosity begin
    toggles = (
        :linear_verbosity, :nonlinear_verbosity,
        :dt_NaN, :init_NaN, :dense_output_saveat, :max_iters, :dt_min_unstable, :instability, :inconsistent_input,
        :newton_convergence, :step_rejected, :step_accepted, :convergence_limit,
        :alg_switch, :stiff_detection, :mismatched_input_output_type, :jacobian_update,
        :w_factorization, :newton_iterations,
        :rosenbrock_no_differential_states, :shampine_dt, :unlimited_dt, :dt_epsilon,
        :stability_check, :near_singular,
        :sensitivity_vjp_choice,
        # SDE-specific fields
        :noise_evaluation,
        # DDE-specific fields
        :discontinuity_tracking,
        :delay_evaluation,
        :constrained_step,
        :residual_control,
        :neutral_delay,
        :state_dependent_delay,
    )

    presets = (
        None = (
            linear_verbosity = None(),
            nonlinear_verbosity = None(),
            dt_NaN = Silent(),
            init_NaN = Silent(),
            dense_output_saveat = Silent(),
            max_iters = Silent(),
            dt_min_unstable = Silent(),
            instability = Silent(),
            inconsistent_input = Silent(),
            newton_convergence = Silent(),
            step_rejected = Silent(),
            step_accepted = Silent(),
            convergence_limit = Silent(),
            alg_switch = Silent(),
            stiff_detection = Silent(),
            mismatched_input_output_type = Silent(),
            jacobian_update = Silent(),
            w_factorization = Silent(),
            newton_iterations = Silent(),
            rosenbrock_no_differential_states = Silent(),
            shampine_dt = Silent(),
            unlimited_dt = Silent(),
            dt_epsilon = Silent(),
            stability_check = Silent(),
            near_singular = Silent(),
            sensitivity_vjp_choice = Silent(),
            # SDE-specific fields
            noise_evaluation = Silent(),
            # DDE-specific fields
            discontinuity_tracking = Silent(),
            delay_evaluation = Silent(),
            constrained_step = Silent(),
            residual_control = Silent(),
            neutral_delay = Silent(),
            state_dependent_delay = Silent(),
        ),
        Minimal = (
            linear_verbosity = Minimal(),
            nonlinear_verbosity = Minimal(),
            dt_NaN = WarnLevel(),
            init_NaN = WarnLevel(),
            dense_output_saveat = Silent(),
            max_iters = WarnLevel(),
            dt_min_unstable = WarnLevel(),
            instability = WarnLevel(),
            inconsistent_input = WarnLevel(),
            newton_convergence = WarnLevel(),
            step_rejected = Silent(),
            step_accepted = Silent(),
            convergence_limit = Silent(),
            alg_switch = Silent(),
            stiff_detection = Silent(),
            mismatched_input_output_type = Silent(),
            jacobian_update = Silent(),
            w_factorization = Silent(),
            newton_iterations = Silent(),
            rosenbrock_no_differential_states = WarnLevel(),
            shampine_dt = Silent(),
            unlimited_dt = WarnLevel(),
            dt_epsilon = WarnLevel(),
            stability_check = Silent(),
            near_singular = WarnLevel(),
            sensitivity_vjp_choice = Silent(),
            # SDE-specific fields
            noise_evaluation = Silent(),
            # DDE-specific fields
            discontinuity_tracking = Silent(),
            delay_evaluation = Silent(),
            constrained_step = Silent(),
            residual_control = Silent(),
            neutral_delay = Silent(),
            state_dependent_delay = WarnLevel(),
        ),
        Standard = (
            linear_verbosity = Minimal(),
            nonlinear_verbosity = Minimal(),
            dt_NaN = WarnLevel(),
            init_NaN = WarnLevel(),
            dense_output_saveat = WarnLevel(),
            max_iters = WarnLevel(),
            dt_min_unstable = WarnLevel(),
            instability = WarnLevel(),
            inconsistent_input = WarnLevel(),
            newton_convergence = Silent(),
            step_rejected = Silent(),
            step_accepted = Silent(),
            convergence_limit = Silent(),
            alg_switch = Silent(),
            stiff_detection = Silent(),
            mismatched_input_output_type = WarnLevel(),
            jacobian_update = Silent(),
            w_factorization = Silent(),
            newton_iterations = Silent(),
            rosenbrock_no_differential_states = WarnLevel(),
            shampine_dt = Silent(),
            unlimited_dt = WarnLevel(),
            dt_epsilon = WarnLevel(),
            stability_check = Silent(),
            near_singular = Silent(),
            sensitivity_vjp_choice = Silent(),
            # SDE-specific fields
            noise_evaluation = Silent(),
            # DDE-specific fields
            discontinuity_tracking = Silent(),
            delay_evaluation = Silent(),
            constrained_step = Silent(),
            residual_control = Silent(),
            neutral_delay = Silent(),
            state_dependent_delay = Silent(),
        ),
        Detailed = (
            linear_verbosity = Detailed(),
            nonlinear_verbosity = Detailed(),
            dt_NaN = WarnLevel(),
            init_NaN = WarnLevel(),
            dense_output_saveat = InfoLevel(),
            max_iters = WarnLevel(),
            dt_min_unstable = WarnLevel(),
            instability = WarnLevel(),
            inconsistent_input = WarnLevel(),
            newton_convergence = WarnLevel(),
            step_rejected = Silent(),
            step_accepted = Silent(),
            convergence_limit = InfoLevel(),
            alg_switch = InfoLevel(),
            stiff_detection = Silent(),
            mismatched_input_output_type = WarnLevel(),
            jacobian_update = InfoLevel(),
            w_factorization = InfoLevel(),
            newton_iterations = InfoLevel(),
            rosenbrock_no_differential_states = WarnLevel(),
            shampine_dt = InfoLevel(),
            unlimited_dt = WarnLevel(),
            dt_epsilon = InfoLevel(),
            stability_check = InfoLevel(),
            near_singular = WarnLevel(),
            sensitivity_vjp_choice = WarnLevel(),
            # SDE-specific fields
            noise_evaluation = InfoLevel(),
            # DDE-specific fields
            discontinuity_tracking = InfoLevel(),
            delay_evaluation = InfoLevel(),
            constrained_step = InfoLevel(),
            residual_control = InfoLevel(),
            neutral_delay = InfoLevel(),
            state_dependent_delay = WarnLevel(),
        ),
        All = (
            linear_verbosity = All(),
            nonlinear_verbosity = All(),
            dt_NaN = WarnLevel(),
            init_NaN = WarnLevel(),
            dense_output_saveat = InfoLevel(),
            max_iters = WarnLevel(),
            dt_min_unstable = WarnLevel(),
            instability = WarnLevel(),
            inconsistent_input = WarnLevel(),
            newton_convergence = WarnLevel(),
            step_rejected = InfoLevel(),
            step_accepted = InfoLevel(),
            convergence_limit = InfoLevel(),
            alg_switch = InfoLevel(),
            stiff_detection = InfoLevel(),
            mismatched_input_output_type = InfoLevel(),
            jacobian_update = InfoLevel(),
            w_factorization = InfoLevel(),
            newton_iterations = InfoLevel(),
            rosenbrock_no_differential_states = WarnLevel(),
            shampine_dt = InfoLevel(),
            unlimited_dt = WarnLevel(),
            dt_epsilon = InfoLevel(),
            stability_check = InfoLevel(),
            near_singular = WarnLevel(),
            sensitivity_vjp_choice = WarnLevel(),
            # SDE-specific fields
            noise_evaluation = InfoLevel(),
            # DDE-specific fields
            discontinuity_tracking = InfoLevel(),
            delay_evaluation = InfoLevel(),
            constrained_step = InfoLevel(),
            residual_control = InfoLevel(),
            neutral_delay = InfoLevel(),
            state_dependent_delay = InfoLevel(),
        ),
    )

    groups = (
        error_control = (
            :dt_NaN, :init_NaN, :dense_output_saveat, :max_iters, :dt_min_unstable,
            :instability, :inconsistent_input, :newton_convergence, :step_rejected, :step_accepted, :convergence_limit,
        ),
        performance = (
            :alg_switch, :stiff_detection, :mismatched_input_output_type, :jacobian_update,
            :w_factorization, :newton_iterations,
        ),
        numerical = (
            :rosenbrock_no_differential_states, :shampine_dt, :unlimited_dt, :dt_epsilon,
            :stability_check, :near_singular,
        ),
        sensitivity = (
            :sensitivity_vjp_choice,
        ),
        sde_specific = (
            :noise_evaluation,
        ),
        dde_specific = (
            :discontinuity_tracking,
            :delay_evaluation,
            :constrained_step,
            :residual_control,
            :neutral_delay,
            :state_dependent_delay,
        ),
    )
end

"""
    DEVerbosity <: AbstractVerbositySpecifier

Verbosity configuration for differential equation solvers, providing fine-grained control over
diagnostic messages, warnings, and errors during solution.

# Fields

## Solver Verbosity
- `linear_verbosity`: Verbosity configuration for linear solvers
- `nonlinear_verbosity`: Verbosity configuration for nonlinear solvers

## Error Control Group
- `dt_NaN`: Messages when time step becomes NaN
- `init_NaN`: Messages when initial conditions contain NaN
- `dense_output_saveat`: Messages about dense output with saveat
- `max_iters`: Messages when maximum iterations are reached
- `dt_min_unstable`: Messages when time step becomes too small/unstable
- `instability`: Messages when numerical instability is detected
- `newton_convergence`: Messages when Newton iteration fails to converge
- `step_rejected`: Messages when adaptive steps are rejected
- `step_accepted`: Messages when adaptive steps are accepted
- `convergence_limit`: Messages when convergence at floating point precision limit

## Performance Group
- `alg_switch`: Messages when algorithm switching occurs
- `stiff_detection`: Messages when stiffness is detected
- `mismatched_input_output_type`: Messages when input/output types don't match
- `jacobian_update`: Messages when Jacobian matrix is computed/updated
- `w_factorization`: Messages when W matrix is factorized
- `newton_iterations`: Messages about Newton iteration progress

## Numerical Group
- `rosenbrock_no_differential_states`: Messages when Rosenbrock has no differential states
- `shampine_dt`: Messages about Shampine time step selection
- `unlimited_dt`: Messages when time step is unlimited
- `dt_epsilon`: Messages when timestep goes below floating point epsilon
- `stability_check`: Messages about stability checks in extrapolation methods
- `near_singular`: Messages when Jacobian/mass matrix appears near-singular

## Sensitivity Group
- `sensitivity_vjp_choice`: Messages about VJP choice in sensitivity analysis (used by SciMLSensitivity.jl)

## SDE-Specific Group (used by StochasticDiffEq.jl)
- `noise_evaluation`: Messages about noise term evaluation

## DDE-Specific Group (used by DelayDiffEq.jl)
- `discontinuity_tracking`: Messages about discontinuity propagation tracking
- `delay_evaluation`: Messages about delay term evaluation
- `constrained_step`: Messages when step size is constrained by discontinuities
- `residual_control`: Messages about residual control in implicit methods
- `neutral_delay`: Messages specific to neutral delay equations
- `state_dependent_delay`: Messages when state-dependent delays are detected/evaluated

# Constructors

    DEVerbosity(preset::AbstractVerbosityPreset)

Create a `DEVerbosity` using a preset configuration:
- `SciMLLogging.None()`: All messages disabled
- `SciMLLogging.Minimal()`: Only critical errors and fatal issues
- `SciMLLogging.Standard()`: Balanced verbosity (default)
- `SciMLLogging.Detailed()`: Comprehensive debugging information
- `SciMLLogging.All()`: Maximum verbosity

    DEVerbosity(; preset=nothing, error_control=nothing, performance=nothing, numerical=nothing, sde_specific=nothing, dde_specific=nothing, kwargs...)

Create a `DEVerbosity` with group-level or individual field control.

# Examples

```julia
# Use a preset
verbose = DEVerbosity(SciMLLogging.Standard())

# Set entire groups
verbose = DEVerbosity(
    error_control = SciMLLogging.WarnLevel(),
    numerical = SciMLLogging.InfoLevel()
)

# Set individual fields
verbose = DEVerbosity(
    dt_NaN = SciMLLogging.ErrorLevel(),
    alg_switch = SciMLLogging.InfoLevel()
)

# Mix group and individual settings
verbose = DEVerbosity(
    numerical = SciMLLogging.InfoLevel(),  # Set all numerical to InfoLevel
    unlimited_dt = SciMLLogging.ErrorLevel()  # Override specific field
)
```
"""
function DEVerbosity end

const DEFAULT_VERBOSE = DEVerbosity()
const NONE_VERBOSE = DEVerbosity(SciMLLogging.None())

@inline function _process_verbose_param(verbose::SciMLLogging.AbstractVerbosityPreset)
    return DEVerbosity(verbose)
end

@inline _process_verbose_param(::Val{true}) = DEFAULT_VERBOSE
@inline _process_verbose_param(::Val{false}) = NONE_VERBOSE

Base.@constprop :aggressive @inline function _process_verbose_param(verbose::Bool)
    return verbose ? DEFAULT_VERBOSE : NONE_VERBOSE
end

@inline _process_verbose_param(verbose::DEVerbosity) = verbose

using DiffEqBase, Test

function f_lin(du, u, p, t)
    du[1] = 0.2u[1] + p[1] * u[2]
    return du[2] = 0.2u[1] - p[2] * u[2]
end
p = (0.0, 1.0)
prob = LinearProblem(f_lin, ones(2))
prob = LinearProblem(rand(2, 2), ones(2))

function f_nonlin(du, u, p)
    du[1] = 0.2u[1] + p[1] * u[2]
    return du[2] = 0.2u[1] - p[2] * u[2]
end
p = (0.0, 1.0)
prob = NonlinearProblem(f_nonlin, ones(2), p)

function f_quad(du, u, p)
    du[1] = 0.2u[1] + p[1] * u[2]
    return du[2] = 0.2u[1] - p[2] * u[2]
end
p = (0.0, 1.0)
prob = IntegralProblem(f_quad, (zeros(2), ones(2)), p)

function f_ode(du, u, p, t)
    du[1] = 0.2u[1]
    return du[2] = 0.4u[2]
end
u0 = ones(2)
tspan = (0, 1.0)

prob = ODEProblem(f_ode, u0, tspan)
@test typeof(prob.tspan) == Tuple{Float64, Float64}
prob = ODEProblem{true}(f_ode, u0, tspan)
@test typeof(prob.tspan) == Tuple{Float64, Float64}
prob = ODEProblem(ODEFunction{true}(f_ode), u0, tspan)
@test typeof(prob.tspan) == Tuple{Float64, Float64}
@test isinplace(prob) == true
prob = ODEProblem{false}(f_ode, u0, tspan)
@test isinplace(prob) == false

@inferred ODEProblem{true}(f_ode, u0, tspan)
@test_broken @inferred(ODEProblem(f_ode, u0, tspan)) == ODEProblem(f_ode, u0, tspan)

function f_2ndorder(dv, u, v, p, t)
    return dv .= 2.0 .* v
end
u0 = ones(2)
v0 = ones(2)
tspan = (0, 1.0)
prob = SecondOrderODEProblem(f_2ndorder, u0, v0, tspan)

prob = SDEProblem((u, p, t) -> 1.01u, (u, p, t) -> 0.87u, 1 / 2, (0.0, 1.0))

function f_sde(du, u, p, t)
    du[1] = 0.2u[1]
    return du[2] = 0.4u[2]
end
function g_sde(du, u, p, t)
    du[1] = 0.2u[1]
    return du[2] = 0.4u[2]
end
u0 = ones(2)
tspan = (0, 1.0)
prob = SDEProblem(f_sde, g_sde, u0, tspan)
prob = SDEProblem{true}(f_sde, g_sde, u0, tspan)

@test_broken @inferred(SDEProblem(f_sde, g_sde, u0, tspan)) == SDEProblem(f_sde, g_sde, u0, tspan)
@inferred SDEProblem{true}(f_sde, g_sde, u0, tspan)

f_1delay = function (du, u, h, p, t)
    return du[1] = -h(t - 1)[1]
end
prob = DDEProblem(f_1delay, ones(1), t -> zeros(1), (0.0, 10.0), constant_lags = ones(1))
prob = DDEProblem{true}(
    f_1delay, ones(1), t -> zeros(1), (0.0, 10.0),
    dependent_lags = ones(1)
)

@test_broken @inferred(
    DDEProblem(
        f_1delay, ones(1), t -> zeros(1), (0.0, 10.0),
        constant_lags = ones(1)
    )
) == DDEProblem(
    f_1delay, ones(1), t -> zeros(1), (0.0, 10.0),
    constant_lags = ones(1)
)
@inferred DDEProblem{true}(
    f_1delay, ones(1), t -> zeros(1), (0.0, 10.0),
    dependent_lags = ones(1)
)

function f_dae(r, yp, y, p, tres)
    r[1] = -0.04 * y[1] + 1.0e4 * y[2] * y[3]
    r[2] = -r[1] - 3.0e7 * y[2] * y[2] - yp[2]
    r[1] -= yp[1]
    return r[3] = y[1] + y[2] + y[3] - 1.0
end
u0 = [1.0, 0, 0]
du0 = [-0.04, 0.04, 0.0]
differential_vars = [true, true, false]

prob_dae_resrob = DAEProblem(f_dae, du0, u0, (0.0, 100000.0))
prob_dae_resrob = DAEProblem{true}(f_dae, du0, u0, (0.0, 100000.0))

@test_broken @inferred(DAEProblem(f_dae, du0, u0, (0.0, 100000.0))) ==
    DAEProblem(f_dae, du0, u0, (0.0, 100000.0))
@inferred DAEProblem{true}(f_dae, du0, u0, (0.0, 100000.0))

# Ensures uniform dimensionality of u0, du0, and differential_vars
@test_throws ArgumentError DAEProblem(f_dae, du0, u0[1:(end - 1)], (0.0, 100000.0))
@test_throws ArgumentError DAEProblem(
    f_dae, du0, u0, (0.0, 100000.0);
    differential_vars = differential_vars[1:(end - 1)]
)

f_rode(u, p, t, W) = 1.01u .+ 0.87u .* W
u0 = 1.0
tspan = (0.0, 1.0)
prob = RODEProblem(f_rode, u0, tspan)
prob = RODEProblem{false}(f_rode, u0, tspan)

@test_broken @inferred(RODEProblem(f_rode, u0, tspan)) == RODEProblem(f_rode, u0, tspan)
@inferred RODEProblem{false}(f_rode, u0, tspan)

DiscreteProblem(ones(1), tspan)
f_discrete(u, p, t) = 0.5
DiscreteProblem{false}(f_discrete, ones(1), tspan)

@test_broken @inferred(DiscreteProblem(ones(1), tspan)) == DiscreteProblem(ones(1), tspan)
@inferred DiscreteProblem{false}(f_discrete, ones(1), tspan)

function f_steady(du, u, p, t)
    du[1] = 2 - 2u[1]
    return du[2] = u[1] - 4u[2]
end
u0 = zeros(2)
prob = SteadyStateProblem(f_steady, u0)

@test_broken @inferred(SteadyStateProblem(f_steady, u0)) == SteadyStateProblem(f_steady, u0)
@test SteadyStateProblem(ODEProblem(f_steady, u0, tspan, :param)).p == :param

using DiffEqBase, Test

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    return t - 2.95
end

affect! = function (integrator)
    return integrator.u = integrator.u + 2
end

rootfind = true
save_positions = (true, true)
callback = ContinuousCallback(condition, affect!; save_positions = save_positions)

cbs = CallbackSet(nothing)
@test typeof(cbs.discrete_callbacks) <: Tuple
@test typeof(cbs.continuous_callbacks) <: Tuple
cbs = CallbackSet(callback, nothing)
@test typeof(cbs.discrete_callbacks) <: Tuple
@test typeof(cbs.continuous_callbacks) <: Tuple
cbs = CallbackSet(callback, CallbackSet())
@test typeof(cbs.discrete_callbacks) <: Tuple
@test typeof(cbs.continuous_callbacks) <: Tuple

condition = function (integrator)
    return true
end
affect! = function (integrator) end
save_positions = (true, false)
saving_callback = DiscreteCallback(condition, affect!; save_positions = save_positions)

cbs1 = CallbackSet(callback, saving_callback)

@test length(cbs1.discrete_callbacks) == 1
@test length(cbs1.continuous_callbacks) == 1

cbs2 = CallbackSet(callback)
@test length(cbs2.continuous_callbacks) == 1
@test length(cbs2.discrete_callbacks) == 0

cbs3 = CallbackSet(saving_callback)
@test length(cbs3.discrete_callbacks) == 1
@test length(cbs3.continuous_callbacks) == 0

cbs4 = CallbackSet()
@test length(cbs4.discrete_callbacks) == 0
@test length(cbs4.continuous_callbacks) == 0

cbs5 = CallbackSet(cbs1, cbs2)

@test length(cbs5.discrete_callbacks) == 1
@test length(cbs5.continuous_callbacks) == 2

# For the purposes of this test, create a empty integrator type and
# override find_callback_time, since we don't actually care about testing
# the find callback time aspect, just the inference failure
mutable struct EmptyIntegrator
    u::Vector{Float64}
    tdir::Int
    last_event_error::Float64
end
function DiffEqBase.find_callback_time(
        integrator::EmptyIntegrator,
        callback::ContinuousCallback, counter
    )
    return 1.0 + counter, 0.9 + counter, true, counter, 0.0
end
function DiffEqBase.find_callback_time(
        integrator::EmptyIntegrator,
        callback::VectorContinuousCallback, counter
    )
    return 1.0 + counter, 0.9 + counter, true, counter, 0.0
end
find_first_integrator = EmptyIntegrator([1.0, 2.0], 1, 0.0)
vector_affect! = function (integrator, idx)
    return integrator.u = integrator.u + idx
end

cond_1(u, t, integrator) = t - 1.0
cond_2(u, t, integrator) = t - 1.1
cond_3(u, t, integrator) = t - 1.2
cond_4(u, t, integrator) = t - 1.3
cond_5(u, t, integrator) = t - 1.4
cond_6(u, t, integrator) = t - 1.5
cond_7(u, t, integrator) = t - 1.6
cond_8(u, t, integrator) = t - 1.7
cond_9(u, t, integrator) = t - 1.8
cond_10(u, t, integrator) = t - 1.9
# Setup a lot of callbacks so the recursive inference failure happens
callbacks = (
    ContinuousCallback(cond_1, affect!),
    ContinuousCallback(cond_2, affect!),
    ContinuousCallback(cond_3, affect!),
    ContinuousCallback(cond_4, affect!),
    ContinuousCallback(cond_5, affect!),
    ContinuousCallback(cond_6, affect!),
    ContinuousCallback(cond_7, affect!),
    ContinuousCallback(cond_8, affect!),
    ContinuousCallback(cond_9, affect!),
    ContinuousCallback(cond_10, affect!),
    VectorContinuousCallback(cond_1, vector_affect!, 2),
    VectorContinuousCallback(cond_2, vector_affect!, 2),
    VectorContinuousCallback(cond_3, vector_affect!, 2),
    VectorContinuousCallback(cond_4, vector_affect!, 2),
    VectorContinuousCallback(cond_5, vector_affect!, 2),
    VectorContinuousCallback(cond_6, vector_affect!, 2),
);
function test_find_first_callback(callbacks, int)
    return @timed(DiffEqBase.find_first_continuous_callback(int, callbacks...))
end
test_find_first_callback(callbacks, find_first_integrator);
@test test_find_first_callback(callbacks, find_first_integrator).bytes == 0

# https://github.com/SciML/DiffEqBase.jl/issues/1233
@testset "Inexact rootfinding" begin
    # function with irrational root (sqrt(2))
    irrational_f(x, p = 0.0) = x^2 - 2

    # Forward integration
    is_forward = true
    tspan = (1.0, 2.0)
    before = DiffEqBase.find_root(irrational_f, tspan, SciMLBase.LeftRootFind)
    after = DiffEqBase.find_root(irrational_f, tspan, SciMLBase.RightRootFind)
    @test irrational_f(before) < 0.0
    @test irrational_f(after) > 0.0
    @test nextfloat(before) == after

    # Backward integration
    is_forward = false
    tspan = (2.0, 1.0)
    before = DiffEqBase.find_root(irrational_f, tspan, SciMLBase.LeftRootFind)
    after = DiffEqBase.find_root(irrational_f, tspan, SciMLBase.RightRootFind)
    @test irrational_f(before) > 0.0
    @test irrational_f(after) < 0.0
    @test nextfloat(after) == before
end

using LinearAlgebra, OrdinaryDiffEq, Test, ADTypes
f = (du, u, p, t) -> du .= u ./ t
jac = (J, u, p, t) -> (J[1, 1] = 1 / t; J[2, 2] = 1 / t; J[1, 2] = 0; J[2, 1] = 0)

jp_diag = Diagonal(zeros(2))
fun = ODEFunction(f; jac = jac, jac_prototype = jp_diag)
prob = ODEProblem(fun, ones(2), (1.0, 10.0))
sol = solve(prob, Rosenbrock23())
@test sol.u[end] ≈ [10.0, 10.0]
@test length(sol) < 60

sol = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
@test sol.u[end] ≈ [10.0, 10.0]
@test length(sol) < 60

jp = Tridiagonal(jp_diag)
fun = ODEFunction(f; jac = jac, jac_prototype = jp)
prob = ODEProblem(fun, ones(2), (1.0, 10.0))

sol = solve(prob, Rosenbrock23())
@test sol.u[end] ≈ [10.0, 10.0]
@test length(sol) < 60

sol = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
@test sol.u[end] ≈ [10.0, 10.0]
@test length(sol) < 60

#=
jp = SymTridiagonal(jp_diag)
fun = ODEFunction(f; jac=jac, jac_prototype=jp)
prob = ODEProblem(fun,ones(2),(1.0,10.0))
sol = solve(prob,Rosenbrock23())
@test sol[end] ≈ [10.0,10.0]
@test length(sol) < 60
=#

# Don't test the autodiff=false version here because it's not as numerically stable,
# so lack of optimizations would lead to unsymmetric which causes an error:
# LoadError: ArgumentError: broadcasted assignment breaks symmetry between locations (1, 2) and (2, 1)

@test_broken begin
    local jp = Hermitian(jp_diag)
    local fun = ODEFunction(f; jac = jac, jac_prototype = jp)
    local prob = ODEProblem(fun, ones(2), (1.0, 10.0))
    local sol = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
    @test sol.u[end] ≈ [10.0, 10.0]
    @test length(sol) < 60
end

@test_broken begin
    local jp = Symmetric(jp_diag)
    local fun = ODEFunction(f; jac = jac, jac_prototype = jp)
    local prob = ODEProblem(fun, ones(2), (1.0, 10.0))
    local sol = solve(prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
    @test sol.u[end] ≈ [10.0, 10.0]
    @test length(sol) < 60
end

using OrdinaryDiffEq, GTPSA, Test
using DifferentiationInterface
using ADTypes: AutoForwardDiff
using ForwardDiff

# GTPSA is itself an AD engine - these tests compare GTPSA jacobian/hessian
# results against ForwardDiff as a reference implementation

# ODEProblem 1 =======================

f!(du, u, p, t) = du .= p .* u

# Initial variables and parameters
x = [1.0, 2.0, 3.0]
p = [4.0, 5.0, 6.0]

prob = ODEProblem(f!, x, (0.0, 1.0), p)
sol = solve(prob, Tsit5(), reltol = 1.0e-16, abstol = 1.0e-16)

# Parametric GTPSA map
desc = Descriptor(3, 2, 3, 2) # 3 variables 3 parameters, both to 2nd order
dx = @vars(desc)
dp = @params(desc)
prob_GTPSA = ODEProblem(f!, x .+ dx, (0.0, 1.0), p .+ dp)
sol_GTPSA = solve(prob_GTPSA, Tsit5(), reltol = 1.0e-16, abstol = 1.0e-16)

@test sol.u[end] ≈ scalar.(sol_GTPSA.u[end]) # scalar gets 0th order part

# Compare Jacobian against AD backends using DifferentiationInterface
function sol_end_problem1(t)
    prob = ODEProblem(f!, t[1:3], (0.0, 1.0), t[4:6])
    sol = solve(prob, Tsit5(), reltol = 1.0e-16, abstol = 1.0e-16)
    return sol.u[end]
end

@testset "GTPSA Problem 1 Jacobian tests" begin
    J_AD = DifferentiationInterface.jacobian(sol_end_problem1, AutoForwardDiff(), [x..., p...])
    @test J_AD ≈ GTPSA.jacobian(sol_GTPSA.u[end], include_params = true)
end

@testset "GTPSA Problem 1 Hessian tests" begin
    for i in 1:3
        function sol_end_i_problem1(t)
            prob = ODEProblem(f!, t[1:3], (0.0, 1.0), t[4:6])
            sol = solve(prob, Tsit5(), reltol = 1.0e-16, abstol = 1.0e-16)
            return sol.u[end][i]
        end
        Hi_AD = DifferentiationInterface.hessian(sol_end_i_problem1, AutoForwardDiff(), [x..., p...])
        @test Hi_AD ≈ GTPSA.hessian(sol_GTPSA.u[end][i], include_params = true)
    end
end

# ODEProblem 2 =======================
pdot!(dq, p, q, params, t) = dq .= [0.0, 0.0, 0.0]
function qdot!(dp, p, q, params, t)
    return dp .= [
        p[1] / sqrt((1 + p[3])^2 - p[1]^2 - p[2]^2),
        p[2] / sqrt((1 + p[3])^2 - p[1]^2 - p[2]^2),
        p[3] / sqrt(1 + p[3]^2) - (p[3] + 1) / sqrt((1 + p[3])^2 - p[1]^2 - p[2]^2),
    ]
end

prob2 = DynamicalODEProblem(pdot!, qdot!, [0.0, 0.0, 0.0], [0.0, 0.0, 0.0], (0.0, 25.0))
sol2 = solve(prob2, Yoshida6(), dt = 1.0, reltol = 1.0e-16, abstol = 1.0e-16)

desc2 = Descriptor(6, 2) # 6 variables to 2nd order
dx2 = @vars(desc2) # identity map
prob_GTPSA2 = DynamicalODEProblem(pdot!, qdot!, dx2[1:3], dx2[4:6], (0.0, 25.0))
sol_GTPSA2 = solve(prob_GTPSA2, Yoshida6(), dt = 1.0, reltol = 1.0e-16, abstol = 1.0e-16)

@test sol2.u[end] ≈ scalar.(sol_GTPSA2.u[end]) # scalar gets 0th order part

# Compare Jacobian against AD backends using DifferentiationInterface
function sol_end_problem2(t)
    prob = DynamicalODEProblem(pdot!, qdot!, t[1:3], t[4:6], (0.0, 25.0))
    sol = solve(prob, Yoshida6(), dt = 1.0, reltol = 1.0e-16, abstol = 1.0e-16)
    return sol.u[end]
end

@testset "GTPSA Problem 2 Jacobian tests" begin
    J_AD = DifferentiationInterface.jacobian(sol_end_problem2, AutoForwardDiff(), zeros(6))
    @test J_AD ≈ GTPSA.jacobian(sol_GTPSA2.u[end], include_params = true)
end

@testset "GTPSA Problem 2 Hessian tests" begin
    for i in 1:6
        function sol_end_i_problem2(t)
            prob = DynamicalODEProblem(pdot!, qdot!, t[1:3], t[4:6], (0.0, 25.0))
            sol = solve(prob, Yoshida6(), dt = 1.0, reltol = 1.0e-16, abstol = 1.0e-16)
            return sol.u[end][i]
        end
        Hi_AD = DifferentiationInterface.hessian(sol_end_i_problem2, AutoForwardDiff(), zeros(6))
        @test Hi_AD ≈ GTPSA.hessian(sol_GTPSA2.u[end][i], include_params = true)
    end
end

using OrdinaryDiffEq, Sundials, Test

f_oop(u, p, t) = 2u
u0 = 0.5
tspan = (0.0, 1.0)

# Sundials CVODE_Adams does not support complex initial conditions
prob = ODEProblem{false}(f_oop, 1.0 + im, tspan)
@test_throws SciMLBase.ComplexSupportError solve(prob, CVODE_Adams())

# DFBDF is a DAE solver, not compatible with standard ODEProblem
@test_throws SciMLBase.ProblemSolverPairingError solve(prob, DFBDF())

using OrdinaryDiffEq
using LabelledArrays
using ADTypes

function f(out, du, u, p, t)
    out.x = -0.04u.x + 1.0e4 * u.y * u.z - du.x
    out.y = +0.04u.x - 3.0e7 * u.y^2 - 1.0e4 * u.y * u.z - du.y
    return out.z = u.x + u.y + u.z - 1.0
end

u₀ = LVector(x = 1.0, y = 0.0, z = 0.0)
du₀ = LVector(x = -0.04, y = 0.04, z = 0.0)
tspan = (0.0, 100000.0)

differential_vars = LVector(x = true, y = true, z = false)
prob = DAEProblem(f, du₀, u₀, tspan, differential_vars = differential_vars)

sol = solve(prob, DImplicitEuler())

function f1(du, u, p, t)
    du.x .= -1 .* u.x .* u.y .* p[1]
    return du.y .= -1 .* u.y .* p[2]
end
const n = 4
u_0 = @LArray fill(1000.0, 2 * n) (x = (1:n), y = ((n + 1):(2 * n)))
p = [0.1, 0.1]
prob1 = ODEProblem(f1, u_0, (0, 100.0), p)
sol = solve(prob1, Rodas5());
sol = solve(prob1, Rodas5(autodiff = AutoFiniteDiff()));

using DiffEqBase, Test

# Test merge_problem_kwargs function - only using DiffEqBase directly

@testset "merge_problem_kwargs API" begin
    # Create a simple problem for testing
    function f(du, u, p, t)
        du[1] = -u[1]
    end

    # Test 1: Problem with no kwargs
    prob_no_kwargs = ODEProblem(f, [1.0], (0.0, 1.0))
    kwargs_in = (abstol = 1.0e-6, reltol = 1.0e-6)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_no_kwargs; kwargs_in...)
    @test kwargs_out == Base.pairs(kwargs_in)

    # Test 2: Problem with empty kwargs
    prob_empty_kwargs = ODEProblem(f, [1.0], (0.0, 1.0); Dict{Symbol, Any}()...)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_empty_kwargs; kwargs_in...)
    @test kwargs_out == Base.pairs(kwargs_in)

    # Test 3: Problem kwargs are preserved, passed kwargs take precedence
    prob_with_kwargs = ODEProblem(f, [1.0], (0.0, 1.0); abstol = 1.0e-8, reltol = 1.0e-8)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_kwargs; (abstol = 1.0e-6,)...)
    @test kwargs_out.abstol == 1.0e-6  # Passed kwarg takes precedence
    @test kwargs_out.reltol == 1.0e-8  # Problem kwarg is preserved

    # Test 4: Multiple kwargs from problem and passed
    prob_multi = ODEProblem(f, [1.0], (0.0, 1.0); abstol = 1.0e-8, saveat = 0.1)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_multi; (reltol = 1.0e-6, maxiters = 1000)...)
    @test kwargs_out.abstol == 1.0e-8    # From problem
    @test kwargs_out.saveat == 0.1     # From problem
    @test kwargs_out.reltol == 1.0e-6    # From passed kwargs
    @test kwargs_out.maxiters == 1000  # From passed kwargs

    # Test 5: Callback merging disabled
    condition(u, t, integrator) = t - 0.5
    affect!(integrator) = (integrator.u[1] += 1.0)
    cb1 = ContinuousCallback(condition, affect!)
    cb2 = ContinuousCallback(condition, affect!)

    prob_with_cb = ODEProblem(f, [1.0], (0.0, 1.0); callback = cb1)
    kwargs_out = DiffEqBase.merge_problem_kwargs(
        prob_with_cb; merge_callbacks = false,
        (callback = cb2,)...
    )
    @test kwargs_out.callback === cb2  # cb2 should override cb1

    # Test 6: Callback merging enabled (default)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_cb; (callback = cb2,)...)
    @test kwargs_out.callback isa DiffEqBase.CallbackSet
    @test length(kwargs_out.callback.continuous_callbacks) == 2

    # Test 7: Callback merging with CallbackSet
    cb3 = ContinuousCallback(condition, affect!)
    cbset = CallbackSet(cb3)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_cb; (callback = cbset,)...)
    @test kwargs_out.callback isa DiffEqBase.CallbackSet
    @test length(kwargs_out.callback.continuous_callbacks) == 2

    # Test 8: Only problem has callback
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_cb; (abstol = 1.0e-6,)...)
    @test kwargs_out.callback === cb1
    @test kwargs_out.abstol == 1.0e-6

    # Test 9: Only passed kwargs have callback
    prob_no_cb = ODEProblem(f, [1.0], (0.0, 1.0); abstol = 1.0e-8)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_no_cb; (callback = cb2, reltol = 1.0e-6)...)
    @test kwargs_out.callback === cb2
    @test kwargs_out.abstol == 1.0e-8
    @test kwargs_out.reltol == 1.0e-6

    # Test 10: DiscreteCallback merging
    dcb1 = DiscreteCallback((u, t, integrator) -> true, integrator -> nothing)
    dcb2 = DiscreteCallback((u, t, integrator) -> true, integrator -> nothing)
    prob_with_dcb = ODEProblem(f, [1.0], (0.0, 1.0); callback = dcb1)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_dcb; (callback = dcb2,)...)
    @test kwargs_out.callback isa DiffEqBase.CallbackSet
    @test length(kwargs_out.callback.discrete_callbacks) == 2

    # Test 11: Mixed Continuous and Discrete callback merging
    prob_with_ccb = ODEProblem(f, [1.0], (0.0, 1.0); callback = cb1)
    kwargs_out = DiffEqBase.merge_problem_kwargs(prob_with_ccb; (callback = dcb1,)...)
    @test kwargs_out.callback isa DiffEqBase.CallbackSet
    @test length(kwargs_out.callback.continuous_callbacks) == 1
    @test length(kwargs_out.callback.discrete_callbacks) == 1
end

struct EvalFunc{F} <: Function
    f::F
end
(f::EvalFunc)(args...) = f.f(args...)

NO_TSPAN_PROBS = Union{
    AbstractLinearProblem, AbstractNonlinearProblem,
    AbstractIntegralProblem, AbstractSteadyStateProblem,
    AbstractJumpProblem,
}

"""
    has_callbacks(kwargs)

Check if there are any callbacks in the kwargs. Returns `true` if callbacks are present.
"""
function has_callbacks(kwargs)
    cb = get(kwargs, :callback, nothing)
    cb === nothing && return false
    cb isa CallbackSet && return !isempty(cb)
    return true
end

"""
    merge_problem_kwargs(prob; merge_callbacks=true, kwargs…)

Merges kwargs stored in `prob.kwargs` with the provided `kwargs`, following
DiffEq's standard merging rules:
- Problem kwargs are merged first
- Passed kwargs take precedence (i.e., they override problem kwargs)
- If `merge_callbacks=true` and both prob and kwargs have callbacks, they are
  merged into a `CallbackSet` rather than one overriding the other

Returns the merged kwargs as a Base.pairs.

This function is intended for use by problem types that override `__solve` or `__init`
and need to manually handle kwargs merging that would normally be done by `solve_call`
or `init_call`.
"""
function merge_problem_kwargs(prob; merge_callbacks = true, kwargs...)

    # Special handling for callback merging
    if has_kwargs(prob)
        if merge_callbacks && haskey(prob.kwargs, :callback) && haskey(kwargs, :callback)
            kwargs_temp = NamedTuple{
                Base.diff_names(
                    Base._nt_names(values(kwargs)),
                    (:callback,)
                ),
            }(values(kwargs))
            callbacks = NamedTuple{(:callback,)}(
                (
                    DiffEqBase.CallbackSet(
                        prob.kwargs[:callback],
                        values(kwargs).callback
                    ),
                )
            )
            kwargs = merge(kwargs_temp, callbacks)
        end
        kwargs = isempty(prob.kwargs) ? kwargs : merge(values(prob.kwargs), kwargs)
    end

    return kwargs
end

function init_call(
        _prob, args...; merge_callbacks = true, kwargshandle = nothing,
        kwargs...
    )
    kwargshandle = kwargshandle === nothing ? SciMLBase.KeywordArgError : kwargshandle
    kwargshandle = has_kwargs(_prob) && haskey(_prob.kwargs, :kwargshandle) ?
        _prob.kwargs[:kwargshandle] : kwargshandle

    # Merge problem kwargs with passed kwargs
    kwargs = merge_problem_kwargs(_prob; merge_callbacks, kwargs...)

    checkkwargs(kwargshandle; kwargs...)

    return if _prob isa Union{ODEProblem, DAEProblem} && isnothing(_prob.u0) &&
            !has_callbacks(kwargs)
        build_null_integrator(_prob, args...; kwargs...)
    elseif hasfield(typeof(_prob), :f) && hasfield(typeof(_prob.f), :f) &&
            _prob.f.f isa EvalFunc
        Base.invokelatest(__init, _prob, args...; kwargs...) #::T
    else
        __init(_prob, args...; kwargs...) #::T
    end
end

function init(
        prob::AbstractDEProblem, args...; sensealg = nothing,
        u0 = nothing, p = nothing, kwargs...
    )
    if sensealg === nothing && has_kwargs(prob) && haskey(prob.kwargs, :sensealg)
        sensealg = prob.kwargs[:sensealg]
    end

    u0 = u0 !== nothing ? u0 : prob.u0
    p = p !== nothing ? p : prob.p

    return init_up(prob, sensealg, u0, p, args...; kwargs...)
end

function init(prob::AbstractJumpProblem, args...; kwargs...)
    return init_call(prob, args...; kwargs...)
end

function init_up(prob::AbstractDEProblem, sensealg, u0, p, args...; kwargs...)
    alg = extract_alg(args, kwargs, has_kwargs(prob) ? prob.kwargs : kwargs)
    return if isnothing(alg) || !(alg isa AbstractDEAlgorithm) # Default algorithm handling
        _prob = get_concrete_problem(
            prob, !(prob isa DiscreteProblem); alg = alg, u0 = u0,
            p = p, kwargs...
        )
        init_call(_prob, args...; kwargs...)
    else
        tstops = get(kwargs, :tstops, nothing)
        if tstops === nothing && has_kwargs(prob)
            tstops = get(prob.kwargs, :tstops, nothing)
        end
        if !(tstops isa Union{Nothing, AbstractArray, Tuple, Real}) &&
                !SciMLBase.allows_late_binding_tstops(alg)
            throw(LateBindingTstopsNotSupportedError())
        end
        _prob = get_concrete_problem(prob, isadaptive(alg); alg = alg, u0 = u0, p = p, kwargs...)
        _alg = prepare_alg(alg, _prob.u0, _prob.p, _prob)
        check_prob_alg_pairing(_prob, alg) # alg for improved inference
        if length(args) > 1
            init_call(_prob, _alg, Base.tail(args)...; kwargs...)
        else
            init_call(_prob, _alg; kwargs...)
        end
    end
end

function solve_call(
        _prob, args...; merge_callbacks = true, kwargshandle = nothing,
        kwargs...
    )
    kwargshandle = kwargshandle === nothing ? SciMLBase.KeywordArgError : kwargshandle
    kwargshandle = has_kwargs(_prob) && haskey(_prob.kwargs, :kwargshandle) ?
        _prob.kwargs[:kwargshandle] : kwargshandle

    # Merge problem kwargs with passed kwargs
    kwargs = merge_problem_kwargs(_prob; merge_callbacks, kwargs...)

    checkkwargs(kwargshandle; kwargs...)
    if isdefined(_prob, :u0)
        if _prob.u0 isa Array
            if !isconcretetype(RecursiveArrayTools.recursive_unitless_eltype(_prob.u0))
                throw(NonConcreteEltypeError(RecursiveArrayTools.recursive_unitless_eltype(_prob.u0)))
            end

            if !(eltype(_prob.u0) <: Number) && !(eltype(_prob.u0) <: Enum) &&
                    !(_prob.u0 isa AbstractVector{<:AbstractArray} && _prob isa BVProblem)
                # Allow Enums for FunctionMaps, make into a trait in the future
                # BVPs use Vector of Arrays for initial guesses
                throw(NonNumberEltypeError(eltype(_prob.u0)))
            end
        end

        if _prob.u0 === nothing && !has_callbacks(kwargs)
            return build_null_solution(_prob, args...; kwargs...)
        end
    end

    return if hasfield(typeof(_prob), :f) && hasfield(typeof(_prob.f), :f) &&
            _prob.f.f isa EvalFunc
        Base.invokelatest(__solve, _prob, args...; kwargs...) #::T
    else
        __solve(_prob, args...; kwargs...) #::T
    end
end

mutable struct NullODEIntegrator{IIP, ProbType, T, SolType, F, P} <:
    AbstractODEIntegrator{Nothing, IIP, Nothing, T}
    du::Vector{Float64}
    u::Vector{Float64}
    t::T
    prob::ProbType
    sol::SolType
    f::F
    p::P
end
function build_null_integrator(
        prob::AbstractDEProblem, args...;
        kwargs...
    )
    sol = solve(prob, args...; kwargs...)
    # The DAE initialization in `build_null_solution` may change the parameter
    # object `prob.p` via `@set!`, hence use the "new" prob instead of the "old" one.
    prob = sol.prob
    return NullODEIntegrator{
        isinplace(prob), typeof(prob), eltype(prob.tspan), typeof(sol),
        typeof(prob.f), typeof(prob.p),
    }(
        Float64[],
        Float64[],
        prob.tspan[1],
        prob,
        sol,
        prob.f,
        prob.p
    )
end
function solve!(integ::NullODEIntegrator)
    integ.t = integ.sol.t[end]
    return nothing
end
function step!(integ::NullODEIntegrator, dt = nothing, stop_at_tdt = false)
    if !isnothing(dt)
        integ.t += dt
    else
        integ.t = integ.sol.t[end]
    end
    return nothing
end
function SciMLBase.u_modified!(integ::NullODEIntegrator, u) end
SciMLBase.check_error(integ::NullODEIntegrator) = integ.sol.retcode

function hack_null_solution_init(prob)
    if SciMLBase.has_initialization_data(prob.f)
        initializeprob = prob.f.initialization_data.initializeprob
        nlsol = solve(initializeprob)
        success = SciMLBase.successful_retcode(nlsol)
        if prob.f.initialization_data.initializeprobpmap !== nothing
            @set! prob.p = prob.f.initializeprobpmap(prob, nlsol)
        end
    else
        success = true
    end
    return prob, success
end

function build_null_solution(
        prob::AbstractDEProblem, args...;
        saveat = (),
        save_everystep = true,
        save_on = true,
        save_start = save_everystep || isempty(saveat) ||
            saveat isa Number || prob.tspan[1] in saveat,
        save_end = true,
        kwargs...
    )
    ts = if saveat === ()
        if save_start && save_end
            [prob.tspan[1], prob.tspan[2]]
        elseif save_start && !save_end
            [prob.tspan[1]]
        elseif !save_start && save_end
            [prob.tspan[2]]
        else
            eltype(prob.tspan)[]
        end
    elseif saveat isa Number
        prob.tspan[1]:saveat:prob.tspan[2]
    else
        saveat
    end

    timeseries = [Float64[] for i in 1:length(ts)]

    prob, success = hack_null_solution_init(prob)
    retcode = success ? ReturnCode.Success : ReturnCode.InitialFailure
    return build_solution(prob, nothing, ts, timeseries; dense = true, retcode)
end

"""
```julia
solve(prob::AbstractDEProblem, alg::Union{AbstractDEAlgorithm,Nothing}; kwargs...)
```

## Arguments

The only positional argument is `alg` which is optional. By default, `alg = nothing`.
If `alg = nothing`, then `solve` dispatches to the DifferentialEquations.jl automated
algorithm selection (if `using DifferentialEquations` was done, otherwise it will
error with a `MethodError`).

## Keyword Arguments

The DifferentialEquations.jl universe has a large set of common arguments available
for the `solve` function. These arguments apply to `solve` on any problem type and
are only limited by limitations of the specific implementations.

Many of the defaults depend on the algorithm or the package the algorithm derives
from. Not all of the interface is provided by every algorithm.
For more detailed information on the defaults and the available options
for specific algorithms / packages, see the manual pages for the solvers of specific
problems. To see whether a specific package is compatible with the use of a
given option, see the [Solver Compatibility Chart](https://docs.sciml.ai/DiffEqDocs/stable/basics/compatibility_chart/#Solver-Compatibility-Chart)

### Default Algorithm Hinting

To help choose the default algorithm, the keyword argument `alg_hints` is
provided to `solve`. `alg_hints` is a `Vector{Symbol}` which describe the
problem at a high level to the solver. The options are:

* `:auto` vs `:nonstiff` vs `:stiff` - Denotes the equation as nonstiff/stiff.
  `:auto` allow the default handling algorithm to choose stiffness detection
  algorithms. The default handling defaults to using `:auto`.

Currently unused options include:

* `:interpolant` - Denotes that a high-precision interpolation is important.
* `:memorybound` - Denotes that the solver will be memory bound.

This functionality is derived via the benchmarks in
[SciMLBenchmarks.jl](https://github.com/SciML/SciMLBenchmarks.jl)

#### SDE Specific Alghints

* `:additive` - Denotes that the underlying SDE has additive noise.
* `:stratonovich` - Denotes that the solution should adhere to the Stratonovich
  interpretation.

### Output Control

These arguments control the output behavior of the solvers. It defaults to maximum
output to give the best interactive user experience, but can be reduced all the
way to only saving the solution at the final timepoint.

The following options are all related to output control. See the "Examples"
section at the end of this page for some example usage.

* `dense`: Denotes whether to save the extra pieces required for dense (continuous)
  output. Default is `save_everystep && isempty(saveat)` for algorithms which have
  the ability to produce dense output, i.e. by default it's `true` unless the user
  has turned off saving on steps or has chosen a `saveat` value. If `dense=false`,
  the solution still acts like a function, and `sol(t)` is a linear interpolation
  between the saved time points.
* `saveat`: Denotes specific times to save the solution at, during the solving
  phase. The solver will save at each of the timepoints in this array in the
  most efficient manner available to the solver. If only `saveat` is given, then
  the arguments `save_everystep` and `dense` are `false` by default.
  If `saveat` is given a number, then it will automatically expand to
  `tspan[1]:saveat:tspan[2]`. For methods where interpolation is not possible,
  `saveat` may be equivalent to `tstops`. The default value is `[]`.
* `save_idxs`: Denotes the indices for the components of the equation to save.
  Defaults to saving all indices. For example, if you are solving a 3-dimensional ODE,
  and given `save_idxs = [1, 3]`, only the first and third components of the
  solution will be outputted.
  Notice that of course in this case the outputted solution will be two-dimensional.
* `tstops`: Denotes *extra* times that the timestepping algorithm must step to.
  This should be used to help the solver deal with discontinuities and
  singularities, since stepping exactly at the time of the discontinuity will
  improve accuracy. If a method cannot change timesteps (fixed timestep
  multistep methods), then `tstops` will use an interpolation,
  matching the behavior of `saveat`. If a method cannot change timesteps and
  also cannot interpolate, then `tstops` must be a multiple of `dt` or else an
  error will be thrown. `tstops` may also be a function `tstops(p, tspan)`, accepting the parameter
  object and `tspan`, returning the vector of time points to stop at. Default is `[]`.
* `d_discontinuities:` Denotes locations of discontinuities in low order derivatives.
  This will force FSAL algorithms which assume derivative continuity to re-evaluate
  the derivatives at the point of discontinuity. The default is `[]`.
* `save_everystep`: Saves the result at every step.
  Default is true if `isempty(saveat)`.
* `save_on`: Denotes whether intermediate solutions are saved. This overrides the
  settings of `dense`, `saveat` and `save_everystep` and is used by some applications
  to manually turn off saving temporarily. Everyday use of the solvers should leave
  this unchanged. Defaults to `true`.
* `save_start`: Denotes whether the initial condition should be included in the solution
  type as the first timepoint. This setting overrides `saveat` when set to `false`.
  Defaults to
  `save_everystep || isempty(saveat) || saveat isa Number || prob.tspan[1] in saveat`.
* `save_end`: Denotes whether the final condition should be included in the solution type
  as the final timepoint. This setting is overridden by other saving settings when set to
  `false`. Defaults to
  `save_everystep || isempty(saveat) || saveat isa Number || prob.tspan[2] in saveat`.
* `initialize_save`: Denotes whether to save after the callback initialization
  phase (when `u_modified=true`). Defaults to `true`.

Note that `dense` requires `save_everystep=true` and `saveat=false`. If you need
additional saving while keeping dense output, see
[the SavingCallback in the Callback Library](https://docs.sciml.ai/DiffEqCallbacks/stable/output_saving/#DiffEqCallbacks.SavingCallback).

### Stepsize Control

These arguments control the timestepping routines.

#### Basic Stepsize Control

These are the standard options for controlling stepping behavior. Error estimates
do the comparison

```math
err_{scaled} = err/(abstol + max(uprev,u)*reltol)
```

The scaled error is guaranteed to be `<1` for a given local error estimate
(note: error estimates are local unless the method specifies otherwise). `abstol`
controls the non-scaling error and thus can be thought of as the error around zero.
`reltol` scales with the size of the dependent variables and so one can interpret
`reltol=1e-3` as roughly being (locally) correct to 3 digits. Note tolerances can
be specified element-wise by passing a vector whose size matches `u0`.

* `adaptive`: Turns on adaptive timestepping for appropriate methods. Default
  is true.
* `abstol`: Absolute tolerance in adaptive timestepping. This is the tolerance
  on local error estimates, not necessarily the global error (though these quantities
  are related). Defaults to `1e-6` on deterministic equations (ODEs/DDEs/DAEs) and `1e-2`
  on stochastic equations (SDEs/RODEs).
* `reltol`: Relative tolerance in adaptive timestepping.  This is the tolerance
  on local error estimates, not necessarily the global error (though these quantities
  are related). Defaults to `1e-3` on deterministic equations (ODEs/DDEs/DAEs) and `1e-2`
  on stochastic equations (SDEs/RODEs).
* `dt`: Sets the initial stepsize. This is also the stepsize for fixed
  timestep methods. Defaults to an automatic choice if the method is adaptive.
* `dtmax`: Maximum dt for adaptive timestepping. Defaults are
  package-dependent.
* `dtmin`: Minimum dt for adaptive timestepping. Defaults are
  package-dependent.
* `force_dtmin`: Declares whether to continue, forcing the minimum `dt` usage.
  Default is `false`, which has the solver throw a warning and exit early when
  encountering the minimum `dt`. Setting this true allows the solver to continue,
  never letting `dt` go below `dtmin` (and ignoring error tolerances in those
  cases). Note that `true` is not compatible with most interop packages.

#### Fixed Stepsize Usage

Note that if a method does not have adaptivity, the following rules apply:

* If `dt` is set, then the algorithm will step with size `dt` each iteration.
* If `tstops` and `dt` are both set, then the algorithm will step with either a
  size `dt`, or use a smaller step to hit the `tstops` point.
* If `tstops` is set without `dt`, then the algorithm will step directly to
  each value in `tstops`
* If neither `dt` nor `tstops` are set, the solver will throw an error.

#### [Advanced Adaptive Stepsize Control](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/)

These arguments control more advanced parts of the internals of adaptive timestepping
and are mostly used to make it more efficient on specific problems. For detailed
explanations of the timestepping algorithms, see the
[timestepping descriptions](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/#timestepping)

* `internalnorm`: The norm function `internalnorm(u,t)` which error estimates
  are calculated. Required are two dispatches: one dispatch for the state variable
  and the other on the elements of the state variable (scalar norm).
  Defaults are package-dependent.
* `controller`: Possible examples are [`IController`](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/#OrdinaryDiffEq.IController),
  [`PIController`](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/#OrdinaryDiffEq.PIController),
  [`PIDController`](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/#OrdinaryDiffEq.PIDController),
  [`PredictiveController`](https://docs.sciml.ai/DiffEqDocs/stable/extras/timestepping/#OrdinaryDiffEq.PredictiveController).
  Default is algorithm-dependent.
* `gamma`: The risk-factor γ in the q equation for adaptive timestepping
  of the controllers using it.
  Default is algorithm-dependent.
* `beta1`: The Lund stabilization α parameter.
  Default is algorithm-dependent.
* `beta2`: The Lund stabilization β parameter.
  Default is algorithm-dependent.
* `qmax`: Defines the maximum value possible for the adaptive q.
  Default is algorithm-dependent.
* `qmin`: Defines the minimum value possible for the adaptive q.
  Default is algorithm-dependent.
* `qsteady_min`: Defines the minimum for the range around 1 where the timestep
  is held constant. Default is algorithm-dependent.
* `qsteady_max`: Defines the maximum for the range around 1 where the timestep
  is held constant. Default is algorithm-dependent.
* `qoldinit`: The initial `qold` in stabilization stepping.
  Default is algorithm-dependent.
* `failfactor`: The amount to decrease the timestep by if the Newton iterations
  of an implicit method fail. Default is 2.

### Memory Optimizations

* `calck`: Turns on and off the internal ability for intermediate
  interpolations (also known as intermediate density). Not the same as `dense`, which is post-solution interpolation.
  This defaults to `dense || !isempty(saveat) ||  "no custom callback is given"`.
  This can be used to turn off interpolations
  (to save memory) if one isn't using interpolations when a custom callback is
  used. Another case where this may be used is to turn on interpolations for
  usage in the integrator interface even when interpolations are used nowhere else.
  Note that this is only required if the algorithm doesn't have
  a free or lazy interpolation (`DP8()`). If `calck = false`, `saveat` cannot be used.
  The rare keyword `calck` can be useful in event handling.
* `alias`: an `AbstractAliasSpecifier` object that holds fields specifying which variables to alias
  when solving. For example, to tell an ODE solver to alias the `u0` array, you can use an `ODEAliases` object, 
  and the `alias_u0` keyword argument, e.g. `solve(prob,alias = ODEAliases(alias_u0 = true))`. 
  For more information on what can be aliased for each problem type, see the documentation for the `AbstractAliasSpecifier`
  associated with that problem type. Set to `true` to alias every variable possible, or to `false` to disable aliasing.
  Defaults to an `AbstractAliasSpecifier` instance with `nothing` for all fields, which tells the solver to use the default behavior.

### Miscellaneous

* `maxiters`: Maximum number of iterations before stopping. Defaults to 1e5.
* `callback`: Specifies a callback. Defaults to a callback function which
  performs the saving routine. For more information, see the
  [Event Handling and Callback Functions manual page](https://docs.sciml.ai/DiffEqCallbacks/stable/).
* `initializealg`: The initialization algorithm for DAEs and ODEs with constraints.
  Available options include:
  - `DefaultInit()` (default): Automatically chooses the best initialization algorithm
  - `CheckInit()`: Only checks that initial conditions are consistent, errors if not
  - `NoInit()`: Skip initialization completely (for when you know conditions are consistent)
  - `OverrideInit()`: Use problem's initialization_data (typically from ModelingToolkit)
  - `BrownBasicInit()`: Brown's basic initialization algorithm for index-1 DAEs
  - `ShampineCollocationInit()`: Shampine's collocation initialization for general DAEs
  See the [DAE initialization documentation](https://docs.sciml.ai/DiffEqDocs/stable/features/dae_initialization/)
  for more details.
* `isoutofdomain`: Specifies a function `isoutofdomain(u,p,t)` where, when it
  returns true, it will reject the timestep. Disabled by default.
* `unstable_check`: Specifies a function `unstable_check(dt,u,p,t)` where, when
  it returns true, it will cause the solver to exit and throw a warning. Defaults
  to `any(isnan,u)`, i.e. checking if any value is a NaN.
* `verbose`: Toggles whether warnings are thrown when the solver exits early.
  Defaults to true.
* `merge_callbacks`: Toggles whether to merge `prob.callback` with the `solve` keyword
  argument `callback`. Defaults to `true`.
* `wrap`: Toggles whether to wrap the solution if `prob.problem_type` has a preferred
  alternate wrapper type for the solution. Useful when speed, but not shape of solution
  is important. Defaults to `Val(true)`. `Val(false)` will cancel wrapping the solution.
* `u0`: The initial condition, overrides the one defined in the problem struct.
  Defaults to `nothing` (no override, use the `u0` defined in `prob`).
* `p`: The parameters, overrides the one defined in the problem struct.
  Defaults to `nothing` (no override, use the `p` defined in `prob`).

### Progress Monitoring

These arguments control the usage of the progressbar in ProgressLogging.jl compatible environments.
For information on setting up progress bars in VS Code and other environments, see the
[progress bar documentation](https://docs.sciml.ai/DiffEqDocs/stable/features/progress_bar/#Using-Progress-Bars-with-VS-Code).

* `progress`: Turns on/off the Juno progressbar. Default is false.
* `progress_steps`: Numbers of steps between updates of the progress bar.
  Default is 1000.
* `progress_name`: Controls the name of the progressbar. Default is the name
  of the problem type.
* `progress_message`: Controls the message with the progressbar. Defaults to
  showing `dt`, `t`, the maximum of `u`.
* `progress_id`: Controls the ID of the progress log message to distinguish simultaneous simulations.

### Error Calculations

If you are using the test problems (ex: `ODETestProblem`), then the following
options control the errors which are calculated:

* `timeseries_errors`: Turns on and off the calculation of errors at the steps
  which were taken, such as the `l2` error. Default is true.
* `dense_errors`: Turns on and off the calculation of errors at the steps which
  require dense output and calculate the error at 100 evenly-spaced points
  throughout `tspan`. An example is the `L2` error. Default is false.

### Sensitivity Algorithms (`sensealg`)

`sensealg` is used for choosing the way the automatic differentiation is performed.
For more information, see the documentation for SciMLSensitivity:
https://docs.sciml.ai/SciMLSensitivity/stable/

## Examples

The following lines are examples of how one could use the configuration of
`solve()`. For these examples a 3-dimensional ODE problem is assumed, however
the extension to other types is straightforward.

1. `solve(prob, AlgorithmName())` : The "default" setting, with a user-specified
   algorithm (given by `AlgorithmName()`). All parameters get their default values.
   This means that the solution is saved at the steps the Algorithm stops internally
   and dense output is enabled if the chosen algorithm allows for it.

   All other integration parameters (e.g. stepsize) are chosen automatically.
2. `solve(prob, saveat = 0.01, abstol = 1e-9, reltol = 1e-9)` : Standard setting
   for accurate output at specified (and equidistant) time intervals, used for
   e.g. Fourier Transform. The solution is given every 0.01 time units,
   starting from `tspan[1]`. The solver used is `Tsit5()` since no keyword
   `alg_hints` is given.

3. `solve(prob, maxiters = 1e7, progress = true, save_idxs = [1])` : Using longer
   maximum number of solver iterations can be useful when a given `tspan` is very
   long. This example only saves the first of the variables of the system, either
   to save size or because the user does not care about the others. Finally, with
   `progress = true` you are enabling the progress bar.
"""
function solve(
        prob::AbstractDEProblem, args...; sensealg = nothing,
        u0 = nothing, p = nothing, wrap = Val(true), kwargs...
    )
    if sensealg === nothing && haskey(prob.kwargs, :sensealg)
        sensealg = prob.kwargs[:sensealg]
    end

    u0 = u0 !== nothing ? u0 : prob.u0
    p = p !== nothing ? p : prob.p

    return if wrap isa Val{true}
        wrap_sol(
            solve_up(
                prob, sensealg, u0, p, args...;
                originator = SciMLBase.set_mooncakeoriginator_if_mooncake(SciMLBase.ChainRulesOriginator()),
                kwargs...
            )
        )
    else
        solve_up(
            prob, sensealg, u0, p, args...;
            originator = SciMLBase.set_mooncakeoriginator_if_mooncake(SciMLBase.ChainRulesOriginator()),
            kwargs...
        )
    end
end

function solve_up(
        prob::AbstractDEProblem, sensealg, u0, p,
        args...; originator = SciMLBase.ChainRulesOriginator(),
        kwargs...
    )
    alg = extract_alg(args, kwargs, has_kwargs(prob) ? prob.kwargs : kwargs)
    return if isnothing(alg) || !(alg isa AbstractDEAlgorithm) # Default algorithm handling
        _prob = get_concrete_problem(
            prob, !(prob isa DiscreteProblem); alg = alg, u0 = u0,
            p = p, kwargs...
        )
        solve_call(_prob, args...; kwargs...)
    else
        tstops = get(kwargs, :tstops, nothing)
        if tstops === nothing && has_kwargs(prob)
            tstops = get(prob.kwargs, :tstops, nothing)
        end
        if !(tstops isa Union{Nothing, AbstractArray, Tuple, Real}) &&
                !SciMLBase.allows_late_binding_tstops(alg)
            throw(LateBindingTstopsNotSupportedError())
        end
        _prob = get_concrete_problem(prob, isadaptive(alg); alg = alg, u0 = u0, p = p, kwargs...)
        _alg = prepare_alg(alg, _prob.u0, _prob.p, _prob)
        check_prob_alg_pairing(_prob, alg) # use alg for improved inference
        if length(args) > 1
            solve_call(_prob, _alg, Base.tail(args)...; kwargs...)
        else
            solve_call(_prob, _alg; kwargs...)
        end
    end
end

function solve(prob::AbstractNoiseProblem, args...; kwargs...)
    return __solve(prob, args...; kwargs...)
end

function solve(prob::AbstractJumpProblem, args...; kwargs...)
    return __solve(prob, args...; kwargs...)
end

function get_concrete_problem(prob::AbstractJumpProblem, isadapt; kwargs...)
    return get_updated_symbolic_problem(SciMLBase.get_root_indp(prob), prob; kwargs...)
end

function get_concrete_problem(prob::AbstractEnsembleProblem, isadapt; kwargs...)
    return prob
end

function solve(
        prob::PDEProblem, alg::AbstractDEAlgorithm, args...;
        kwargs...
    )
    return solve(prob.prob, alg, args...; kwargs...)
end

function init(
        prob::PDEProblem, alg::AbstractDEAlgorithm, args...;
        kwargs...
    )
    return init(prob.prob, alg, args...; kwargs...)
end

function get_concrete_problem(prob, isadapt; alg = nothing, kwargs...)
    oldprob = prob
    prob = get_updated_symbolic_problem(SciMLBase.get_root_indp(prob), prob; kwargs...)
    if prob !== oldprob
        kwargs = (; kwargs..., u0 = SII.state_values(prob), p = SII.parameter_values(prob))
    end
    p = get_concrete_p(prob, kwargs)
    tspan = get_concrete_tspan(prob, isadapt, kwargs, p)
    u0 = get_concrete_u0(prob, isadapt, tspan[1], kwargs)
    u0_promote = promote_u0(u0, p, tspan[1])
    tspan_promote = promote_tspan(u0_promote, p, tspan, prob, kwargs)
    f_promote = promote_f(
        prob.f, Val(SciMLBase.specialization(prob.f)), u0_promote, p,
        tspan_promote[1], Val(_uses_forwarddiff(alg)),
        _forwarddiff_chunksize(alg)
    )
    if isconcreteu0(prob, tspan[1], kwargs) && prob.u0 === u0 &&
            typeof(u0_promote) === typeof(prob.u0) &&
            prob.tspan == tspan && typeof(prob.tspan) === typeof(tspan_promote) &&
            p === prob.p && f_promote === prob.f
        return prob
    else
        return remake(prob; f = f_promote, u0 = u0_promote, p = p, tspan = tspan_promote)
    end
end

function get_concrete_problem(prob::DAEProblem, isadapt; alg = nothing, kwargs...)
    oldprob = prob
    prob = get_updated_symbolic_problem(SciMLBase.get_root_indp(prob), prob; kwargs...)
    if prob !== oldprob
        kwargs = (; kwargs..., u0 = SII.state_values(prob), p = SII.parameter_values(prob))
    end
    p = get_concrete_p(prob, kwargs)
    tspan = get_concrete_tspan(prob, isadapt, kwargs, p)
    u0 = get_concrete_u0(prob, isadapt, tspan[1], kwargs)
    du0 = get_concrete_du0(prob, isadapt, tspan[1], kwargs)

    u0_promote = promote_u0(u0, p, tspan[1])
    du0_promote = promote_u0(du0, p, tspan[1])
    tspan_promote = promote_tspan(u0_promote, p, tspan, prob, kwargs)

    f_promote = promote_f(
        prob.f, Val(SciMLBase.specialization(prob.f)), u0_promote, p,
        tspan_promote[1], Val(_uses_forwarddiff(alg)),
        _forwarddiff_chunksize(alg)
    )
    if isconcreteu0(prob, tspan[1], kwargs) && typeof(u0_promote) === typeof(prob.u0) &&
            isconcretedu0(prob, tspan[1], kwargs) && typeof(du0_promote) === typeof(prob.du0) &&
            prob.tspan == tspan && typeof(prob.tspan) === typeof(tspan_promote) &&
            p === prob.p && f_promote === prob.f
        return prob
    else
        return remake(
            prob; f = f_promote, du0 = du0_promote, u0 = u0_promote, p = p,
            tspan = tspan_promote
        )
    end
end

function get_concrete_problem(prob::DDEProblem, isadapt; kwargs...)
    oldprob = prob
    prob = get_updated_symbolic_problem(SciMLBase.get_root_indp(prob), prob; kwargs...)
    if prob !== oldprob
        kwargs = (; kwargs..., u0 = SII.state_values(prob), p = SII.parameter_values(prob))
    end
    p = get_concrete_p(prob, kwargs)
    tspan = get_concrete_tspan(prob, isadapt, kwargs, p)
    u0 = get_concrete_u0(prob, isadapt, tspan[1], kwargs)

    if prob.constant_lags isa Function
        constant_lags = prob.constant_lags(p)
    else
        constant_lags = prob.constant_lags
    end

    u0 = promote_u0(u0, p, tspan[1])
    tspan = promote_tspan(u0, p, tspan, prob, kwargs)

    return remake(prob; u0 = u0, tspan = tspan, p = p, constant_lags = constant_lags)
end

# Most are extensions
promote_tspan(u0, p, tspan, prob, kwargs) = _promote_tspan(tspan, kwargs)
function _promote_tspan(tspan, kwargs)
    if (dt = get(kwargs, :dt, nothing)) !== nothing
        tspan1, tspan2, _ = promote(tspan..., dt)
        return (tspan1, tspan2)
    else
        return tspan
    end
end

# Helper to get the effective ForwardDiff chunk size from the algorithm.
# Returns Val{CS}(). Defaults to Val(1) when algorithm is not known or unspecified.
_forwarddiff_chunksize(::Nothing) = Val(1)
_forwarddiff_chunksize(alg) = _resolve_chunksize(SciMLBase.forwarddiff_chunksize(alg))
_resolve_chunksize(::Val{0}) = Val(1)
_resolve_chunksize(v::Val) = v

# Helper to determine if we need ForwardDiff-aware function wrapping.
# Default to true (full wrapping) when algorithm is not known.
_uses_forwarddiff(::Nothing) = true
function _uses_forwarddiff(alg)
    fd = SciMLBase.forwarddiffs_model(alg)
    # forwarddiffs_model returns Bool for OrdinaryDiffEq algorithms, but may return
    # an AD type (e.g. AutoFiniteDiff()) for StochasticDiffEq algorithms.
    # Only use simple path when it explicitly returns false.
    fd !== false && return true
    # For composite algorithms that contain sub-algorithms (e.g. AutoTsit5(Rosenbrock23())),
    # check if any sub-algorithm uses ForwardDiff.
    if hasfield(typeof(alg), :algs)
        return any(_uses_forwarddiff, alg.algs)
    end
    return false
end

# Full path for algorithms that use ForwardDiff internally (e.g. Rosenbrock).
# These algorithms precompile AFTER the ForwardDiff extension loads, so
# backedges to hasdualpromote/wrapfun_iip don't cause invalidation issues.
function promote_f(
        f::F, ::Val{specialize}, u0, p, t, ::Val{true},
        ::Val{CS} = Val(1)
    ) where {F, specialize, CS}
    uElType = u0 === nothing ? Float64 : eltype(u0)
    if isdefined(f, :jac_prototype) && f.jac_prototype isa AbstractArray
        f = @set f.jac_prototype = similar(f.jac_prototype, uElType)
    end

    return f = if f isa ODEFunction && isinplace(f) && !(f.f isa AbstractSciMLOperator) &&
            # Opt-out SubArrays since they would create type mismatches with the integrator's internal Arrays
            !(u0 isa SubArray) &&
            (
            (
                specialize === SciMLBase.AutoSpecialize && eltype(u0) !== Any &&
                    RecursiveArrayTools.recursive_unitless_eltype(u0) === eltype(u0) &&
                    one(t) === oneunit(t) &&
                    hasdualpromote(u0, t)
            ) ||
                (
                specialize === SciMLBase.FunctionWrapperSpecialize &&
                    !(f.f isa FunctionWrappersWrappers.FunctionWrappersWrapper)
            )
        )
        # Wrap tgrad if present, so its type is also erased.
        # tgrad!(dT, u, p, t) -> Nothing has the same shape as the RHS.
        if f.tgrad !== nothing && !(f.tgrad isa FunctionWrappersWrappers.FunctionWrappersWrapper)
            f = @set f.tgrad = wrapfun_jac_iip(f.tgrad, (u0, u0, p, t))
        end
        # Wrap the Jacobian if present, so its type is also erased
        if f.jac !== nothing && !(f.jac isa FunctionWrappersWrappers.FunctionWrappersWrapper)
            n = length(u0)
            J_proto = f.jac_prototype !== nothing ? similar(f.jac_prototype, uElType) :
                zeros(uElType, n, n)
            f = @set f.jac = wrapfun_jac_iip(f.jac, (J_proto, u0, p, t))
        end
        return unwrapped_f(f, wrapfun_iip(f.f, (u0, u0, p, t), Val(CS)))
    else
        return f
    end
end

# Simple path for algorithms that do NOT use ForwardDiff internally (e.g. Tsit5, Verner).
# Avoids calling hasdualpromote/wrapfun_iip which have extension overrides in
# DiffEqBaseForwardDiffExt that would create invalidating method table backedges.
# Uses a simple single-signature FunctionWrapper instead.
function promote_f(
        f::F, ::Val{specialize}, u0, p, t, ::Val{false},
        ::Val{CS} = Val(1)
    ) where {F, specialize, CS}
    uElType = u0 === nothing ? Float64 : eltype(u0)
    if isdefined(f, :jac_prototype) && f.jac_prototype isa AbstractArray
        f = @set f.jac_prototype = similar(f.jac_prototype, uElType)
    end

    return f = if f isa ODEFunction && isinplace(f) && !(f.f isa AbstractSciMLOperator) &&
            f.mass_matrix isa UniformScaling &&
            f.jac === nothing &&
            !(u0 isa SubArray) &&
            (
            (
                specialize === SciMLBase.AutoSpecialize && eltype(u0) !== Any &&
                    RecursiveArrayTools.recursive_unitless_eltype(u0) === eltype(u0) &&
                    one(t) === oneunit(t)
            ) ||
                (
                specialize === SciMLBase.FunctionWrapperSpecialize &&
                    !(f.f isa FunctionWrappersWrappers.FunctionWrappersWrapper)
            )
        )
        return unwrapped_f(
            f,
            FunctionWrappersWrappers.FunctionWrappersWrapper(
                Void(f.f), (typeof((u0, u0, p, t)),), (Nothing,)
            )
        )
    else
        return f
    end
end

hasdualpromote(u0, t) = true

function promote_f(
        f::SplitFunction, ::Val{specialize}, u0, p, t, ::Val{true},
        ::Val{CS} = Val(1)
    ) where {specialize, CS}
    return if isnothing(f._func_cache)
        f
    else
        # Copy the cache to ensure it's properly initialized
        remake(f, _func_cache = copy(f._func_cache))
    end
end
function promote_f(
        f::SplitFunction, ::Val{specialize}, u0, p, t, ::Val{false},
        ::Val{CS} = Val(1)
    ) where {specialize, CS}
    return if isnothing(f._func_cache)
        f
    else
        remake(f, _func_cache = copy(f._func_cache))
    end
end
prepare_alg(alg, u0, p, f) = alg

function get_concrete_tspan(prob, isadapt, kwargs, p)
    if prob.tspan isa Function
        tspan = prob.tspan(p)
    elseif haskey(kwargs, :tspan)
        tspan = kwargs[:tspan]
    elseif prob.tspan === (nothing, nothing)
        throw(NoTspanError())
    else
        tspan = prob.tspan
    end

    isadapt && eltype(tspan) <: Integer && (tspan = float.(tspan))

    any(isnan, tspan) && throw(NaNTspanError())

    return tspan
end

function __solve(
        prob::AbstractDEProblem, args...; default_set = false, second_time = false,
        kwargs...
    )
    return if second_time
        throw(NoDefaultAlgorithmError())
    elseif length(args) > 0 && !(
            first(args) isa
                Union{Nothing, AbstractDEAlgorithm, AbstractNonlinearAlgorithm}
        )
        throw(NonSolverError())
    else
        __solve(prob, nothing, args...; default_set = false, second_time = true, kwargs...)
    end
end

function __init(
        prob::AbstractDEProblem, args...; default_set = false, second_time = false,
        kwargs...
    )
    return if second_time
        throw(NoDefaultAlgorithmError())
    elseif length(args) > 0 && !(
            first(args) isa
                Union{Nothing, AbstractDEAlgorithm, AbstractNonlinearAlgorithm}
        )
        throw(NonSolverError())
    else
        __init(prob, nothing, args...; default_set = false, second_time = true, kwargs...)
    end
end

function check_prob_alg_pairing(prob, alg)
    if prob isa ODEProblem && !(alg isa AbstractODEAlgorithm) ||
            prob isa SDEProblem && !(alg isa AbstractSDEAlgorithm) ||
            prob isa SDDEProblem && !(alg isa AbstractSDEAlgorithm) ||
            prob isa DDEProblem && !(alg isa AbstractDDEAlgorithm) ||
            prob isa DAEProblem && !(alg isa AbstractDAEAlgorithm) ||
            prob isa BVProblem && !(alg isa AbstractBVPAlgorithm) ||
            prob isa SteadyStateProblem && !(alg isa AbstractSteadyStateAlgorithm)
        throw(ProblemSolverPairingError(prob, alg))
    end

    if isdefined(prob, :u0) && eltypedual(prob.u0) &&
            !SciMLBase.isautodifferentiable(alg)
        throw(DirectAutodiffError())
    end

    if prob isa SDEProblem && prob.noise_rate_prototype !== nothing &&
            prob.noise !== nothing &&
            size(prob.noise_rate_prototype, 2) != length(prob.noise.W[1])
        throw(
            NoiseSizeIncompatibilityError(
                size(prob.noise_rate_prototype, 2),
                length(prob.noise.W[1])
            )
        )
    end

    # Complex number support comes before arbitrary number support for a more direct
    # error message.
    if !SciMLBase.allowscomplex(alg)
        if isdefined(prob, :u0) &&
                RecursiveArrayTools.recursive_unitless_eltype(prob.u0) <: Complex
            throw(ComplexSupportError(alg))
        end
    end

    if isdefined(prob, :tspan) && eltype(prob.tspan) <: Complex
        throw(ComplexTspanError())
    end

    # Check for concrete element type so that the non-concrete case throws a better error
    return if !SciMLBase.allows_arbitrary_number_types(alg)
        if isdefined(prob, :u0)
            uType = RecursiveArrayTools.recursive_unitless_eltype(prob.u0)
            u0_as_initial_guess = (prob isa BVProblem) && (uType <: Vector)
            if Base.isconcretetype(uType) &&
                    !(uType <: Union{Float32, Float64, ComplexF32, ComplexF64}) &&
                    !u0_as_initial_guess
                throw(
                    GenericNumberTypeError(
                        alg,
                        isdefined(prob, :u0) ? typeof(prob.u0) :
                            nothing,
                        isdefined(prob, :tspan) ? typeof(prob.tspan) :
                            nothing
                    )
                )
            end
        end

        if isdefined(prob, :tspan)
            tType = eltype(prob.tspan)
            if Base.isconcretetype(tType) &&
                    !(tType <: Union{Float32, Float64, ComplexF32, ComplexF64})
                throw(
                    GenericNumberTypeError(
                        alg,
                        isdefined(prob, :u0) ? typeof(prob.u0) :
                            nothing,
                        isdefined(prob, :tspan) ? typeof(prob.tspan) :
                            nothing
                    )
                )
            end
        end
    end
end

################### Differentiation

"""
Ignores all adjoint definitions (i.e. `sensealg`) and proceeds to do standard
AD through the `solve` functions. Generally only used internally for implementing
discrete sensitivity algorithms.
"""
struct SensitivityADPassThrough <: AbstractDEAlgorithm end

###
### Legacy Dispatches to be Non-Breaking
###

@deprecate concrete_solve(
    prob::AbstractDEProblem,
    alg::Union{AbstractDEAlgorithm, Nothing},
    u0 = prob.u0, p = prob.p, args...; kwargs...
) solve(
    prob, alg,
    args...;
    u0 = u0,
    p = p,
    kwargs...
)

function _solve_adjoint(
        prob, sensealg, u0, p, originator, args...; merge_callbacks = true,
        kwargs...
    )
    alg = extract_alg(args, kwargs, prob.kwargs)
    if isnothing(alg) || !(alg isa AbstractDEAlgorithm) # Default algorithm handling
        _prob = get_concrete_problem(
            prob, !(prob isa DiscreteProblem); alg = alg, u0 = u0,
            p = p, kwargs...
        )
    else
        _prob = get_concrete_problem(prob, isadaptive(alg); alg = alg, u0 = u0, p = p, kwargs...)
    end

    # Merge problem kwargs with passed kwargs
    kwargs = merge_problem_kwargs(_prob; merge_callbacks, kwargs...)

    return if length(args) > 1
        _concrete_solve_adjoint(
            _prob, alg, sensealg, u0, p, originator,
            Base.tail(args)...; kwargs...
        )
    else
        _concrete_solve_adjoint(_prob, alg, sensealg, u0, p, originator; kwargs...)
    end
end

function _solve_forward(
        prob, sensealg, u0, p, originator, args...; merge_callbacks = true,
        kwargs...
    )
    alg = extract_alg(args, kwargs, prob.kwargs)
    if isnothing(alg) || !(alg isa AbstractDEAlgorithm) # Default algorithm handling
        _prob = get_concrete_problem(
            prob, !(prob isa DiscreteProblem); alg = alg, u0 = u0,
            p = p, kwargs...
        )
    else
        _prob = get_concrete_problem(prob, isadaptive(alg); alg = alg, u0 = u0, p = p, kwargs...)
    end

    # Merge problem kwargs with passed kwargs
    kwargs = merge_problem_kwargs(_prob; merge_callbacks, kwargs...)

    return if length(args) > 1
        _concrete_solve_forward(
            _prob, alg, sensealg, u0, p, originator,
            Base.tail(args)...; kwargs...
        )
    else
        _concrete_solve_forward(_prob, alg, sensealg, u0, p, originator; kwargs...)
    end
end

using OrdinaryDiffEq, Test
using DiffEqBase
function lorenz(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz, u0, tspan)
@test_nowarn sol = solve(prob, Tsit5(), reltol = 1.0e-6)
sol = solve(prob, Tsit5(), rel_tol = 1.0e-6, kwargshandle = SciMLBase.KeywordArgWarn)
@test_logs (:warn, SciMLBase.KWARGWARN_MESSAGE) sol = solve(
    prob, Tsit5(), rel_tol = 1.0e-6, kwargshandle = SciMLBase.KeywordArgWarn
)
@test_throws SciMLBase.CommonKwargError solve(prob, Tsit5(), rel_tol = 1.0e-6)

prob = ODEProblem(lorenz, u0, tspan, test = 2.0, kwargshandle = SciMLBase.KeywordArgWarn)
@test_logs (:warn, SciMLBase.KWARGWARN_MESSAGE) sol = solve(prob, Tsit5(), reltol = 1.0e-6)

# DAE Initialization Algorithms
# The base types are in SciMLBase, we just add the specific algorithms here

import SciMLBase: DAEInitializationAlgorithm, initialize_dae!, CheckInit, NoInit, OverrideInit

# Re-export the SciMLBase initialization algorithms for convenience
# Note: Docstrings for these types should be added in SciMLBase where they are defined
export CheckInit, NoInit, OverrideInit

"""
    struct DefaultInit <: DAEInitializationAlgorithm

The default initialization algorithm for DAEs. This will use heuristics to
determine the most appropriate initialization based on the problem type.

For Sundials, this will use:
- `OverrideInit` if the problem has `initialization_data` (typically from ModelingToolkit)
- `CheckInit` otherwise
"""
struct DefaultInit <: DAEInitializationAlgorithm end

"""
    struct BrownFullBasicInit{T, F} <: DAEInitializationAlgorithm

The Brown full basic initialization algorithm for DAEs. This implementation
is based on the algorithm described in:

Peter N. Brown, Alan C. Hindmarsh, and Linda R. Petzold,
"Consistent Initial Condition Calculation for Differential-Algebraic Systems",
SIAM Journal on Scientific Computing, Vol. 19, No. 5, pp. 1495-1512, 1998.
DOI: https://doi.org/10.1137/S1064827595289996

This method modifies the algebraic variables and their derivatives to be
consistent with the DAE constraints, while keeping the differential variables
fixed. It uses Newton's method to solve for consistent initial values.

This is the default initialization for many DAE solvers when `differential_vars`
is provided, allowing the solver to distinguish between differential and algebraic
variables.

## Parameters

- `abstol`: Absolute tolerance for the nonlinear solver (default: 1e-10)
- `nlsolve`: Custom nonlinear solver to use (optional)
"""
struct BrownFullBasicInit{T, F} <: DAEInitializationAlgorithm
    abstol::T
    nlsolve::F
end
function BrownFullBasicInit(; abstol = 1.0e-10, nlsolve = nothing)
    return BrownFullBasicInit(abstol, nlsolve)
end
BrownFullBasicInit(abstol) = BrownFullBasicInit(; abstol = abstol, nlsolve = nothing)

"""
    struct ShampineCollocationInit{T, F} <: DAEInitializationAlgorithm

The Shampine collocation initialization algorithm for DAEs. This implementation
is based on the algorithm described in:

Lawrence F. Shampine, "Consistent Initial Condition for Differential-Algebraic
Systems", SIAM Journal on Scientific Computing, Vol. 22, No. 6, pp. 2007-2026, 2001.
DOI: https://doi.org/10.1137/S1064827599355049

This method uses collocation on the first two steps to find consistent initial
conditions. It modifies both the differential and algebraic variables to satisfy
the DAE constraints. This is more general than BrownBasicInit but may be more
expensive computationally.

This method is useful when you need to modify all variables (both differential
and algebraic) to achieve consistency, rather than just the algebraic ones.

## Parameters

- `initdt`: Initial time step to use in the collocation method (optional)
- `nlsolve`: Custom nonlinear solver to use (optional)
"""
struct ShampineCollocationInit{T, F} <: DAEInitializationAlgorithm
    initdt::T
    nlsolve::F
end
function ShampineCollocationInit(; initdt = nothing, nlsolve = nothing)
    return ShampineCollocationInit(initdt, nlsolve)
end
function ShampineCollocationInit(initdt)
    return ShampineCollocationInit(; initdt = initdt, nlsolve = nothing)
end

export DefaultInit, BrownFullBasicInit, ShampineCollocationInit
